-- This information tells other players more about the mod
name = "新版百里屠苏"
description = "仙剑人物屠苏."
author = "飞熊"
version = "1.0.29"

-- This is the URL name of the mod's thread on the forum; the part after the index.php? and before the first & in the URL
-- Example:
-- http://forums.kleientertainment.com/index.php?/files/file/202-sample-mods/
-- becomes
-- /files/file/202-sample-mods/
forumthread = ""

-- This lets other players know if your mod is out of date, update it to match the current version in the game
api_version = 6

icon_atlas = "modicon.xml"
icon = "modicon.tex"

reign_of_giants_compatible = true
dont_starve_compatible = true
shipwrecked_compatible = true
hamlet_compatible = true

local op = {
            {description="TAB", data = 1119},
            {description="KP_PERIOD", data = 266},
            {description="KP_DIVIDE", data = 267},
            {description="KP_MULTIPLY", data = 268},
            {description="KP_MINUS", data = 269},
            {description="KP_PLUS", data = 270},
            {description="KP_ENTER", data = 271},
            {description="KP_EQUALS", data = 272},
            {description="MINUS", data = 45},
            {description="EQUALS", data = 61},
            {description="SPACE", data = 32},
            {description="ENTER", data = 13},
            {description="ESCAPE", data = 27},
            {description="HOME", data = 278},
            {description="INSERT", data = 277},
            {description="DELETE", data = 127},
            {description="END", data   = 279},
            {description="PAUSE", data = 19},
            {description="PRINT", data = 316},
            {description="CAPSLOCK", data = 301},
            {description="SCROLLOCK", data = 302},
            {description="RSHIFT", data = 303}, -- use SHIFT instead
            {description="LSHIFT", data = 304}, -- use SHIFT instead
            {description="RCTRL", data = 305}, -- use CTRL instead
            {description="LCTRL", data = 306}, -- use CTRL instead
            {description="RALT", data = 307}, -- use ALT instead
            {description="LALT", data = 308}, -- use ALT instead
            {description="ALT", data = 400},
            {description="CTRL", data = 401},
            {description="SHIFT", data = 402},
            {description="BACKSPACE", data = 8},
            {description="PERIOD", data = 46},
            {description="SLASH", data = 47},
            {description="LEFTBRACKET", data     = 91},
            {description="BACKSLASH", data     = 92},
            {description="RIGHTBRACKET", data = 93},
            {description="TILDE", data = 96},
            {description="A", data = 97},
            {description="B", data = 98},
            {description="C", data = 99},
            {description="D", data = 100},
            {description="E", data = 101},
            {description="F", data = 102},
            {description="G", data = 103},
            {description="H", data = 104},
            {description="I", data = 105},
            {description="J", data = 106},
            {description="K", data = 107},
            {description="L", data = 108},
            {description="M", data = 109},
            {description="N", data = 110},
            {description="O", data = 111},
            {description="P", data = 112},
            {description="Q", data = 113},
            {description="R", data = 114},
            {description="S", data = 115},
            {description="T", data = 116},
            {description="U", data = 117},
            {description="V", data = 118},
            {description="W", data = 119},
            {description="X", data = 120},
            {description="Y", data = 121},
            {description="Z", data = 122},
            {description="F1", data = 282},
            {description="F2", data = 283},
            {description="F3", data = 284},
            {description="F4", data = 285},
            {description="F5", data = 286},
            {description="F6", data = 287},
            {description="F7", data = 288},
            {description="F8", data = 289},
            {description="F9", data = 290},
            {description="F10", data = 291},
            {description="F11", data = 292},
            {description="F12", data = 293},
 
            {description="UP", data = 273},
            {description="DOWN", data = 274},
            {description="RIGHT", data = 275},
            {description="LEFT", data = 276},
            {description="PAGEUP", data = 280},
            {description="PAGEDOWN", data = 281},
 
            {description="0", data = 48},
            {description="1", data = 49},
            {description="2", data = 50},
            {description="3", data = 51},
            {description="4", data = 52},
            {description="5", data = 53},
            {description="6", data = 54},
            {description="7", data = 55},
            {description="8", data = 56},
            {description="9", data = 57},
        }
		


configuration_options =
{

    {
      name = "Initial three",
      label = "初始生命值",
      hover = "初始生命值",
      options = {
            --{description="55", data = 55},
            --{description="65", data = 65},
            --{description="75", data = 75},
            --{description="85", data = 85},
            {description="95", data = 95},
            {description="125", data = 125},
            {description="155", data = 155},
      			},
		default = 125,
    },
    {
      name = "jianghuzhuisha",
      label = "江湖追杀频率",
      hover = "江湖追杀频率",
      options = {
            --{description="测试", data = 20},
            --{description="快", data = 900},
            --{description="中", data = 1500},
            {description="该值固定", data = 4500},
      			},
		default = 4500,
    },
	
    {
      name = "jianghuzhuishajuli",
      label = "江湖追杀仇恨距离",
      hover = "江湖追杀仇恨距离",
      options = {
            {description="近", data = 80},
            {description="中", data = 100},
            {description="远", data = 120},
      			},
		default = 100,
    },

	{
      name = "player_linggen",
      label = "人物灵根",
      hover = "人物灵根",
      options = {
            {description="劣质灵根", data = 1},
            {description="普普通通", data = 5},
            {description="高等灵根", data = 8},
            {description="神级灵根", data = 10},
      			},
		default = 8,
    },
	
    {
      name = "arm_atkspeed",
      label = "敌对人物攻击频率",
      hover = "敌对人物攻击频率",
      options = {
            {description="慢", data = 3.6},
            {description="中", data = 2.4},
            {description="快", data = 1.2},
      			},
		default = 1.2,
    },
	

	
    {	
      name = "arm_rpgdamage",
      label = "敌对人物技能伤害",
      hover = "敌对人物技能伤害",
      options = {
            {description="低", data = 30},
            {description="中", data = 50},
            {description="高", data = 80},
            {description="变态", data = 100},
      			},
		default = 50,
    },
	
    {	
      name = "arm_healthup",
      label = "敌对人物生命值成长",
      hover = "敌对人物生命值成长",
      options = {
            {description="100", data = 100},
            {description="200", data = 200},
            {description="300", data = 300},
            {description="400", data = 400},
            {description="500", data = 500},
            {description="600", data = 600},
            {description="700", data = 700},
      			},
		default = 700,
    },
	
    {	
      name = "practice_speed",
      label = "修炼速度",
      hover = "修炼速度",
      options = {
            {description="正常", data = 1},
            {description="两倍", data = 2},
            {description="四倍", data = 4},
            {description="急速", data = 10},
      			},
		default = 4,
    },
	

	{
		name = "Lang",
		label = "语言",
		options =
		{
			{description = "CHINESE", data = 0},
			{description = "English", data = 1},
		},
		default = 0,
	},

	{
        name = "shijieshutrans",
        label = "传送至世界树",
        hover = "传送至世界树",
        options =op,
        default = 112,
    },

	{
        name = "xuying",
        label = "月牙-位移闪避",
        hover = "月牙-位移闪避",
        options =op,
        default = 122,
    },
	
    {
      name = "xuying_direction",
      label = "月牙的闪避方向",
      hover = "月牙的闪避方向",
      options = {
            {description="人物面对的方向", data = 1},
            {description="鼠标方向", data = 0},

      			},
		default = 0,
    },
	
    {
      name = "aiwuxiankanshu",
      label = "爱无线是否破坏植物",
      hover = "爱无线是否破坏植物",
      options = {
            {description="是", data = 1},
            {description="否", data = 0},

      			},
		default = 1,
    },
	
	{
        name = "jineng",
        label = "释放当前技能",
        hover = "释放当前技能",
        options =op,
        default = 114,
    },
	
	{
        name = "zhaohuanshanggu",
        label = "唤出上古神剑",
        hover = "唤出上古神剑",
        options =op,
        default = 118,
    },
	
	{
        name = "xiulian",
        label = "修炼",
        hover = "修炼",
        options =op,
        default = 116,
    },

	{
        name = "shuxing",
        label = "属性查看",
        hover = "属性查看",
        options =op,
        default = 108,
    },
	
	--[[
	
	{
      name = "arm_armor",
      label = "敌对人物护甲",
      hover = "敌对人物护甲",
      options = {
            {description="低", data = 0.7},
            {description="中", data = 0.8},
            {description="高", data = 0.9},
            {description="巨型刮痧", data = 0.95},
      			},
		default = 0.9,
    },
	
    {
        name = "commandaxiang",
        label = "阿翔战斗/回避",
        hover = "阿翔战斗/回避",
        options =op,
        default = 118,
    },

    {
      name = "ssword_Hunger",
      label = "饥饿速率",
      hover = "饥饿速率",
      options = {
            --{description="0.60", data = 0.60},
            --{description="0.80", data = 0.80},
            {description="1.00", data = 1.00},
            --{description="1.20", data = 1.20},
            --{description="1.40", data = 1.40},
            --{description="1.60", data = 1.60},
            --{description="1.80", data = 1.80},
      			},
		default = 1.00,
    },
	
	{
        name = "upyujian",
        label = "御剑起飞",
        hover = "御剑起飞",
        options =op,
        default = 273,
    },
	{
        name = "downyujian",
        label = "御剑降落",
        hover = "御剑降落",
        options =op,
        default = 274,
    },
	{
        name = "fenjijianyu",
        label = "FENJIJIANYU",
        hover = "FENJIJIANYU",
        options =op,
        default = 53,
    },
	{
        name = "shuangman",
        label = "SHUANGMAN",
        hover = "SHUANGMAN",
        options =op,
        default = 54,
    },
	{
		name = "quickwork",
		label = "快速采集",
		options =
		{
			{description = "on", data = 1},
			{description = "off", data = 0},
		},
		default = 0,
	},
	]]


    {
        name = "difficult",
        label = "生物加强",
        --hover = "难度选择",
        options =
        {
            --{description = "正常", data = "1"},
            --{description = "3倍血量攻击", data = "3"},
            --{description = "5倍血量攻击", data = "5"},
            {description = "7倍血量攻击", data = "7"},
        },
        default = "7",
    },
	

        }