--Need to make this enemy much less player focused.
--Doesn't target player by default.
    --Only if hit or if sharkittens threatened.

local assets =
{
	Asset("ANIM", "anim/tigershark_build.zip"),
    Asset("ANIM", "anim/tigershark_ground_build.zip"),
	Asset("ANIM", "anim/tigershark_ground.zip"),
    Asset("ANIM", "anim/tigershark_water_build.zip"),
	Asset("ANIM", "anim/tigershark_water.zip"),
    --Asset("ANIM", "anim/tigershark.zip"),
	Asset("ANIM", "anim/tigershark_water_ripples_build.zip"),
}

local prefabs =
{
	"tigersharkshadow",
    "splash_water_big",
    "groundpound_fx",
    "groundpoundring_fx",
    "mysterymeat",
    "fish_raw",
    "tigereye",
    "shark_gills",
}

SetSharedLootTable('tigershark',
{
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},
    {"fish_raw", 1.00},

    {"tigereye", 1.00},
    {"tigereye", 0.50},

    {"shark_gills", 1.00},
    {"shark_gills", 1.00},
    {"shark_gills", 0.33},
    {"shark_gills", 0.10},
})

local TARGET_DIST = 20
local HEALTH_THRESHOLD = 0.1
local HOME_PROTECTION_DISTANCE = 60

local brain = require "brains/boss_tigersharkbrain"

local function on_close(inst)
inst.tigershark_lingyu = inst:DoPeriodicTask(15, function()
--if inst:GetDistanceSqToInst(player) < 30 then
    --inst.sg:GoToState("taunt")
	inst.AnimState:PlayAnimation("taunt")
--end
inst:DoTaskInTime(1.5, function() 
			local player = GetPlayer()  
if not player.components.driver.vehicle then
    --混乱
	if not player.taskp then
			local x, y, z = player.Transform:GetWorldPosition()
	        local fx = SpawnPrefab("explode_small")
	        fx.Transform:SetPosition(x, y, z)
		--if target.brain then target.brain:Stop() end
		--if target.components.combat then target.components.combat:SetTarget(nil) end
		    player.components.talker:Say("哇，我被恐惧啦")
			player.components.playercontroller:Enable(false)
            --inst.components.locomotor:StopMoving()
	player.taskp = player:DoPeriodicTask(0.75, function() player.components.locomotor:RunInDirection(math.random()*360) end)
	player:DoTaskInTime(3, function()
		if player and player.taskp and not player.components.health:IsDead() then
			player.taskp:Cancel()
			player.taskp = nil
			player.components.playercontroller:Enable(true)
			--player.components.combat:SetTarget(attacker)
			--if target.brain then target.brain:Start() end
		end
	end)
	end
end

end)


end)

end 

local function far(inst)

		if inst and inst.tigershark_lingyu then inst.tigershark_lingyu:Cancel() inst.tigershark_lingyu = nil end


end
local function assasin_hunt(inst)
    --local dist = 40
    return FindEntity(inst, TUNING.ZHUISHAJULI, function(guy)
            return ( guy:HasTag("player") or guy:HasTag("yamche"))
			and not guy:HasTag("toso_arm")
			 and guy.components.health
                and not guy.components.health:IsDead()
                and inst.components.combat:CanTarget(guy)
        end)
		end

local function Onhunt(inst, target)
    return inst.components.combat:CanTarget(target) and not target:HasTag("toso_arm")
end

local function ShouldSleep(inst)
    return false
end

local function ShouldWake(inst)
    return true
end

local function GetTarget(inst)
    --Used for logic of moving between land and water states
    local target = inst.components.combat.target and inst.components.combat.target:GetPosition()

    if not target and inst:GetBufferedAction() then
        target = (inst:GetBufferedAction().target and inst:GetBufferedAction().target:GetPosition()) or inst:GetBufferedAction().pos
    end

    --Returns a position
    return target
end

local function GroundTypesMatch(inst, target)
    local target = target or GetTarget(inst)

    if target then
        if target.prefab then
            return inst:HasTag("aquatic") == target:HasTag("aquatic")
        elseif target.x and target.y and target.z then
            local tar_tile = GetMap():GetTileAtPoint(target:Get())
            return WorldSim:IsWater(tar_tile) == inst:GetIsOnWater()
        end
    end

    return true
end

local function FindSharkHome(inst)
    if not inst.sharkHome then
        if GetWorld().components.tigersharker and GetWorld().components.tigersharker.shark_home then
            inst.sharkHome = GetWorld().components.tigersharker.shark_home
        else
            inst.sharkHome = GetClosestInstWithTag("sharkhome", inst, 10000)
        end
    end
    return inst.sharkHome
end

local function OnAttacked(inst, data)
    inst.components.combat:SetTarget(data.attacker)
end

local function RetargetFn(inst)
    local home = FindSharkHome(inst)

    if home and home:GetPosition():Dist(inst:GetPosition()) < HOME_PROTECTION_DISTANCE then
        --Aggressive to the player if close to home
        return FindEntity(inst, TARGET_DIST, 
            function(tar) return inst.components.combat:CanTarget(tar) end, nil, 
            {"prey", "smallcreature", "bird", "butterfly", "sharkitten"})
    elseif inst.components.health:GetPercent() > HEALTH_THRESHOLD then
        --Not aggressive to the player if far from home
        return FindEntity(inst, TARGET_DIST, 
            function(tar) return inst.components.combat:CanTarget(tar) end, nil,
            {"prey", "smallcreature", "bird", "butterfly", "sharkitten", "player", "companion"})
    end
end

local function KeepTargetFn(inst, target)
    --If this thing is close to my kittens keep target no matter what.
    local home = FindSharkHome(inst)
    if inst.components.health:GetPercent() < HEALTH_THRESHOLD and home and home:GetPosition():Dist(inst:GetPosition()) > HOME_PROTECTION_DISTANCE then
        --If I'm low health & not protecting my home, flee.
        return false
    else
        return inst.components.combat:CanTarget(target)
    end
end

local function ontimerdone(inst, data)
    if data.name == "Run" then
        inst.CanRun = true
    end
end

local function MakeWater(inst)
    inst:ClearStateGraph()
    inst:SetStateGraph("SGboss_tigershark_water")
    inst.AnimState:SetBuild("tigershark_water_build")
    inst.AnimState:AddOverrideBuild("tigershark_water_ripples_build")
    inst:AddTag("aquatic")
    inst.DynamicShadow:Enable(false)
end

local function MakeGround(inst)
    inst:ClearStateGraph()
    inst:SetStateGraph("SGboss_tigershark_ground")
    inst.AnimState:SetBuild("tigershark_ground_build")
    inst:RemoveTag("aquatic")
    inst.DynamicShadow:Enable(true)
end

local function OnSave(inst, data)
    data.CanRun = inst.CanRun
    data.NextFeedTime = GetTime() - inst.NextFeedTime
end

local function OnLoad(inst, data)
    if data then
        inst.CanRun = data.CanRun or true
        inst.NextFeedTime = data.NextFeedTime or 0
    end
end

local function CanBeAttacked(inst, attacker)
    return not inst.sg:HasStateTag("specialattack")
end

local function fn()

	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddDynamicShadow()
    inst.Transform:SetFourFaced()
    inst.DynamicShadow:SetSize( 6, 3 )
    inst.DynamicShadow:Enable(false)

    inst:AddTag("aquatic")
    inst:AddTag("scarytoprey")
    inst:AddTag("tigershark")
    inst:AddTag("largecreature")
    inst:AddTag("epic")
    inst:AddTag("seacreature")
	--所有敌对人形怪
	inst:AddTag("groundpoundimmune")
	inst:AddTag("toso_arm")
    inst:AddTag("toso_armboss")	

    MakePoisonableCharacter(inst)
    MakeCharacterPhysics(inst, 0, 1.33)
local player = GetPlayer()  

	inst:AddComponent("locomotor")
	inst.components.locomotor.walkspeed = 20
	inst.components.locomotor.runspeed = 30

    inst:AddComponent("rowboatwakespawner")

    inst.AnimState:SetBank("tigershark")
    inst.AnimState:SetBuild("tigershark_water_build")
    inst.AnimState:PlayAnimation("water_run", true)
    inst.AnimState:SetRayTestOnBB(true)
    inst.AnimState:AddOverrideBuild("tigershark_water_ripples_build")

    inst:AddComponent("inspectable")
    inst.no_wet_prefix = true

	inst:AddComponent("knownlocations")

    inst:AddComponent("health")
		--生命护甲数值
	inst.components.health:SetMaxHealth(240000+player.level*TUNING.ARM_HEALTHUP)
    inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)

    inst:AddComponent("eater")
    inst.components.eater.foodprefs = { "MEAT" }
    inst.components.eater.ablefoods = { "MEAT", "VEGGIE", "GENERIC" }

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('tigershark')

    inst:AddComponent("groundpounder")
    inst.components.groundpounder.destroyer = true
    inst.components.groundpounder.damageRings = 3
    inst.components.groundpounder.destructionRings = 1
    inst.components.groundpounder.numRings = 3
    inst.components.groundpounder.noTags = {"sharkitten"}

    inst:AddComponent("combat")
	--攻速攻击力数值
	 inst.components.combat:SetDefaultDamage(400+player.level*20)

    inst.components.combat:SetRange(TUNING.TIGERSHARK_ATTACK_RANGE, TUNING.TIGERSHARK_ATTACK_RANGE)
    inst.components.combat:SetAreaDamage(TUNING.TIGERSHARK_SPLASH_RADIUS, TUNING.TIGERSHARK_SPLASH_DAMAGE/TUNING.TIGERSHARK_DAMAGE)
	
	inst.components.combat:SetAttackPeriod(TUNING.ARM_ATKSPEED*0.5)---min_attack_period
	
    inst.components.combat:SetRetargetFunction(0, assasin_hunt)
	inst.components.combat:SetKeepTargetFunction(Onhunt)
    inst.components.combat:SetHurtSound("dontstarve_DLC001/creatures/bearger/hurt")
    inst.components.combat.canbeattackedfn = CanBeAttacked
    inst.components.combat.notags = {"sharkitten"}
	--成长护甲
	inst.task_always = inst:DoPeriodicTask(2, function()
	local player = GetPlayer()


	
if player.level > 10 and player.level <= 20 then
inst.components.health:SetAbsorptionAmount(0.91)
elseif player.level > 20 and player.level <= 30 then
inst.components.health:SetAbsorptionAmount(0.92)	
elseif player.level > 30 and player.level <= 40 then
inst.components.health:SetAbsorptionAmount(0.93)
elseif player.level > 40 and player.level <= 50 then
inst.components.health:SetAbsorptionAmount(0.94)
elseif player.level > 50 and player.level <= 60 then
inst.components.health:SetAbsorptionAmount(0.95)
elseif player.level > 60 and player.level <= 70 then
inst.components.health:SetAbsorptionAmount(0.96)
elseif player.level > 70 and player.level <= 80 then
inst.components.health:SetAbsorptionAmount(0.97)
elseif player.level > 80 and player.level <= 90 then
inst.components.health:SetAbsorptionAmount(0.98)
elseif player.level > 90 then
inst.components.health:SetAbsorptionAmount(0.99)
else
inst.components.health:SetAbsorptionAmount(TUNING.ARM_ARMOR)
end	
	
	end)
    --领域
    inst:AddComponent("playerprox")
    inst.components.playerprox:SetDist(30, 30)
    inst.components.playerprox:SetOnPlayerNear(on_close)
    inst.components.playerprox:SetOnPlayerFar(far)

    --inst:AddComponent("sleeper")
    --inst.components.sleeper:SetResistance(4)
    --inst.components.sleeper:SetSleepTest(ShouldSleep)
    --inst.components.sleeper:SetWakeTest(ShouldWake)

    inst:ListenForEvent("killed", function(inst, data)
        if inst.components.combat and data and data.victim == inst.components.combat.target then
            inst.components.combat.target = nil
        end
    end)

    inst.CanRun = true --Can do charge attack

    inst.CanFly = false --Can do leap attack

    --[[
        - While in water, tigershark jumps every third attack.
        - While on ground, tigershark *can* jump after every third attack, but will
            only jump to close distance.

        This logic is controlled through the tigershark's stategraphs.
    --]]

    inst.AttackCounter = 0
    inst.NextFeedTime = 0
    inst.OnSave = OnSave
    inst.OnLoad = OnLoad
    inst.GroundTypesMatch = GroundTypesMatch
    inst.FindSharkHome = FindSharkHome
    inst.GetTarget = GetTarget
    inst.MakeGround = MakeGround
    inst.MakeWater = MakeWater

    inst:SetStateGraph("SGboss_tigershark_water")
    inst:SetBrain(brain)

    inst:AddComponent("timer")
    inst:ListenForEvent("timerdone", ontimerdone)
    inst:ListenForEvent("attacked", OnAttacked)

    inst:DoTaskInTime(1*FRAMES, function()
        if inst:GetIsOnWater() then
            MakeWater(inst)
            inst.sg:GoToState("idle")
        else
            MakeGround(inst)
            inst.sg:GoToState("idle")
        end
    end)

	return inst
end

return Prefab( "ocean/objects/boss_tigershark", fn, assets, prefabs)