local assets=
{
	--Asset("ANIM", "anim/prj_huan.zip"),
	Asset("SOUND", "sound/chess.fsb"),
}

local function OnHit(inst, owner, target)
    inst:Remove()
    --inst.SoundEmitter:PlaySound("dontstarve/creatures/bishop/shotexplo")
		inst.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.Transform:SetFourFaced()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank("blow_dart")
    anim:SetBuild("blow_dart")
    anim:PushAnimation("dart_pipe")
	--inst.Transform:SetPosition(0, 1.4, 0)
    trans:SetScale(1, 1.45, 1)
    
    inst:AddTag("projectile")
    inst.persists = false
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(30)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(2)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnHit)
    
    return inst
end

return Prefab( "common/inventory/prj_gongjian", fn, assets) 
