require "prefabutil"

local prefabs =
{
	"rowboat_wake",
	"boat_hit_fx",
	"boat_hit_fx_raft_log",
	"boat_hit_fx_raft_bamboo",
	"boat_hit_fx_rowboat",
	"boat_hit_fx_cargoboat",
	"boat_hit_fx_armoured",
	"flotsam_armoured",
	"flotsam_bamboo",
	"flotsam_cargo",
	"flotsam_lograft",
	"flotsam_rowboat",
	"flotsam_surfboard",
}

local assets =
{
	--自己改的
    Asset("ANIM", "anim/weapon/sword_3.zip"),
    Asset("ANIM", "anim/weapon/swap_sword_3.zip"),
	Asset("ANIM", "anim/boat/toso_sword_fly.zip"),
	Asset("ANIM", "anim/xuanyuan.zip"),
	
	
	--Asset("ANIM", "anim/raft_surfboard_build.zip"),
	--Asset("ANIM", "anim/boat_hud_raft.zip"), 
	Asset("ANIM", "anim/boat_inspect_raft.zip"), 
	--Asset("ANIM", "anim/ryondae.zip"),
	--Asset("ANIM", "anim/flotsam_ryondae_build.zip"),
	Asset("IMAGE","images/inventoryimages/sword_3.tex"),
	Asset("ATLAS","images/inventoryimages/sword_3.xml")

}

local function on_close(inst)
local player = GetPlayer()



end 

local function far(inst)
local player = GetPlayer()
if not player.components.driver.vehicle then


inst:Remove()
player.components.inventory:GiveItem(SpawnPrefab("surfboard_item_toso"))

end
	
end

---------YELLOW STAFF-------------

local function cancreatejianling(staff, caster, target, pos)
    local ground = GetWorld()
    if ground and pos then
        local tile = ground.Map:GetTileAtPoint(pos.x, pos.y, pos.z)
        return tile ~= GROUND.IMPASSIBLE and tile < GROUND.UNDERGROUND
    end
    return false
end

local function createjianling(staff, target, pos)
    local light = SpawnPrefab("jianling")
    light.Transform:SetPosition(pos.x, pos.y, pos.z)
    staff:Remove()

    local caster = staff.components.inventoryitem.owner
    if caster and caster.components.sanity then
        caster.components.sanity:DoDelta(-20)
    end

end

--攻击特效
local function onattack_sword5( inst, attacker, target )





	local x, y, z = target.Transform:GetWorldPosition()
	local fx = SpawnPrefab("moose_nest_fx")	
	fx.Transform:SetPosition(x, y, z)
	--target.components.health:DoDelta(- 5 - attacker.level)
	if target and target.components.health and not target.components.health:IsDead() then
	


	target.components.combat:GetAttacked(attacker, 2+2*attacker.level)
	
	

	
	end
	
	
    --减防御

	if target and not target:HasTag("wall") and not target.components.health:IsDead() and target.components.health.fa_resistances and target.components.health.fa_resistances[FA_DAMAGETYPE.PHYSICAL] then
		if not target:HasTag("armorbreakdark") then
			target:AddTag("armorbreakdark")
			local oldabsorb2 = target.components.health.fa_resistances[FA_DAMAGETYPE.PHYSICAL]
			target.components.health.fa_resistances[FA_DAMAGETYPE.PHYSICAL] = oldabsorb2-0.6
			if target.components.health.fa_resistances[FA_DAMAGETYPE.PHYSICAL] <= 0 then target.components.health.fa_resistances[FA_DAMAGETYPE.PHYSICAL] = 0 end
			target:DoTaskInTime(5, function() target.components.health.fa_resistances[FA_DAMAGETYPE.PHYSICAL] = oldabsorb2 target:RemoveTag("armorbreakdark") end)
		end
	end
	
end
--在剑上
local function onboataa(inst)

	if inst.components.drivable.driver and GetPlayer().components.sswordcast then

	else
	
	inst:Remove()
	end

end



local function AutoEquipItem(playercontroller, bufferedaction)
	if not bufferedaction then return end
	if not bufferedaction.invobject then return end
	if not playercontroller.autoequip_lastequipped then
		playercontroller.autoequip_lastequipped = playercontroller.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	end
	playercontroller.inst.components.locomotor:PushAction(BufferedAction(playercontroller.inst, nil, ACTIONS.EQUIP, bufferedaction.invobject), true)
    -- playercontroller.inst.components.inventory:Equip(bufferedaction.invobject)
end



local function OnDropped(inst)
    inst.AnimState:PlayAnimation("idle")
end


local function OnThrown(inst, owner, target, playercontroller)
	inst.components.projectile:SetSpeed(25)
	local weapons = owner.components.inventory:FindItems(function(item)
			return item.components.weapon
		end)
	if weapons then
		for k,v in pairs(weapons) do
			if v and v.prefab == "surfboard_item_toso" then
			--c_give("oinc",100)
			--playercontroller.owner.components.locomotor:PushAction(BufferedAction(playercontroller.inst, nil, ACTIONS.EQUIP, v), true)
			owner.components.inventory:Equip(v)
			end
            	end
        end	
    --移动速度 (可选)
	owner.components.locomotor.walkspeed = (owner.components.locomotor.walkspeed+0.25*TUNING.WILSON_WALK_SPEED)
    --跑步速度
	owner.components.locomotor.runspeed = (owner.components.locomotor.runspeed+0.25*TUNING.WILSON_RUN_SPEED)
    if target ~= owner then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
    end
    inst.AnimState:PlayAnimation("spin_loop", true)
end

local function OnCaught(inst, catcher)
    --移动速度 (可选)
	catcher.components.locomotor.walkspeed = (catcher.components.locomotor.walkspeed-0.5*TUNING.WILSON_WALK_SPEED)
    --跑步速度
	catcher.components.locomotor.runspeed = (catcher.components.locomotor.runspeed-0.5*TUNING.WILSON_RUN_SPEED)
    if catcher then
        if catcher.components.inventory then
            if inst.components.equippable and not catcher.components.inventory:GetEquippedItem(inst.components.equippable.equipslot) then
				catcher.components.inventory:Equip(inst)
			else
                catcher.components.inventory:GiveItem(inst)
            end
            catcher:PushEvent("catch")
        end
    end
end

local function ReturnToOwner(inst, owner)
    if owner and not (inst.components.finiteuses and inst.components.finiteuses:GetUses() < 1) then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_return")
        inst.components.projectile:Throw(owner, owner)
    end
end

local function OnHit(inst, owner, target,data)
    if owner == target then
	--移动速度 (可选)
	owner.components.locomotor.walkspeed = (owner.components.locomotor.walkspeed-0.5*TUNING.WILSON_WALK_SPEED)
    --跑步速度
	owner.components.locomotor.runspeed = (owner.components.locomotor.runspeed-0.5*TUNING.WILSON_RUN_SPEED)
        OnDropped(inst)
    else
	if not target:HasTag("prey") 
		and not target:HasTag("veggie") 
		and not target:HasTag("structure")
		and not target:HasTag("wall") then
		--if FLYINGAXE_HEALTH_STEALING then
			--owner.components.health:DoDelta(1)
		--end
	end
	inst.components.projectile:SetSpeed(15)   
        ReturnToOwner(inst, owner)
    end
    local impactfx = SpawnPrefab("impact")
    if impactfx then
	    local follower = impactfx.entity:AddFollower()
	    follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
        impactfx:FacePoint(Vector3(inst.Transform:GetWorldPosition()))
    end
end


local function ondeploy(inst, pt, deployer)
	local board = inst.components.pocket:RemoveItem("toso_surfboard") or SpawnPrefab("toso_surfboard") 
	if board then
	--之前是0
		pt = Vector3(pt.x, 0, pt.z)
		board.Physics:SetCollides(false)--设置碰撞
		board.Physics:Teleport(pt.x, pt.y, pt.z) 
		board.Physics:SetCollides(true)--设置碰撞
		inst:Remove()
		return board
	end
end

--开关
local function unfoldit(inst)

local owner = inst.components.inventoryitem.owner
	if inst.isunfolded then
	--inst.components.talker:Say("近战模式!")
			--owner:PushEvent("unequip", {item=inst, eslot=EQUIPSLOTS.HANDS})
		--owner:PushEvent("equip", {item=inst, eslot=EQUIPSLOTS.HANDS})
		--owner.SoundEmitter:PlaySound("dontstarve/wilson/use_umbrella_down")
    inst.components.weapon:SetDamage(51*TUNING.DIFFICULTY)
    inst.components.weapon:SetRange(0.8)
    inst.components.weapon:SetOnAttack(onattack_sword5)
    if inst.components.projectile then
    inst:RemoveComponent("projectile")
	end
	--inst:AddComponent("deployable")
	--inst.components.deployable.ondeploy = ondeploy
	--inst.components.deployable.placer = "surfboard_placer"
	--inst.components.deployable.deploydistance = 2	
	
	--inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(15, 15)
    --inst.components.playerprox:SetOnPlayerNear(on_close)
    --inst.components.playerprox:SetOnPlayerFar(far)

	
		inst.isunfolded = false
	else
	--inst.components.talker:Say("远程模式!")
        --owner:PushEvent("unequip", {item=inst, eslot=EQUIPSLOTS.HANDS})
		--owner:PushEvent("equip", {item=inst, eslot=EQUIPSLOTS.HANDS})
		--owner.SoundEmitter:PlaySound("dontstarve/wilson/use_umbrella_up") 
    inst.components.weapon:SetDamage(26*TUNING.DIFFICULTY)
    inst.components.weapon:SetRange(13, 15)
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(25)
    inst.components.projectile:SetCanCatch(true)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(ReturnToOwner)
    inst.components.projectile:SetOnCaughtFn(OnCaught)
 
    --if inst.components.deployable then
    --inst:RemoveComponent("deployable")
	--end	
	
local oldhit = inst.components.projectile.Hit
	
function inst.components.projectile:Hit(target)
		
	if target == self.owner and target.components.catcher then

			target:PushEvent("catch", {projectile = self.inst})
 
			self.inst:PushEvent("caught", {catcher = target})

			self:Catch(target)

			target.components.catcher:StopWatching(self.inst)

		else
			
			oldhit(self, target)
		
	end

end
	
		inst.isunfolded = true
	end
	
	--inst.components.useableitem.inuse = false
end

--加入装备函数
local function onequip(inst, owner)
    inst.components.weapon:SetDamage(51*TUNING.DIFFICULTY)
    inst.components.weapon:SetRange(0.8)
    inst.components.weapon:SetOnAttack(onattack_sword5)
    if inst.components.projectile then
    inst:RemoveComponent("projectile")
	end
	--inst:AddComponent("deployable")
	--inst.components.deployable.ondeploy = ondeploy
	--inst.components.deployable.placer = "surfboard_placer"
	--inst.components.deployable.deploydistance = 2	
	
	--inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(15, 15)
    --inst.components.playerprox:SetOnPlayerNear(on_close)
    --inst.components.playerprox:SetOnPlayerFar(far)

	
		inst.isunfolded = false


    owner.AnimState:OverrideSymbol("swap_object", "swap_sword_3", "swap_sword_3")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
		inst.isunfolded = false

	--inst.components.weapon:SetRange(0, 0)
	--inst.components.useableitem.inuse = false
	inst.ownerWalkSpeed=owner.components.locomotor.walkspeed
	inst.ownerRunSpeed=owner.components.locomotor.runspeed	
end

local function onunequip(inst, owner)

    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
	inst.isunfolded = false

end



local function boat_perish(inst)
	--if inst.components.drivable.driver and GetPlayer():GetIsOnWater() and GetPlayer().components.yiyucast then
    --inst.Physics:SetMotorVelOverride(0, 10, 0)
	--end
	if inst.components.drivable.driver and GetPlayer():GetIsOnWater() and GetPlayer().components.tosocast then
		local driver = inst.components.drivable.driver
		--driver.Physics:SetMotorVelOverride(0, 0, -10)
        --driver.components.talker:Say("什么鬼")
		driver.components.driver:OnDismount(true)
		local reborn = SpawnPrefab("amulet")
		GetPlayer().components.inventory:GiveItem(reborn)
		GetPlayer().components.inventory:Equip(reborn)
		driver.components.health:Kill("drowning")
		inst.SoundEmitter:PlaySound(inst.sinksound)
		--inst:Remove()
	elseif inst.components.drivable.driver and not GetPlayer():GetIsOnWater() and GetPlayer().components.tosocast then
		local driver = inst.components.drivable.driver
        --driver.components.talker:Say("什么鬼lllll")
		--driver.Physics:SetMotorVelOverride(0, 0, 10)
		driver.components.driver:OnDismount(true)
		--inst:Remove()
	end
end

local function onmounted(inst)
end

local function ondismounted(inst)
end 

local function onopen(inst)
	if inst.components.drivable.driver == nil then
		inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/HUD_boat_inventory_open")
	end
end

local function onclose(inst)
	if inst.components.drivable.driver == nil then
		inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/HUD_boat_inventory_close")
	end
end

local function setupcontainer(inst, slots, bank, build, inspectslots, inspectbank, inspectbuild, inspectboatbadgepos, inspectboatequiproot)
	inst:AddComponent("container")
	inst.components.container:SetNumSlots(#slots)
	inst.components.container.type = "boat"
	inst.components.container.side_align_tip = -500
	inst.components.container.canbeopened = false
	inst.components.container.onopenfn = onopen
	inst.components.container.onclosefn = onclose

	inst.components.container.widgetslotpos = slots
	inst.components.container.widgetanimbank = bank
	inst.components.container.widgetanimbuild = build
	inst.components.container.widgetboatbadgepos = Vector3(0, 40, 0)
	inst.components.container.widgetequipslotroot = Vector3(-80, 40, 0)

	local boatwidgetinfo = {}
	boatwidgetinfo.widgetslotpos = inspectslots
	boatwidgetinfo.widgetanimbank = inspectbank
	boatwidgetinfo.widgetanimbuild = inspectbuild
	boatwidgetinfo.widgetboatbadgepos = inspectboatbadgepos
	boatwidgetinfo.widgetpos = Vector3(200, 0, 0)
	boatwidgetinfo.widgetequipslotroot = inspectboatequiproot
	inst.components.container.boatwidgetinfo = boatwidgetinfo
end

local function commonfn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	trans:SetFourFaced()
	inst.no_wet_prefix = true 

	inst:AddTag("boat")

	local anim = inst.entity:AddAnimState()	
	inst.entity:AddSoundEmitter()

	inst.entity:AddPhysics()
	--ceshi

	inst.Physics:SetCylinder(0.25,2)

	inst:AddComponent("inspectable")
	inst:AddComponent("drivable")

	inst:AddComponent("rowboatwakespawner")
	inst:AddComponent("boathealth")
	inst.components.boathealth:SetDepletedFn(boat_perish)

    inst:AddComponent("repairable")
    inst.components.repairable.repairmaterial = "boat"

	return inst
end

local function deploytest(inst, pt)
	local ground = GetWorld()
	local tile = GROUND.GRASS
	if ground and ground.Map then
		tile = ground.Map:GetTileAtPoint(pt:Get())
	end
	local onWater = ground.Map:IsWater(tile)
	return onWater
end

local function surfboard_ondropped(inst)
	--If this is a valid place to be deployed, auto deploy yourself.
	if inst.components.deployable and inst.components.deployable:CanDeploy(inst:GetPosition()) then
		inst.components.deployable:Deploy(inst:GetPosition(), inst)
	end
end

local function pickupfn(inst, guy)
	local board = SpawnPrefab("surfboard_item_toso")
	guy.components.inventory:GiveItem(board)
	board.components.pocket:GiveItem("toso_surfboard", inst)
	return true
end



local function surfboardfn(sim)

	local inst = commonfn(sim)
	setupcontainer(inst, {}, "boat_hud_raft", "boat_hud_raft", {}, "boat_inspect_raft", "boat_inspect_raft", {x=0,y=5}, {})--设置容积

	inst:AddTag("weiyijian")

	inst.AnimState:SetBank("toso_sword_fly")
	inst.AnimState:SetBuild("toso_sword_fly")
	inst.AnimState:PlayAnimation("run_loop", true)
    --inst.Transform:SetPosition(0, 10, 0)
	

	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "sword_3.tex" )

	inst.components.boathealth.maxhealth = 460
	inst.components.boathealth:SetHealth(460, TUNING.ARMOUREDBOAT_PERISHTIME)
    inst.components.boathealth.damagesound = "dontstarve_DLC002/common/surfboard_damage"
	
	inst.landsound = "dontstarve_DLC002/common/boatjump_land_wood"--着陆声音
	inst.sinksound = "dontstarve_DLC002/common/boat_sinking_log_cargo"--沉船声音
	inst.sailsound = "common/surfboard_sail_LP"--航行声音
	inst.sailmusic = "surfing"	--航行音乐
	
	inst.components.drivable.sanitydrain = 0
	inst.components.drivable.runspeed = 6
	inst.components.drivable.maprevealbonus = 8
	inst.components.drivable.hitfx = "boat_hit_fx_armoured"
	inst.components.drivable.runanimation = "row_loop"
	inst.components.drivable.prerunanimation = "row_pre"
	inst.components.drivable.postrunanimation = "row_pst"
	inst.components.drivable.overridebuild = "toso_sword_fly"
	inst.components.drivable.flotsambuild = "flotsam_ryondae_build"
	inst.components.drivable.creaksound = "dontstarve_DLC002/common/boat_creaks"
	inst.components.drivable.alwayssail = true
	inst.waveboost = TUNING.SURFBOARD_WAVEBOOST
	inst.wavesanityboost = TUNING.SURFBOARD_WAVESANITYBOOST

	inst:AddComponent("characterspecific")
    inst.components.characterspecific:SetOwner("ssword")
	
    --inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(15, 15)
    --inst.components.playerprox:SetOnPlayerNear(on_close)
    --inst.components.playerprox:SetOnPlayerFar(far)
	
	--加回复
inst.task_reply = inst:DoPeriodicTask(10, function()
if inst.components.boathealth.currenthealth < inst.components.boathealth.maxhealth then
inst.components.boathealth.currenthealth = inst.components.boathealth.currenthealth + 1
end

end)

	--[[
TheInput:AddKeyUpHandler(KEY_UP, function()

    if not IsPaused() then

		local driver = inst.components.drivable.driver
		if driver then
		driver.Physics:SetMotorVelOverride(0, 5, 0)
		end

	end	


end)

TheInput:AddKeyUpHandler(KEY_DOWN, function()

    if not IsPaused() then

		local driver = inst.components.drivable.driver
		if driver then
		--driver.Physics:ClearMotorVelOverride()
		driver.Physics:SetMotorVelOverride(0, -5, 0)
		end
	end	


end)
]]
    --无人驾驶自动消失
	--inst.task_disappear = inst:DoPeriodicTask(5, function()
	--onboataa(inst)
	--end)

	
	inst:AddComponent("pickupable")
	inst.components.pickupable:SetOnPickupFn(pickupfn)
	inst:SetInherentSceneAltAction(ACTIONS.RETRIEVE)
	local olddrive = inst.components.drivable.OnUpdate
	inst.components.drivable.OnUpdate= function(dt)
    if inst:HasTag("boat") then
        local tile = inst:GetCurrentTileType()
        if tile and not GetMap():IsWater(tile) and inst.prefab ~= "toso_surfboard" then
            if self.driver then
                self.driver.components.driver:OnDismount(nil, inst:GetPosition())
            end
            inst:onhammered(inst)
        end

    end
end
	return inst
end 


--照明
local function applylight(inst)


       if GetClock():IsDay() then
				inst.Light:Enable(false)


 	   elseif GetClock():IsDusk() then
	   	   if inst.yuansu_guang then
				inst.Light:Enable(true)
				inst.Light:SetRadius(1)
    			inst.Light:SetFalloff(1)
    			inst.Light:SetIntensity(0.3)
    			inst.Light:SetColour(128/255,128/255,255/255)

           end
       elseif GetClock():IsNight() then
	       if inst.yuansu_guang then
				inst.Light:Enable(true)
				inst.Light:SetRadius(3)
    			inst.Light:SetFalloff(1)
    			inst.Light:SetIntensity(0.5)
    			inst.Light:SetColour(128/255,128/255,255/255)

	       end
	   end	

end


local function item_set(inst)


if GetClock():IsNight() then
--inst.equipfnt(inst, inst.items["TORCH"])
inst.Light:Enable(true)
elseif not GetClock():IsNight() then
inst.Light:Enable(false)
end
end

local function getspawnlocation(inst, target)
	local tarPos = target:GetPosition()
	local pos = inst:GetPosition()
	local vec = tarPos - pos
	vec = vec:Normalize()
	local dist = pos:Dist(tarPos)
	return pos + (vec * (dist * .15))
end

local function cantornado(staff, caster, target, pos)
    return target and (
        target.components.health and target.components.combat and caster.components.combat:CanTarget(target)
        --or target.components.workable
        )
end

local function spawntornado(staff, target, pos)
local player = GetPlayer()

    staff.components.weapon:SetDamage(26*TUNING.DIFFICULTY)
    staff.components.weapon:SetRange(13, 15)
    staff:AddComponent("projectile")
    staff.components.projectile:SetSpeed(25)
    staff.components.projectile:SetCanCatch(true)
    staff.components.projectile:SetOnThrownFn(OnThrown)
    staff.components.projectile:SetOnHitFn(OnHit)
    staff.components.projectile:SetOnMissFn(ReturnToOwner)
    staff.components.projectile:SetOnCaughtFn(OnCaught)

        local weapon = player.components.combat:GetWeapon()
        --print(weapon)
        local damage = 20
        --四次斩击伤害
        target.components.combat:GetAttacked(player,damage,weapon)



end

local function surfboarditemfn(Sim)

	local inst = CreateEntity()



	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	


	inst:AddTag("boat")
	--加入剑属性标签
    inst:AddTag("sharp")
    inst:AddTag("anjianzhaohuan")
    inst:AddTag("weapon_sword")
    inst:AddTag("projectile")
	
	inst.AnimState:SetBank("xuanyuan") 
	inst.AnimState:SetBuild("xuanyuan") 
	inst.AnimState:PlayAnimation("idle")
	
    inst.entity:AddLight()
				inst.Light:SetRadius(1)
    			inst.Light:SetFalloff(1)
    			inst.Light:SetIntensity(0.3)
    			inst.Light:SetColour(128/255,128/255,255/255)
	inst.Light:Enable(false)	

	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "sword_3.tex" )

	inst.isunfolded = false	
	--inst:AddComponent("useableitem")
    --inst.components.useableitem:SetOnUseFn(unfoldit)
    --加入剑属性	
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(51*TUNING.DIFFICULTY)
    inst.components.weapon:SetRange(0.8)
    --inst.components.weapon:SetDamage(TUNING.BOOMERANG_DAMAGE)
    --inst.components.weapon:SetRange(20, 20)
    inst.components.weapon:SetOnAttack(onattack_sword5)
	
    inst:AddComponent("spellcaster")
    inst.components.spellcaster.canuseontargets = true
    inst.components.spellcaster.canusefrominventory = false
    inst.components.spellcaster:SetSpellTestFn(cantornado)
    inst.components.spellcaster:SetSpellFn(spawntornado)
    inst.components.spellcaster.castingstate = "castspell_tornado"
    inst.components.spellcaster.actiontype = "SCIENCE"
	
    --inst:AddComponent("projectile")
    --inst.components.projectile:SetSpeed(20)
    --inst.components.projectile:SetCanCatch(true)
    --inst.components.projectile:SetOnThrownFn(OnThrown)
    --inst.components.projectile:SetOnHitFn(OnHit)
    --inst.components.projectile:SetOnMissFn(ReturnToOwner)
    --inst.components.projectile:SetOnCaughtFn(OnCaught)
	
    --可装备
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
	inst.ownerWalkSpeed=5
	inst.ownerRunSpeed=7

	if not IsDLCEnabled(REIGN_OF_GIANTS) then
    MakeInventoryFloatable(inst, "idle_water", "anim")
    --inst.components.equippable.poisonblocker = true
	inst:AddComponent("windproofer")
	inst.components.windproofer:SetEffectiveness(0) 
    end
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.keepondeath = true
	inst.components.inventoryitem.imagename = "sword_3"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/sword_3.xml"

	inst.components.inventoryitem:SetOnDroppedFn(surfboard_ondropped)

	inst:AddComponent("pocket")

	--inst:AddComponent("deployable")
	--inst.components.deployable.ondeploy = ondeploy
	--inst.components.deployable.placer = "surfboard_placer"
	--inst.components.deployable.deploydistance = 2	


    --inst:AddComponent("spellcaster")
    --inst.components.spellcaster:SetSpellFn(createjianling)
    --inst.components.spellcaster:SetSpellTestFn(cancreatejianling)
    --inst.components.spellcaster.canuseonpoint = true
    --inst.components.spellcaster.canusefrominventory = false
	
	
    --inst:AddComponent("playerprox")
    --inst.components.playerprox:SetDist(15, 15)
    --inst.components.playerprox:SetOnPlayerNear(on_close)
    --inst.components.playerprox:SetOnPlayerFar(far)

	inst:AddComponent("characterspecific")
    inst.components.characterspecific:SetOwner("ssword")

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 24
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(1, 0.8, 0.65, 1)
    inst.components.talker.offset = Vector3(200,-250,0)
    inst.components.talker.symbol = "swap_object"
	
	
	
	--inst.apply = inst:DoPeriodicTask(0,unfoldit)	
	
--检测投掷状态，没有就装上
--[[
inst.huifu = inst:DoPeriodicTask(20, function()
if inst.components.inventory and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) and inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS).prefab  == "surfboard_item_toso" then

else
if not inst.components.deployable then
	inst:AddComponent("deployable")
	inst.components.deployable.ondeploy = ondeploy
	inst.components.deployable.placer = "surfboard_placer"
	inst.components.deployable.deploydistance = 2	
end
end

end)
]]	
	
	return inst
end

return 
	Prefab( "common/objects/toso_surfboard", surfboardfn, assets, prefabs),
	Prefab("common/inventory/surfboard_item_toso", surfboarditemfn, assets, prefabs),
	MakePlacer( "common/surfboard_placer", "toso_sword_fly", "toso_sword_fly", "run_loop", false, false, false, nil, nil, nil, nil, true)