local assets=
{ 
    Asset("ANIM", "anim/toso_bowm.zip"),
    Asset("ANIM", "anim/weapon/swap_bowm.zip"),
	
    Asset("ATLAS", "images/inventoryimages/toso_bowm.xml"),
    Asset("IMAGE", "images/inventoryimages/toso_bowm.tex"),
}
local prefabs = 
{

}

local function onfinished(inst)
    inst:Remove()
end

local function OnEquipYuMo(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_bowm", "swap_bowm")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 	
	
end

local function OnUnequipYuMo(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 

end

------------------------------------------------------------





local function attackfuel(inst, attacker, target)
local player = GetPlayer()


	
	
end


------------------------------------------------------------

local function yumofn(colour)
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    --inst.entity:AddMiniMapEntity()

	--inst.backpack_level = 0
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "toso_bowm.tex" )
	
    inst.AnimState:SetBank("toso_bowm")
    inst.AnimState:SetBuild("toso_bowm")
    inst.AnimState:PlayAnimation("idle")
	
	

	inst:AddTag("toso_sword")
	inst:AddTag("gongjian")
	inst:AddTag("waterproofer")
	
    inst.entity:AddLight()
	inst.Light:SetRadius(.4)
    inst.Light:SetFalloff(.5)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(80/255,120/255,250/255)
	inst.Light:Enable(true)
	
    inst:AddComponent("talker")
    inst.components.talker.fontsize = 24
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(1, 0.8, 0.65, 1)
    inst.components.talker.offset = Vector3(200,-250,0)
    inst.components.talker.symbol = "swap_object"
	
    inst:AddComponent("weapon")
	inst.components.weapon:SetRange(8, 10)
	inst.components.weapon:SetProjectile("prj_gongjian")
    inst.components.weapon:SetDamage(51)
    inst.components.weapon:SetOnAttack(attackfuel)


	inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.keepondeath = true
    inst.components.inventoryitem.imagename = "toso_bowm"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/toso_bowm.xml"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( OnEquipYuMo )
    inst.components.equippable:SetOnUnequip( OnUnequipYuMo )






    return inst
end

local function ssword_bowm(inst)
    local inst = yumofn(inst)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES)
    inst.components.finiteuses:SetUses(TUNING.SPEAR_USES)
    
    inst.components.finiteuses:SetOnFinished( onfinished )

	return inst
end	

local function ssword_bowm2(inst)
    local inst = yumofn(inst)



	return inst
end	

return  Prefab("common/inventory/ssword_bowm", ssword_bowm, assets, prefabs),
        Prefab("common/inventory/ssword_bowm2", ssword_bowm2, assets, prefabs)
