local assets=
{
	Asset("ANIM", "anim/inventoryanim/yaoshui.zip"),
	
	Asset("ATLAS", "images/inventoryimages/yaoshui.xml"),
    Asset("IMAGE", "images/inventoryimages/yaoshui.tex"),
}


--效果
local function oneat_yaoshui(inst,eater)

end

local function fn()
    
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)   
	
    --丹药属性
    inst:AddTag("toso_pellet")	


	
    inst.AnimState:SetBank("yaoshui")
    inst.AnimState:SetBuild("yaoshui")
    inst.AnimState:PlayAnimation("idle")
	inst.Transform:SetScale(1.2, 1.2, 1.2)

    --可食用
	inst:AddComponent("edible")	
	inst.components.edible.foodtype = "GENERIC"
	inst.components.edible.foodstate = "PREPARED"
	inst.components.edible.healthvalue = 30
	inst.components.edible.sanityvalue = 20
	inst.components.edible.hungervalue = 10
	--食用效果
	inst.components.edible:SetOnEatenFn(oneat_yaoshui)
    
    inst:AddComponent("inspectable")
	
	--格子数
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 300	

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "yaoshui"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/yaoshui.xml"

 	if SaveGameIndex:IsModeShipwrecked() then
	MakeInventoryFloatable(inst, "idle_water", "idle")
	end
	
    return inst
end

return Prefab( "common/inventory/yaoshui", fn, assets)
