--该技能方法参考瑞文和雨衣模组，伤害结算方式与雨衣一致


local Sswordcast = Class(function(self, inst)
    self.inst = inst
    --self.canuseskill = false
end)

function Sswordcast:areaskill(caster)
    local old = caster.bufferedaction
    if caster:HasTag("huoqiang") then
        self:huoqiang_attack(caster)
	elseif caster:HasTag("baofengxue") then
        self:baofengxue_attack(caster)
    end
    caster.bufferedaction = old
    return true
end


function Sswordcast:toso_skilldist(caster)
	local skilldist = 3.25
	local weapon = caster.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	if weapon and weapon.components.weapon then
		if weapon and weapon.components.weapon and weapon.components.weapon.attackrange then
			skilldist = weapon.components.weapon.attackrange+2.25
		end
	end
	return skilldist
end

function Sswordcast:tosotarget()
	local pos = Vector3(GetPlayer().Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 30)
	for k,v in pairs(ents) do
		if v and v.components.follower and v.components.follower.leader == GetPlayer() and not v:HasTag("myfriend") then
		v:AddTag("myfriend")
		end
		if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("tosotarget") and not v:HasTag("player") and not v:HasTag("myfriend") and not v:HasTag("wall") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("bird") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then
		v:AddTag("tosotarget")
--		elseif v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("tosotarget") and not v:HasTag("myfriend") and v:HasTag("monster") and GetPlayer():HasTag("mononly") and not v:HasTag("wall") and not v:HasTag("player") then
--		v:AddTag("tosotarget")
		end
	end
end

function Sswordcast:get_tosotarget(caster)
	self:tosotarget()
    --self.canuseskill = false
	local x1, y1, z1 = caster.Transform:GetWorldPosition()
	local target = GetClosestInstWithTag("tosotarget", caster or GetPlayer(), 15)
	if caster.components.combat.targetfn then
		target = caster.components.combat.targetfn(caster)
		if not caster.components.combat.target and target ~= nil then
			caster.components.combat:SetTarget(target)
		end
	end
	if caster.components.combat.target then
		target = caster.components.combat.target
	end
	if target and target~=nil then
		local x2, y2, z2 = target.Transform:GetWorldPosition()
		local dist = math.sqrt((x1 - x2)*(x1 - x2) + (z1 - z2)*(z1 - z2))
		local dist_Instructions = self:toso_skilldist(caster)
		local pos = Point(caster.Transform:GetWorldPosition())
--		local range_indicators = TheSim:FindEntities(pos.x,pos.y,pos.z, 10, {"yiyu_range_indicator"} )
		--if dist > self:toso_skilldist(caster) then
			--caster.components.combat:SetTarget(target)
			--caster:RemoveTag("xinjineng")
			--caster:RemoveTag("xinjineng2")
			--caster.components.talker:Say(TUNING.TALK19)
		--elseif dist <= self:toso_skilldist(caster) then
			--self.canuseskill = true
		--end
	end
	if not target or target==nil or (target and target.components.health and target.components.health:IsDead()) then
			caster.components.talker:Say(TUNING.TALKS15)
			--caster:RemoveTag("xinjineng")
			--caster:RemoveTag("xinjineng2")
	end
	if target and target~=nil and target.components.combat and target.components.health and not target.components.health:IsDead() then
	return target
	end

end



--幽影步
function Sswordcast:youying(caster)

    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
    if not caster:HasTag("wudion") then
    caster:AddTag("wudion")
    end

        local pt = Vector3(TheInput:GetWorldPosition():Get())	
if TUNING.XUYING_DIRECTION == 0 then--人物面对方向

        caster:ForceFacePoint(pt.x, pt.y, pt.z)
end
        local x2, y2, z2 = caster.Transform:GetWorldPosition()
        local angel = math.atan2(pt.z - z2, pt.x - x2)
        local dist = math.sqrt((pt.x - x2) * (pt.x - x2) + (pt.z - z2) * (pt.z - z2))
        local speed = dist * 2
        caster.AnimState:PlayAnimation("atk")
		local pos1 = Vector3(caster.Transform:GetWorldPosition())


               local ents = TheSim:FindEntities(pos1.x,pos1.y,pos1.z, 1)
               for k,v in pairs(ents) do
                   if v.components.health and v.components.combat and not v.components.health:IsDead() and not v:HasTag("ssword") and not v:HasTag("bird") and not v:HasTag("myfriend") and not v:HasTag("wall") and not v:HasTag("hive") and not v:HasTag("pig") and not v:HasTag("companion") then
                      

                        v.components.health:DoDelta(-10-caster.level)

                      local pt1 = caster:GetPosition()
                      local pt2 = v:GetPosition()
                      local Repelrate = (1 + math.random() )*1
                      v.Transform:SetPosition((pt2.x-pt1.x)*Repelrate+pt2.x, 0, (pt2.z-pt1.z)*Repelrate+pt2.z)
					  local fx = SpawnPrefab("explode_small")
					  fx.Transform:SetPosition( v.Transform:GetWorldPosition() )
                   end
               end
		
		

		caster:ClearBufferedAction()
		--caster.components.playercontroller:Enable(false)
		caster.components.locomotor:Stop()
		--caster:ForceFacePoint(v:GetPosition():Get())
		caster.components.health:SetInvincible(true)
		caster.SoundEmitter:PlaySound("dontstarve/common/staff_blink")
		caster.AnimState:PlayAnimation("chop_loop")
		--caster.AnimState:PlayAnimation("atk_leap_lag")
		--if caster.components.driver and caster.components.driver.vehicle then
        --caster.components.driver.vehicle:Hide()
        --end
        caster:DoTaskInTime(0.1, function()
            --if math.random() < 0.3 then
                --caster.components.talker:Say("哈", nil, true)
            --end
            --caster.AnimState:PlayAnimation("jump")
            --caster.Physics:SetMotorVelOverride(20, 10, 0)
			caster.Physics:SetMotorVelOverride(20, 0, 0)

        end)
        caster:DoTaskInTime(0.3, function()
            --caster.Physics:ClearMotorVelOverride()
            --caster.Physics:SetMotorVelOverride(20, -10, 0)
			caster.Physics:ClearMotorVelOverride()
            caster.Physics:SetMotorVelOverride(20, 0, 0)
            --caster.AnimState:PlayAnimation("chop_loop")
        end)
        caster:DoTaskInTime(0.5, function()
            --caster.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack")
            --caster.AnimState:PlayAnimation("atk")
			
            if caster.components.driver and caster.components.driver.vehicle then
                caster.components.driver.vehicle:Hide()
            end
		--caster.sg:GoToState("idle")
		--caster.components.health:SetInvincible(false)
		--caster.components.playercontroller:Enable(true)
			
						--caster:DoTaskInTime(.2, function()
							if not caster.sg:HasStateTag("busy") and not caster.sg:HasStateTag("doing") then
								caster.sg:GoToState("idle")
										--local fxbo = SpawnPrefab("groundpoundring_fx")
		                                --fxbo.Transform:SetScale(0.5, 0.5, 0.5)
		                                --fxbo.Transform:SetPosition(caster:GetPosition():Get())
								--caster.SoundEmitter:PlaySound("dontstarve_DLC002/common/boatjump_to_land")
								




							end
						--end)
			
        end)
        caster:DoTaskInTime(0.6, function()


		caster.sg:GoToState("idle")
		caster.components.health:SetInvincible(false)
		caster.components.playercontroller:Enable(true)
		

        caster:RemoveTag("wudion")


		
        end)
		
		
	

end

--跳起攻击
function Sswordcast:tiaoqi3(caster)

    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
	
        local pt = Vector3(TheInput:GetWorldPosition():Get())
        caster:ForceFacePoint(pt.x, pt.y, pt.z)
        local x2, y2, z2 = caster.Transform:GetWorldPosition()
        local angel = math.atan2(pt.z - z2, pt.x - x2)
        local dist = math.sqrt((pt.x - x2) * (pt.x - x2) + (pt.z - z2) * (pt.z - z2))
        local speed = dist * 2
        caster.AnimState:PlayAnimation("atk")
		local pos1 = Vector3(caster.Transform:GetWorldPosition())
		--加入一个特效	
		--local fxhuo = SpawnPrefab("dilie_toso")
		--fxhuo.Transform:SetScale(1.4, 1.4, 1.4)
		--fxhuo.Transform:SetPosition(caster:GetPosition():Get())	

               local ents = TheSim:FindEntities(pos1.x,pos1.y,pos1.z, 1)
               for k,v in pairs(ents) do
                   if v.components.health and v.components.combat and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("bird") and not v:HasTag("myfriend") and not v:HasTag("wall") and not v:HasTag("hive") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then
                      

                        --v.components.health:DoDelta(-10-caster.level)
						--v.components.combat:GetAttacked(caster, 5+caster.level)

                      local pt1 = caster:GetPosition()
                      local pt2 = v:GetPosition()
                      local Repelrate = (1 + math.random() )*1
                      v.Transform:SetPosition((pt2.x-pt1.x)*Repelrate+pt2.x, 0, (pt2.z-pt1.z)*Repelrate+pt2.z)
					  local fx = SpawnPrefab("explode_small")
					  fx.Transform:SetPosition( v.Transform:GetWorldPosition() )
                   end
               end
		
		
		
        caster:DoTaskInTime(0.2, function()
		caster.skillon = false
            --if math.random() < 0.3 then
                --caster.components.talker:Say("哈", nil, true)
            --end
		caster:ClearBufferedAction()
		caster.components.playercontroller:Enable(false)
		caster.components.locomotor:Stop()
		--caster:ForceFacePoint(v:GetPosition():Get())
		caster.components.health:SetInvincible(true)

            caster.AnimState:PlayAnimation("jump")
            caster.Physics:SetMotorVelOverride(0, 20, 0)
        end)
        caster:DoTaskInTime(0.4, function()
            caster.Physics:ClearMotorVelOverride()
            caster.Physics:SetMotorVelOverride(0, -20, 0)
            caster.AnimState:PlayAnimation("pickaxe_loop")
        end)
        caster:DoTaskInTime(0.6, function()
            caster.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack")
            caster.AnimState:PlayAnimation("atk")
            if caster.components.driver and caster.components.driver.vehicle then
                caster.components.driver.vehicle:Hide()
            end
			
						--caster:DoTaskInTime(.2, function()
							if not caster.sg:HasStateTag("busy") and not caster.sg:HasStateTag("doing") then
								caster.sg:GoToState("idle")
										--local fxbo = SpawnPrefab("groundpoundring_fx")
		                                --fxbo.Transform:SetScale(0.5, 0.5, 0.5)
		                                --fxbo.Transform:SetPosition(caster:GetPosition():Get())
								--caster.SoundEmitter:PlaySound("dontstarve_DLC002/common/boatjump_to_land")
							end
						--end)
        caster.skillon = true
		caster.sg:GoToState("idle")
		caster.components.health:SetInvincible(false)
		caster.components.playercontroller:Enable(true)
			
        end)
		
		
		--这里参考翼语的击飞代码--
        caster:DoTaskInTime(0.5, function()
            local x5, y5, z5 = caster:GetPosition():Get()		
            local ents = TheSim:FindEntities(x5, y5, z5, 4)
			                for k,v in pairs(ents) do
            		if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("bird") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then

                       if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then
					      --为避免触发攻击被动，去除攻击，改为减血程序
						  v.components.combat:GetAttacked(caster, 5+caster.level)
						  --v.components.health:DoDelta(-10-caster.level)
						  
					   end
					   
								--if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		                        --if v.brain then v.brain:Stop() end
		                        --if v.components.locomotor then v.components.locomotor:Stop() end
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end	
								

							
            end
            end

        end)
		--这里参考翼语的击飞代码。--	

end

--落下冰冻攻击
function Sswordcast:citong(caster)

    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
	
        local pt = Vector3(TheInput:GetWorldPosition():Get())
        caster:ForceFacePoint(pt.x, pt.y, pt.z)
        local x2, y2, z2 = caster.Transform:GetWorldPosition()
        local angel = math.atan2(pt.z - z2, pt.x - x2)
        local dist = math.sqrt((pt.x - x2) * (pt.x - x2) + (pt.z - z2) * (pt.z - z2))
        local speed = dist * 2
        caster.AnimState:PlayAnimation("atk")
		local pos1 = Vector3(caster.Transform:GetWorldPosition())
		--加入一个特效	
		local fxhuo = SpawnPrefab("dilie_toso")
		fxhuo.Transform:SetScale(1.4, 1.4, 1.4)
		fxhuo.Transform:SetPosition(caster:GetPosition():Get())	

               local ents = TheSim:FindEntities(pos1.x,pos1.y,pos1.z, 1)
               for k,v in pairs(ents) do
                   if v.components.health and v.components.combat and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("bird") and not v:HasTag("myfriend") and not v:HasTag("wall") and not v:HasTag("hive") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then
                      

                        v.components.health:DoDelta(-10-caster.level)

                      local pt1 = caster:GetPosition()
                      local pt2 = v:GetPosition()
                      local Repelrate = (1 + math.random() )*1
                      v.Transform:SetPosition((pt2.x-pt1.x)*Repelrate+pt2.x, 0, (pt2.z-pt1.z)*Repelrate+pt2.z)
					  local fx = SpawnPrefab("explode_small")
					  fx.Transform:SetPosition( v.Transform:GetWorldPosition() )
                   end
               end
		
		
		
        caster:DoTaskInTime(0.2, function()
            --if math.random() < 0.3 then
                --caster.components.talker:Say("哈", nil, true)
            --end
            caster.AnimState:PlayAnimation("jump")
            caster.Physics:SetMotorVelOverride(20, 10, 0)
        end)
        caster:DoTaskInTime(0.4, function()
            caster.Physics:ClearMotorVelOverride()
            caster.Physics:SetMotorVelOverride(20, -10, 0)
            caster.AnimState:PlayAnimation("chop_loop")
        end)
        caster:DoTaskInTime(0.6, function()
            caster.SoundEmitter:PlaySound("dontstarve/tentacle/tentacle_attack")
            caster.AnimState:PlayAnimation("atk")
            if caster.components.driver and caster.components.driver.vehicle then
                caster.components.driver.vehicle:Hide()
            end
			
						--caster:DoTaskInTime(.2, function()
							if not caster.sg:HasStateTag("busy") and not caster.sg:HasStateTag("doing") then
								caster.sg:GoToState("idle")
										--local fxbo = SpawnPrefab("groundpoundring_fx")
		                                --fxbo.Transform:SetScale(0.5, 0.5, 0.5)
		                                --fxbo.Transform:SetPosition(caster:GetPosition():Get())
								--caster.SoundEmitter:PlaySound("dontstarve_DLC002/common/boatjump_to_land")
							end
						--end)

        end)
		
		
		--这里参考翼语的击飞代码--
        caster:DoTaskInTime(0.5, function()
            local x5, y5, z5 = caster:GetPosition():Get()		
            local ents = TheSim:FindEntities(x5, y5, z5, 5)
			                for k,v in pairs(ents) do
            		if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("bird") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then

                       if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then
					      --为避免触发攻击被动，去除攻击，改为减血程序
						  --v.components.combat:GetAttacked(caster, 5+caster.level+caster.skill_jin_1)
						  v.components.health:DoDelta(-5-caster.level-caster.skill_1)
					   end
					   
								--if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		                        --if v.brain then v.brain:Stop() end
		                        --if v.components.locomotor then v.components.locomotor:Stop() end
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end	
								
--冰冻程序								
	if v.components.sleeper and v.components.sleeper:IsAsleep() then
        v.components.sleeper:WakeUp()
    end
    if v.components.burnable then
        if v.components.burnable:IsBurning() then
            v.components.burnable:Extinguish()
        elseif v.components.burnable:IsSmoldering() then
            v.components.burnable:SmotherSmolder()
        end
    end

    --if v.components.combat then
        --v.components.combat:SuggestTarget(attacker)
    --end

    --if v.sg and not v.sg:HasStateTag("frozen") then
        --v:PushEvent("attacked", {attacker = attacker, damage = 0})
    --end
	--冰		 
	if not caster or not v then 
	return end
	
    local numFX = math.random(5,10)
    local pos = caster:GetPosition()
    local targetPos = v:GetPosition()
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = caster:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        caster:DoTaskInTime(math.random() * 0.25, function(caster)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = GetRandomWithVariance(0, 1)
                local z = GetRandomWithVariance(0, 1)
                local offset = (vec * math.random(dist * 0.25, dist)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
            end
        end)
    end
	
	v.components.health:DoDelta(- 10 - caster.level)
	
    if v.components.freezable then
        v.components.freezable:AddColdness(3)
        v .components.freezable:SpawnShatterFX()
    end

--冰冻程序结束	
							
            end
            end

        end)
		--这里参考翼语的击飞代码。--	

end

--击飞连击
function Sswordcast:jifei_attack(caster)

if not caster:HasTag("jifei") then 
    caster:HasTag("jifei")
    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
    if not caster:HasTag("nozhan") then
    caster:AddTag("nozhan")
    end

		--这里参考翼语的击飞代码--
        caster:DoTaskInTime(0, function()
		
            local x5, y5, z5 = caster:GetPosition():Get()		
            local ents = TheSim:FindEntities(x5, y5, z5, 5)
			                for k,v in pairs(ents) do
            		if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("bird") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then

                       if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then
					      --为避免触发攻击被动，去除攻击，改为减血程序
						  --v.components.combat:GetAttacked(caster, 5+caster.level+caster.skill_jin_1)
						  v.components.health:DoDelta(-5-caster.level-caster.skill_2)
					   end
					   
								if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		                        if v.brain then v.brain:Stop() end
		                        if v.components.locomotor then v.components.locomotor:Stop() end
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		                        if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end	
								
								
							    				local x7, y7, z7 = v:GetPosition():Get()
												local ziwen = SpawnPrefab("ziwen")
		                                        ziwen.Transform:SetPosition(x7, y7, z7)
		                                        ziwen.Transform:SetScale(3.5, 3.5, 3.5)
												--caster.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
														caster.AnimState:PlayAnimation("shovel_loop")
		                                                caster.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/ice_large")
												
				                                local sign=1
				                                v.task1 = v:DoPeriodicTask(0.05,  function()
					                            local x8, y8, z8 = v:GetPosition():Get()
					                            v:AddTag("toso_jifei")
												caster.skillon = false
					                            v.Transform:SetPosition(x7, y8+0.35*sign, z7)
				                                end)
				                                v:DoTaskInTime(0.25, function() 
					                            v.components.combat:GetAttacked(caster, 2+caster.level)
				                                end)
				                                v:DoTaskInTime(0.5, function() 
					                            v.components.combat:GetAttacked(caster, 2+caster.level)
				                                end)
				                                v:DoTaskInTime(0.75, function() 
					                            v.components.combat:GetAttacked(caster, 2+caster.level)
				                                end)
				                                v:DoTaskInTime(1, function() 
					                            sign=-1
				                                end)
				                                v:DoTaskInTime(1.25, function() 
					                            v.components.combat:GetAttacked(caster, 2+caster.level)
				                                end)
				                                v:DoTaskInTime(1.5, function() 
					                            v.components.combat:GetAttacked(caster, 2+caster.level)
				                                end)
				                                v:DoTaskInTime(1.75, function() 
					                            v.components.combat:GetAttacked(caster, 2+caster.level)
				                                end)
				                                v:DoTaskInTime(2, function()
					                            if v and v.task1 then
					                            v.task1:Cancel()
					                            v.task1 = nil
					                            end
					                            v:RemoveTag("toso_jifei")
												caster.skillon = true
					                            v.Transform:SetPosition(x7, y7, z7)
				                                end)

	                        if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	                        v:DoTaskInTime(1.5, function()
	                        if v.brain then v.brain:Start() end
	                        if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	                        if v then v.components.combat:SetTarget(caster) end
	                        --if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	                        end)
	                        end
							
            end
            end

        end)
		--这里参考翼语的击飞代码。--	
    caster:RemoveTag("jifei")
end
caster:RemoveTag("onzhan")
end

--冰冻三尺
--参照雪莉大招
function Sswordcast:bingdongsanchi_attack(caster)

    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
    --if not IsPaused() then
    if caster.components.lingli.currentlingli < 10 then
       caster.components.talker:Say("灵力不足")
    end
	
    if caster.components.lingli.currentlingli >= 10 then
       caster.components.talker:Say("冰冻三尺")
       --caster.components.lingli:DoDelta(-10)
       --caster.components.hunger:DoDelta(-10)
       caster.components.playercontroller:Enable(false) 
		caster.components.health:SetInvincible(true)

       local pos = caster:GetPosition()
       caster.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
       
       caster:DoTaskInTime(0.01, function()
            caster.AnimState:PlayAnimation("pickup")
            caster.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/ice_large") 

            for k = 1,math.random(30,40) do
			
            local pt = Vector3(caster.Transform:GetWorldPosition())
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            fx.Transform:SetPosition(pt.x+(math.random(8)-math.random(8)), 0, pt.z+(math.random(8)-math.random(8)))
            end
          
       end)
       caster:DoTaskInTime(0.02, function()




            local pos = Vector3(caster.Transform:GetWorldPosition())
            local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 10)
            for k,v in pairs(ents) do
               
                if v.components.freezable and not v:HasTag("player") and not v:HasTag("shadowcreature") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then
                   v.components.health:DoDelta(-5)
                   v.components.freezable:AddColdness(2)
		           v.components.freezable:SpawnShatterFX()
--添加buff
--v:AddTag("ice2")
                end
            end
       
            caster.components.playercontroller:Enable(true)
		
		    caster.components.health:SetInvincible(false)
       end)
    end
	
end


--击飞参考翼语

function Sswordcast:dilie_attack2(caster)
	local v = self:get_tosotarget(caster)
	if v and v~=nil then
	local diliedmg = 5 + caster.yuansu_bing
--		caster.components.combat:SetTarget(nil)
		caster:ClearBufferedAction()
		caster.components.playercontroller:Enable(false)
		caster.components.locomotor:Stop()
		caster:ForceFacePoint(v:GetPosition():Get())
		caster.components.health:SetInvincible(true)

--		caster.yiyudmgcomb = caster.yiyudmgcomb + 1
		--caster.components.colourtweener:StartTween({1,1,1,1}, 0)

		caster.AnimState:PlayAnimation("shovel_loop")
		caster.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/ice_large")
		--local dilie = SpawnPrefab("dilie")
		local x2, y2, z2 = v:GetPosition():Get()
		--dilie.Transform:SetPosition(x2, y2, z2)
		--dilie.Transform:SetScale(3.5, 3.5, 3.5)


	if caster:HasTag("Ragnarok") then

		local pos = Vector3(v.Transform:GetWorldPosition())
		local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, caster.level/15+2.5)
		for k,v in pairs(ents) do
			if v and v:HasTag("tosotarget") and not v:HasTag("player") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) then

		if v then v.AnimState:SetMultColour(255/255,255/255,0/255,1) end
		if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, diliedmg) end
		if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		if v.brain then v.brain:Stop() end
		if v.components.locomotor then v.components.locomotor:Stop() end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end


				local x2, y2, z2 = v:GetPosition():Get()
				local sign=1
				v.task1 = v:DoPeriodicTask(0.05,  function()
					local x3, y3, z3 = v:GetPosition():Get()
					v:AddTag("fukong")
					v.Transform:SetPosition(x2, y3+0.35*sign, z2)
				end)
				v:DoTaskInTime(0.5, function() 
					sign=-1
				end)
				v:DoTaskInTime(1, function()
					if v and v.task1 then
					v.task1:Cancel()
					v.task1 = nil
					end
					v:RemoveTag("fukong")
					v.Transform:SetPosition(x2, y2, z2)
				end)

	if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	v:DoTaskInTime(1.5, function()
	if v.brain then v.brain:Start() end
	if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	if v then v.components.combat:SetTarget(caster) end
	if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	end)
	end

	end
	end

	elseif not caster:HasTag("Ragnarok") then
		if v then v.AnimState:SetMultColour(255/255,255/255,0/255,1) end
		if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, diliedmg) end
		if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		if v.brain then v.brain:Stop() end
		if v.components.locomotor then v.components.locomotor:Stop() end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end


				local x2, y2, z2 = v:GetPosition():Get()
				local sign=1
				v.task1 = v:DoPeriodicTask(0.05,  function()
					local x3, y3, z3 = v:GetPosition():Get()
					v:AddTag("fukong")
					v.Transform:SetPosition(x2, y3+0.35*sign, z2)
				end)
				v:DoTaskInTime(0.5, function() 
					sign=-1
				end)
				v:DoTaskInTime(1, function()
					if v and v.task1 then
					v.task1:Cancel()
					v.task1 = nil
					end
					v:RemoveTag("fukong")
					v.Transform:SetPosition(x2, y2, z2)
				end)

	if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	v:DoTaskInTime(1.5, function()
	if v.brain then v.brain:Start() end
	if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	if v then v.components.combat:SetTarget(caster) end
	if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	end)
	end

	end

		caster:DoTaskInTime(1.00, function()
		caster.sg:GoToState("idle")
		caster.components.health:SetInvincible(false)
		caster.components.playercontroller:Enable(true)
		end)

	end
end
--冰冻三尺
--参照翼语算法

function Sswordcast:SpawnIceFx(caster, target)
    if not caster or not target then return end
    local numFX = math.random(15,20)
    local pos = caster:GetPosition()
    local targetPos = target:GetPosition()
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = caster:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        caster:DoTaskInTime(math.random() * 0.25, function(caster)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = GetRandomWithVariance(0, 3)
                local z = GetRandomWithVariance(0, 3)
                local offset = (vec * math.random(dist * 0.25, dist)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
            end
        end)
    end
end

function Sswordcast:bingdong_attack2(caster)
	local v = self:get_tosotarget(caster)
	if v and v~=nil then
	local bingdongdmg = 5 + caster.yuansu_bing
--		caster.components.combat:SetTarget(nil)
		caster:ClearBufferedAction()
		caster.components.playercontroller:Enable(false)
		caster.components.locomotor:Stop()
		caster:ForceFacePoint(v:GetPosition():Get())
		caster.components.health:SetInvincible(true)


		caster.AnimState:PlayAnimation("chop_loop")
		caster.SoundEmitter:PlaySound("dontstarve_DLC001/common/iceboulder_smash")


	if caster:HasTag("Ragnarok") then

		local pos = Vector3(v.Transform:GetWorldPosition())
		local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, caster.level/15+2.5)
		for k,v in pairs(ents) do
			if v and v:HasTag("tosotarget") and not v:HasTag("player") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) then
		self:SpawnIceFx(caster, v)
		if v then v.AnimState:SetMultColour(150/255,150/255,150/255,1) end
		if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, bingdongdmg) end
		if v and v.brain then v.brain:Stop() end
		if v and v.components.locomotor then v.components.locomotor:Stop() end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
		if v.components.freezable then--and v.prefab ~= "yiyu_deerclops" 
		v.components.freezable:AddColdness(10, 0.5)
		v.components.freezable:SpawnShatterFX()
		end

	if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	v:DoTaskInTime(1.5, function()
	if v.brain then v.brain:Start() end
	if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	if v then v.components.combat:SetTarget(caster) end
	if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	end)
	end

			end
		end


	elseif not caster:HasTag("Ragnarok") then
		self:SpawnIceFx(caster, v)
		if v then v.AnimState:SetMultColour(150/255,150/255,150/255,1) end
		if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, bingdongdmg) end
		if v and v.brain then v.brain:Stop() end
		if v and v.components.locomotor then v.components.locomotor:Stop() end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
		if v.components.freezable then--and v.prefab ~= "yiyu_deerclops" 
		v.components.freezable:AddColdness(10, 0.5)
		v.components.freezable:SpawnShatterFX()
		end


	if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	v:DoTaskInTime(1.5, function()
	if v.brain then v.brain:Start() end
	if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	if v then v.components.combat:SetTarget(caster) end
	if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	end)
	end

end

		caster:DoTaskInTime(0.6, function()
		--caster:RemoveTag("xinjineng")
		caster.sg:GoToState("idle")
		caster.components.health:SetInvincible(false)
		caster.components.playercontroller:Enable(true)
		end)

	end
end



--烈火刀法
function Sswordcast:liehuodaofa_attack(caster)
    --if not caster:HasTag("kakaka") then
    --caster:AddTag("kakaka")
    --end
	
    caster:ClearBufferedAction()
    caster.components.playercontroller:Enable(false)
    caster.components.locomotor:Stop()	
    if caster.components.driver and caster.components.driver.vehicle then caster.components.driver.vehicle:Show() end

    local pt = Vector3(caster.Transform:GetWorldPosition())
    caster:DoTaskInTime(0.05, function()

    caster:ForceFacePoint(pt.x,pt.y,pt.z)
    caster.AnimState:PlayAnimation("atk")
	local toso_leiting = SpawnPrefab("liehuodaofa_toso")
	toso_leiting.Transform:SetScale(3, 3, 3)
	toso_leiting.Transform:SetPosition(pt.x, pt.y-0.7, pt.z)
	--toso_leiting.Transform:SetPosition(pt.x, pt.y+4, pt.z)
		self:jianyu_area(pt, caster)
		caster.AnimState:PlayAnimation("chop_loop")
	caster:DoTaskInTime(0.5, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.5, function()
		self:jianyu_area(pt, caster)
		caster.AnimState:PlayAnimation("powerup")
	end)
	caster:DoTaskInTime(2, function()
		self:jianyu_area(pt, caster)
	end)

        caster.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        if caster.components.health then
            caster.components.health:SetInvincible(true)
        end
    end)
    caster:DoTaskInTime(0.5, function()
		--caster.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
        caster.components.locomotor:Stop()
        caster.AnimState:PlayAnimation("idle")

        if caster.components.health then
            caster.components.health:SetInvincible(false)
        end
        caster.components.playercontroller:Enable(true)
        caster:ClearBufferedAction()

    end)	
	
end

--离火
function Sswordcast:dilie_attack2(caster)
if not caster:HasTag("jifei") then 
    caster:AddTag("jifei")
	
	local v = self:get_tosotarget(caster)
	if v and v~=nil then
	local diliedmg = 100 + 10*caster.level
--		caster.components.combat:SetTarget(nil)
		caster:ClearBufferedAction()
		caster.components.playercontroller:Enable(false)
		caster.components.locomotor:Stop()
		caster:ForceFacePoint(v:GetPosition():Get())
		caster.components.health:SetInvincible(true)

--		caster.yiyudmgcomb = caster.yiyudmgcomb + 1
		--caster.components.colourtweener:StartTween({1,1,1,1}, 0)

		caster.AnimState:PlayAnimation("shovel_loop")
		caster.SoundEmitter:PlaySound("dontstarve/creatures/deerclops/ice_large")
		--local dilie = SpawnPrefab("dilie")
		local x2, y2, z2 = v:GetPosition():Get()
		--dilie.Transform:SetPosition(x2, y2, z2)
		--dilie.Transform:SetScale(3.5, 3.5, 3.5)


	if caster:HasTag("Ragnarok") then

		local pos = Vector3(v.Transform:GetWorldPosition())
		local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, caster.level/15+2.5)
		for k,v in pairs(ents) do
			if v and v:HasTag("tosotarget") and not v:HasTag("ssword") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) then

		if v then v.AnimState:SetMultColour(255/255,255/255,0/255,1) end
		if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, diliedmg) end
		if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		if v.brain then v.brain:Stop() end
		if v.components.locomotor then v.components.locomotor:Stop() end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end


				local x2, y2, z2 = v:GetPosition():Get()
				local sign=1
				v.task1 = v:DoPeriodicTask(0.05,  function()
					local x3, y3, z3 = v:GetPosition():Get()
					v:AddTag("fukong")
					v.Transform:SetPosition(x2, y3+0.35*sign, z2)
				end)
				v:DoTaskInTime(0.5, function() 
					sign=-1
				end)
				v:DoTaskInTime(1, function()
					if v and v.task1 then
					v.task1:Cancel()
					v.task1 = nil
					end
					v:RemoveTag("fukong")
					v.Transform:SetPosition(x2, y2, z2)
				end)

	if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	v:DoTaskInTime(1.5, function()
	if v.brain then v.brain:Start() end
	if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	if v then v.components.combat:SetTarget(caster) end
	if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	end)
	end

	end
	end

	elseif not caster:HasTag("Ragnarok") then
		if v then v.AnimState:SetMultColour(255/255,255/255,0/255,1) end
		if v and v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, diliedmg) end
		if v and v.components.combat then v.components.combat:BlankOutAttacks(1.5) v.components.combat:SetTarget(nil) end
		if v.brain then v.brain:Stop() end
		if v.components.locomotor then v.components.locomotor:Stop() end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end


				local x2, y2, z2 = v:GetPosition():Get()
				local sign=1
				v.task1 = v:DoPeriodicTask(0.05,  function()
					local x3, y3, z3 = v:GetPosition():Get()
					v:AddTag("fukong")
					v.Transform:SetPosition(x2, y3+0.35*sign, z2)
				end)
				v:DoTaskInTime(0.5, function() 
					sign=-1
				end)
				v:DoTaskInTime(1, function()
					if v and v.task1 then
					v.task1:Cancel()
					v.task1 = nil
					end
					v:RemoveTag("fukong")
					v.Transform:SetPosition(x2, y2, z2)
				end)

	if v and v.components.combat and v.components.health and not v.components.health:IsDead() then
	v:DoTaskInTime(1.5, function()
	if v.brain then v.brain:Start() end
	if v.components.freezable and v.components.freezable:IsFrozen() then v:PushEvent("unfreeze") end
	if v then v.components.combat:SetTarget(caster) end
	if v then v.AnimState:SetMultColour(255/255,255/255,255/255,1) end
	end)
	end

	end

		caster:DoTaskInTime(1.00, function()
		caster.sg:GoToState("idle")
		caster.components.health:SetInvincible(false)
		caster.components.playercontroller:Enable(true)
		end)

	end
	
    caster:RemoveTag("jifei")
end

end

--被动死亡返照
function Sswordcast:siwangfanzhao_attack(caster)
    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
	
    caster:ClearBufferedAction()
    caster.components.playercontroller:Enable(false)
    caster.components.locomotor:Stop()	
    if caster.components.driver and caster.components.driver.vehicle then caster.components.driver.vehicle:Show() end

    local pt = Vector3(caster.Transform:GetWorldPosition())
    caster:DoTaskInTime(0.05, function()

    caster:ForceFacePoint(pt.x,pt.y,pt.z)
    --caster.AnimState:PlayAnimation("atk")
	local toso_leiting = SpawnPrefab("liekaitexiao")
	toso_leiting.Transform:SetScale(5, 5, 5)
	toso_leiting.Transform:SetPosition(pt.x, pt.y-0.7, pt.z)
		--self:jianyu_area(pt, caster)
		caster.AnimState:PlayAnimation("chop_loop")
	caster:DoTaskInTime(0.3, function()
		self:jianyu_area(pt, caster)
	end)
	--caster:DoTaskInTime(0.6, function()
		--self:jianyu_area(pt, caster)
	--end)
	caster:DoTaskInTime(0.9, function()
		self:jianyu_area(pt, caster)
	end)
	--caster:DoTaskInTime(1.2, function()
		--self:jianyu_area(pt, caster)
	--end)
	caster:DoTaskInTime(1.5, function()
		self:jianyu_area(pt, caster)
	end)
	--caster:DoTaskInTime(1.8, function()
		--self:jianyu_area(pt, caster)
	--end)
	caster:DoTaskInTime(2.0, function()
		self:jianyu_area(pt, caster)
	end)

        caster.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        if caster.components.health then
            caster.components.health:SetInvincible(true)
        end
    end)
    caster:DoTaskInTime(0.5, function()
		--caster.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
        caster.components.locomotor:Stop()
        caster.AnimState:PlayAnimation("idle")

        if caster.components.health then
            caster.components.health:SetInvincible(false)
        end
        caster.components.playercontroller:Enable(true)
        caster:ClearBufferedAction()

    end)	
	
end

--被动死亡返照
function Sswordcast:siwangfanzhao_attack2(caster)
    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end

	
    caster:ClearBufferedAction()
    caster.components.playercontroller:Enable(false)
    caster.components.locomotor:Stop()	
    if caster.components.driver and caster.components.driver.vehicle then caster.components.driver.vehicle:Show() end

    local pt = Vector3(caster.Transform:GetWorldPosition())
    caster:DoTaskInTime(0.05, function()

    caster:ForceFacePoint(pt.x,pt.y,pt.z)
    --caster.AnimState:PlayAnimation("atk")
	--local toso_leiting = SpawnPrefab("liekaitexiao")
	--toso_leiting.Transform:SetScale(3, 3, 3)
	--toso_leiting.Transform:SetPosition(pt.x, pt.y-0.7, pt.z)

		--self:jianyu_area(pt, caster)
		caster.AnimState:PlayAnimation("chop_loop")
	caster:DoTaskInTime(0.15, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.3, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.45, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.6, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.75, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.9, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.05, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.2, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.35, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.5, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.65, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.8, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(1.9, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(2.0, function()
		self:jianyu_area(pt, caster)
	end)

        caster.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        if caster.components.health then
            caster.components.health:SetInvincible(true)
        end
    end)
    caster:DoTaskInTime(0.5, function()
		--caster.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
        caster.components.locomotor:Stop()
        caster.AnimState:PlayAnimation("idle")

        if caster.components.health then
            caster.components.health:SetInvincible(false)
        end
        caster.components.playercontroller:Enable(true)
        caster:ClearBufferedAction()

    end)	
	
end

--鼠标处降落
function Sswordcast:jianyu_attack(caster)
    if not caster:HasTag("nodorge") then
    caster:AddTag("nodorge")
    end
    if not caster:HasTag("onzhan") then
    caster:AddTag("onzhan")
    end
	--caster.components.colourtweener:StartTween({1,1,1,1}, 0)
    caster:ClearBufferedAction()
    caster.components.playercontroller:Enable(false)
    caster.components.locomotor:Stop()	
    if caster.components.driver and caster.components.driver.vehicle then caster.components.driver.vehicle:Show() end

    local pt = Vector3(TheInput:GetWorldPosition():Get())
    caster:DoTaskInTime(0.05, function()
	caster.skillon = false

    caster:ForceFacePoint(pt.x,pt.y,pt.z)
    caster.AnimState:PlayAnimation("atk")
	--特效1
	local toso_xuanfeng1 = SpawnPrefab("baofengxue")
	--toso_xuanfeng1.Transform:SetScale(1, 1, 1)
	toso_xuanfeng1.Transform:SetScale(3, 3, 3)
	toso_xuanfeng1.Transform:SetPosition(pt.x, pt.y, pt.z)

		self:jianyu_area(pt, caster)
		
	caster:DoTaskInTime(0.33, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.66, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.99, function()
		self:jianyu_area(pt, caster)
		caster.skillon = true
	end)
	--caster:DoTaskInTime(2.00, function()
		--self:jianyu_area(pt, caster)
	--end)

        caster.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        if caster.components.health then
            caster.components.health:SetInvincible(true)
        end
    end)
    caster:DoTaskInTime(0.5, function()
		--caster.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
        caster.components.locomotor:Stop()
        caster.AnimState:PlayAnimation("idle")

        if caster.components.health then
            caster.components.health:SetInvincible(false)
        end
        caster.components.playercontroller:Enable(true)
        caster:ClearBufferedAction()
		--caster.skillon = true

    end)	
caster:RemoveTag("onzhan")	
end
--敌人处降落
function Sswordcast:jianyu_attack2(target, caster)


    caster:ClearBufferedAction()
    caster.components.playercontroller:Enable(false)
    caster.components.locomotor:Stop()
	--caster.components.combat:SetRange(2, 2)
    if caster.components.driver and caster.components.driver.vehicle then caster.components.driver.vehicle:Show() end

	local pt = Vector3(target.Transform:GetWorldPosition())
    caster:DoTaskInTime(0.05, function()
    caster:ForceFacePoint(pt.x,pt.y,pt.z)
    caster.AnimState:PlayAnimation("atk")

	local longjuan = SpawnPrefab("baofengxue")
	longjuan.Transform:SetPosition(pt.x, pt.y, pt.z)
	self:jianyu_area(pt, caster)
	caster:DoTaskInTime(0.33, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.66, function()
		self:jianyu_area(pt, caster)
	end)
	caster:DoTaskInTime(0.99, function()
		self:jianyu_area(pt, caster)
	end)
        caster.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        if caster.components.health then
            caster.components.health:SetInvincible(true)
        end
    end)
    caster:DoTaskInTime(0.5, function()
		caster.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
        caster.components.locomotor:Stop()
        caster.AnimState:PlayAnimation("idle")

        if caster.components.health then
            caster.components.health:SetInvincible(false)
        end
        caster.components.playercontroller:Enable(true)
        caster:ClearBufferedAction()
    end)
	
end



function Sswordcast:jianyu_area(pt, caster)
	local weapon =  caster.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	local weapondmg = 20
	--if weapon and weapon.components.weapon.damage then
		--weapondmg = weapon.components.weapon.damage
	--end
	local plus_dmg = 20 + caster.level 
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 7)
    for k,v in pairs(ents) do
	if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then
	     v.components.combat.target = caster
		if v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, plus_dmg) end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
end
end
end

--烈火刀法2
function Sswordcast:liehuodaofa_attack2(caster)
    if not caster:HasTag("kakaka") then
    caster:AddTag("kakaka")
    end
	
    caster:ClearBufferedAction()
    caster.components.playercontroller:Enable(false)
    caster.components.locomotor:Stop()	
    if caster.components.driver and caster.components.driver.vehicle then caster.components.driver.vehicle:Show() end

    local pt = Vector3(caster.Transform:GetWorldPosition())
    caster:DoTaskInTime(0.05, function()

    caster:ForceFacePoint(pt.x,pt.y,pt.z)
    caster.AnimState:PlayAnimation("atk")
	--去除特效
	--local toso_leiting = SpawnPrefab("liehuodaofa_toso")
	--toso_leiting.Transform:SetScale(3, 3, 3)
	--toso_leiting.Transform:SetPosition(pt.x, pt.y-0.7, pt.z)

		self:jianyu_area2(pt, caster)
		caster.AnimState:PlayAnimation("chop_loop")
	caster:DoTaskInTime(0.5, function()
		self:jianyu_area2(pt, caster)
	
	end)
	caster:DoTaskInTime(1.5, function()
		self:jianyu_area2(pt, caster)
	
	end)
	caster:DoTaskInTime(2, function()
		self:jianyu_area2(pt, caster)
	
		--去除动作
		--caster.AnimState:PlayAnimation("powerup")
	end)
	--[[
	caster:DoTaskInTime(2.9, function()
		self:jianyu_area2(pt, caster)
    if not caster:HasTag("kakaka") then
    caster:AddTag("kakaka")
    end
	
	end)
    ]]
        caster.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
        if caster.components.health then
            caster.components.health:SetInvincible(true)
        end
    end)
    caster:DoTaskInTime(0.5, function()
		--caster.SoundEmitter:PlaySound("dontstarve/rain/thunder_close")
        caster.components.locomotor:Stop()
        caster.AnimState:PlayAnimation("idle")

        if caster.components.health then
            caster.components.health:SetInvincible(false)
        end
        caster.components.playercontroller:Enable(true)
        caster:ClearBufferedAction()
	if caster:HasTag("kakaka") then
    caster:RemoveTag("kakaka")
    end

    end)	

	
end
--给光元素的
function Sswordcast:jianyu_area2(pt, caster)
	local weapon =  caster.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	local weapondmg = 20
	--if weapon and weapon.components.weapon.damage then
		--weapondmg = weapon.components.weapon.damage
	--end
	local plus_dmg = 4 + caster.level 
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, caster.level/10+5)
    for k,v in pairs(ents) do
	if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then

		if v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, plus_dmg+caster.skill_huo_1) end
	if not caster:HasTag("kakaka") and v.components.combat and v.components.health and not v.components.health:IsDead() then
    caster:AddTag("kakaka")
    end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
end
end
end

--预留给以后用的伤害结算
function Sswordcast:other_area(pt, caster)
	local weapon =  caster.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	local weapondmg = 20
	if weapon and weapon.components.weapon.damage then
		weapondmg = weapon.components.weapon.damage
	end
	local plus_dmg = 2 + caster.level
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 5)
    for k,v in pairs(ents) do
	if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("player") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("toso_role") and not v:HasTag("toso_helper") then
		if v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then v.components.combat:GetAttacked(caster, plus_dmg) end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
end
end
end


return Sswordcast