local assets=
{
	--Asset("ANIM", "anim/amor_ssword.zip"),
    Asset("ANIM", "anim/cloak_fx.zip"),
 	--Asset("IMAGE","images/inventoryimages/amor_ssword.tex"),
	--Asset("ATLAS","images/inventoryimages/amor_ssword.xml")
	
    Asset("ANIM", "anim/armor_weevole.zip"),
 	Asset("IMAGE","images/inventoryimages/amor2_ssword.tex"),
	Asset("ATLAS","images/inventoryimages/amor2_ssword.xml")
}

local prefabs =
{
	"weevole_carapace",
}

local function setsoundparam(inst)
    local param = Remap(inst.components.armor.condition, 0, 0.9,0, 1 ) 
    print(param)
    inst.SoundEmitter:SetParameter( "vortex", "intensity", param )
end

local function spawnwisp(owner)
    local wisp = SpawnPrefab("armorvortexcloak_fx")
    local x,y,z = owner.Transform:GetWorldPosition()
    wisp.Transform:SetPosition(x+math.random()*0.25 -0.25/2,y,z+math.random()*0.25 -0.25/2)    
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "armor_weevole", "swap_body")
    owner.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/equip_off")
	--无僵直
	owner:AddTag("not_hit_stunned")		

	
	
    local function OnBlocked()
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/creatures/pangolden/ball_hit") 
        if inst.components.armor.condition and inst.components.armor.condition > 0 then
            owner:AddChild(SpawnPrefab("vortex_cloak_fx"))    	
        end        

    inst.task2 = inst:DoPeriodicTask(0, function()
    

        if inst.components.armor.condition and inst.components.armor.condition <= 0 then		



	inst.components.equippable.poisonblocker = false
		
	inst.components.equippable.insulated = false
	
	inst.components.equippable.poisongasblocker = false
		end
		

        if inst.components.armor.condition and inst.components.armor.condition > 0 then

    inst.components.equippable.poisonblocker = true
		
	inst.components.equippable.insulated = true
	
	inst.components.equippable.poisongasblocker = true		
		end


    end)
		
		
        setsoundparam(inst)
    end
    inst.OnBlocked = OnBlocked


    inst:ListenForEvent("armorhit", inst.OnBlocked)

    owner.components.inventory:SetOverflow(inst)
    inst.components.container:Open(owner)    
    inst.wisptask = inst:DoPeriodicTask(0.1,function() spawnwisp(owner) end)  

    inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/LP","vortex") 
    setsoundparam(inst)
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    owner.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/equip_on")
	--攻击无僵直取消
	owner:RemoveTag("not_hit_stunned")
  
    inst:RemoveEventCallback("armorhit", inst.OnBlocked)

    owner.components.inventory:SetOverflow(nil)
    inst.components.container:Close(owner)    
    if inst.wisptask then
        inst.wisptask:Cancel()
        inst.wisptask= nil
    end

    inst.SoundEmitter:KillSound("vortex")
end
--2x4
local slotpos = {}
for y = 0, 3 do
    table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
    table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end
--2x6
local slotpos_2x6 = {}
for y = 0, 5 do
	table.insert(slotpos_2x6, Vector3(-162, -y*75 + 170 ,0))
	table.insert(slotpos_2x6, Vector3(-162 +75, -y*75 + 170 ,0))
end
--2x8
local slotpos_2x8 = {}
for y = 0, 6 do
	table.insert(slotpos_2x8, Vector3(-162, -y*75 + 240 ,0))
	table.insert(slotpos_2x8, Vector3(-162 +75, -y*75 + 240 ,0))
end


local function nofuel(inst)

end

local function ontakefuel1(inst)

    if inst.components.armor.condition and inst.components.armor.condition < 0 then
        inst.components.armor:SetCondition(0)

    end
	--inst.components.fueled:DoDelta(150)
    inst.components.armor:SetCondition( inst.components.armor.condition + 300*TUNING.DIFFICULTY )
    --GetPlayer().components.sanity:DoDelta(-TUNING.SANITY_TINY)
    GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/add_fuel")  
	
end

local function ontakefuel2(inst)

    if inst.components.armor.condition and inst.components.armor.condition < 0 then
        inst.components.armor:SetCondition(0)

    end
	--inst.components.fueled:DoDelta(150)
    inst.components.armor:SetCondition( inst.components.armor.condition + 300*2*TUNING.DIFFICULTY )
    --GetPlayer().components.sanity:DoDelta(-TUNING.SANITY_TINY)
    GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/add_fuel")  
	
end

local function ontakefuel3(inst)

    if inst.components.armor.condition and inst.components.armor.condition < 0 then
        inst.components.armor:SetCondition(0)

    end
	--inst.components.fueled:DoDelta(150)
    inst.components.armor:SetCondition( inst.components.armor.condition + 300*3*TUNING.DIFFICULTY )
    --GetPlayer().components.sanity:DoDelta(-TUNING.SANITY_TINY)
    GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/vortex_armour/add_fuel")  
	
end

local function itemtest(inst, item, slot)
	return not item:HasTag("notbackpack") and not item.components.health
end

local function common_fn()
	local inst = CreateEntity()
    
    inst.entity:AddTransform()
    inst.entity:AddSoundEmitter()
    inst.entity:AddAnimState()
	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "amor2_ssword.tex" )
	
    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "idle_water", "anim")    

    --local minimap = inst.entity:AddMiniMapEntity()
    --minimap:SetIcon( "amor_ssword.png" )
	


    inst:AddTag("notbackpack")
    
    inst.AnimState:SetBank("armor_weevole")
    inst.AnimState:SetBuild("armor_weevole")
    inst.AnimState:PlayAnimation("anim")
        
    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")    
    inst.components.inventoryitem.cangoincontainer = true
	inst.components.inventoryitem.imagename = "amor2_ssword"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/amor2_ssword.xml"
    inst.components.inventoryitem.foleysound = "dontstarve_DLC003/common/crafted/vortex_armour/foley"
	--inst.components.inventoryitem.foleysound = "dontstarve_DLC003/creatures/pangolden/ball_hit"  --走路声音
	--inst.components.inventoryitem.foleysound = "dontstarve_DLC002/common/foley/seashell_suit"

    inst:AddComponent("container")




    inst:AddComponent("armor")

    --inst.components.armor:SetImmuneTags({"shadow"})
    --inst.components.armor.bonussanitydamage = 0.3
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    --inst.components.equippable.dapperness = TUNING.CRAZINESS_MED
	
    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(TUNING.WATERPROOFNESS_HUGE)
	
    inst:AddComponent("windproofer")
    inst.components.windproofer:SetEffectiveness(TUNING.WINDPROOFNESS_HUGE)
	
    inst.components.equippable.poisonblocker = true
		
	inst.components.equippable.insulated = true
	
	inst.components.equippable.poisongasblocker = true
	
    
    return inst
end

local function fxfn()
    local inst = CreateEntity()
    
    inst.entity:AddTransform()
    inst.entity:AddSoundEmitter()
    inst.entity:AddAnimState()

    inst.AnimState:SetBank("cloakfx")
    inst.AnimState:SetBuild("cloak_fx")
    inst.AnimState:PlayAnimation("idle",true)    

    inst:AddTag("fx")

    for i=1,14 do
        inst.AnimState:Hide("fx"..i)
    end
    inst.AnimState:Show("fx"..math.random(1,14))

    inst:ListenForEvent("animover", function() inst:Remove() end) 
	


    return inst
end

local function armor_ssword1_fn(inst)
    local inst = common_fn(inst)

    inst.components.armor:InitCondition(800*TUNING.DIFFICULTY, 0.9)
    inst.components.armor.dontremove = true

    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "NIGHTMARE"
    inst.components.fueled:InitializeFuelLevel(4 * TUNING.LARGE_FUEL)
    inst.components.fueled.ontakefuelfn = ontakefuel1
    inst.components.fueled.accepting = true

    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_backpack_2x4"
    inst.components.container.widgetpos = Vector3(-5,-70,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "pack"
    
	return inst
end	

local function armor_ssword2_fn(inst)
    local inst = common_fn(inst)

    inst.components.armor:InitCondition(800*2*TUNING.DIFFICULTY, 0.9)
    inst.components.armor.dontremove = true

    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "NIGHTMARE"
    inst.components.fueled:InitializeFuelLevel(4*2 * TUNING.LARGE_FUEL)
    inst.components.fueled.ontakefuelfn = ontakefuel2
    inst.components.fueled.accepting = true

    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos_2x6)
    inst.components.container.widgetslotpos = slotpos_2x6
    inst.components.container.widgetanimbank = "ui_piggyback_2x6"
    inst.components.container.widgetanimbuild = "ui_piggyback_2x6"
    inst.components.container.widgetpos = Vector3(-5,-50,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "pack"

	return inst
end	

local function armor_ssword3_fn(inst)
    local inst = common_fn(inst)

    inst.components.armor:InitCondition(800*3*TUNING.DIFFICULTY, 0.9)
    inst.components.armor.dontremove = true

    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "NIGHTMARE"
    inst.components.fueled:InitializeFuelLevel(4*3 * TUNING.LARGE_FUEL)
    inst.components.fueled.ontakefuelfn = ontakefuel3
    inst.components.fueled.accepting = true

    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos_2x8)
    inst.components.container.widgetslotpos = slotpos_2x8
    inst.components.container.widgetanimbank = "ui_krampusbag_2x8"
    inst.components.container.widgetanimbuild = "ui_krampusbag_2x8"
    inst.components.container.widgetpos = Vector3(-5,-75,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "pack"

	return inst
end	

return Prefab( "common/inventory/armor_ssword", armor_ssword1_fn, assets),
       Prefab( "common/inventory/armor_ssword2", armor_ssword2_fn, assets),
       Prefab( "common/inventory/armor_ssword3", armor_ssword3_fn, assets),
        Prefab( "common/inventory/armorvortexcloak_fx", fxfn, assets) 
