local assets =
{
    Asset("ANIM", "anim/chuizi.zip"),
    Asset("ANIM", "anim/swap_chuizi.zip"),
	Asset("IMAGE","images/inventoryimages/chuizi.tex"),
	Asset("ATLAS","images/inventoryimages/chuizi.xml")
}




local function onAttackchuizi(inst, owner, target)

	if target:HasTag("largecreature") then
	--target.components.health:DoDelta(- 20 - owner.level*20)
	--attacker.components.hunger:DoDelta(5)
	--attacker.components.sanity:DoDelta(20)
	--owner.components.health:DoDelta(+5)
	--local x, y, z = target.Transform:GetWorldPosition()
	--local fx = SpawnPrefab("moose_nest_fx_idle")
	--fx.Transform:SetPosition(x, y, z)
    else 
    
	--attacker.components.health:DoDelta(2)
	--attacker.components.hunger:DoDelta(5)
	--attacker.components.sanity:DoDelta(20)
	--attacker.components.health:DoDelta(5)
	--target.components.health:DoDelta(-20)
        --attacker.components.hunger:DoDelta(-2)
	
    end

end




--装备
local function onequip(inst, owner)

    owner.AnimState:OverrideSymbol("swap_object", "swap_chuizi", "swap_futou")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")

	
end

local function onunequip(inst, owner)

    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")

end








local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    --inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)
	
    inst.AnimState:SetBank("futou")
    inst.AnimState:SetBuild("chuizi")
    inst.AnimState:PlayAnimation("idle")
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "chuizi.tex" )
	--inst:AddTag("shadow")
	--inst:AddTag("feng")
    inst:AddTag("sharp")
    inst:AddTag("weapon_sword")
    inst:AddTag("weapon_rude")
    --inst:AddTag("extinguisher")
	


    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(13)

    -------
    inst.components.weapon:SetRange(0.5)
    inst.components.weapon:SetOnAttack(onAttackchuizi)


	
    inst:AddComponent("inspectable")
	

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "chuizi"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/chuizi.xml"
	--inst.components.inventoryitem.nobounce = true
	--inst.components.inventoryitem.keepondeath = true

	
	inst:AddComponent("talker")
    inst.components.talker.fontsize = 36
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4)
    inst.components.talker.offset = Vector3(0, 0, 0)
    inst.components.talker.symbol = "swap_object"
	inst.Transform:SetScale(1.5,1.5,1.5)
	
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    --inst.components.equippable.dapperness = 20/60
	
    inst:AddComponent("tool")
    --if SaveGameIndex:IsModeShipwrecked() or SaveGameIndex:IsModePorkland() then 
    --inst.components.tool:SetAction(ACTIONS.HACK,6)
	--end
    --inst.components.tool:SetAction(ACTIONS.CHOP, 5)
    --inst.components.tool:SetAction(ACTIONS.MINE, 8)
    inst.components.tool:SetAction(ACTIONS.HAMMER, 1)

 
	
    return inst
end

return Prefab( "common/inventory/chuizi", fn, assets)