require "prefabutil"
local assets =
{
	Asset("ANIM", "anim/inventoryanim/jiandai.zip"),
	Asset("ANIM", "anim/inventoryanim/hat_hulu.zip"),
	Asset("ANIM", "anim/ui_chest_3x3.zip"),
	Asset("ANIM", "anim/ui_chester_shadow_3x4.zip"),
    Asset("ATLAS", "images/inventoryimages/hulu.xml"),
    Asset("IMAGE", "images/inventoryimages/hulu.tex"),
}
--[[
--烤箱功能
local function cooked(inst)

	local container = inst.components.container

		for i = 1, container:GetNumSlots() do
	        local item = container:GetItemInSlot(i)
	     	if item then 
	     		local replacement = nil 
				if item.components.cookable or item.prefab == "log" then 
				inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel") 

		
				end
				
		     	if item.components.cookable then 
		     		replacement = item.components.cookable:GetProduct()
	     	    elseif item.components.edible and item.components.perishable then
                   --如果是烧烤过的或者熟的食物则刷新保鲜度	
                    item.components.perishable.perishremainingtime = item.components.perishable.perishtime
		     	elseif item.prefab == "log" then 
		     		replacement = "charcoal"
					
		     	elseif item.components.burnable and not item.prefab == "log" then 
		     	--elseif item.prefab == "twigs" and item.prefab == "cutgrass" then 
		     		replacement = "ash"				
		     	end  
		     	if replacement then 
	     			local stacksize = 1 
	     			if item.components.stackable then 
	     				stacksize = item.components.stackable:StackSize()
	     			end 
	     			local newprefab = SpawnPrefab(replacement)
	     			if newprefab.components.stackable then 
	     				newprefab.components.stackable:SetStackSize(stacksize)
	     			end 
	     			container:RemoveItemBySlot(i)
	     			item:Remove()
	     			container:GiveItem(newprefab, i)
	     		end 
		     end 
			 

			 
		end 
		return false 

end	
]]

local function cooked(inst)

	local container = inst.components.container

		for i = 1, container:GetNumSlots() do
	        local item = container:GetItemInSlot(i)
	     	if item then 
			local replacement = nil 
            if item.prefab == "twigs" then 
			replacement = "ash"
			end
            if item.prefab == "cutgrass" then 
			replacement = "ash"
			end
            if item.prefab == "coffeebeans" then 
			replacement = "coffeebeans_cooked"
			end
            if item.prefab == "monstermeat" then 
			replacement = "meat"
			end
            if item.prefab == "plantmeat" then 
			replacement = "meat"
			end
            if item.prefab == "cookedmonstermeat" then 
			replacement = "cookedmeat"
			end
            if item.prefab == "plantmeat_cooked" then 
			replacement = "cookedmeat"
			end
            if item.prefab == "froglegs" then 
			replacement = "smallmeat"
			end
            if item.prefab == "froglegs_cooked" then 
			replacement = "cookedsmallmeat"
			end
			
            --if item.prefab == "berries" then 
			--replacement = "coffeebeans_cooked"
			--end
            if TUNING.SDLC ==3 and item.prefab == "beefalohat" then 
			replacement = "gasmaskhat"
			end
            if TUNING.SDLC ==2 and item.prefab == "beefalohat" then 
			replacement = "snakeskinhat"
			end
            if TUNING.SDLC ==1 and item.prefab == "gasmaskhat" then 
			replacement = "beefalohat"
			end
            if TUNING.SDLC ==2 and item.prefab == "gasmaskhat" then 
			replacement = "snakeskinhat"
			end
            if TUNING.SDLC ==1 and item.prefab == "snakeskinhat" then 
			replacement = "beefalohat"
			end
            if TUNING.SDLC ==3 and item.prefab == "snakeskinhat" then 
			replacement = "gasmaskhat"
			end
		     	if replacement then 
	     			local stacksize = 1 
	     			if item.components.stackable then 
	     				stacksize = item.components.stackable:StackSize()
	     			end 
	     			local newprefab = SpawnPrefab(replacement)
	     			if newprefab.components.stackable then 
	     				newprefab.components.stackable:SetStackSize(stacksize)
	     			end 
	     			container:RemoveItemBySlot(i)
	     			item:Remove()
	     			container:GiveItem(newprefab, i)
	     		end 			
			
				if item.components.perishable then 
                --如果是则刷新保鲜度	
                if item.prefab ~= "hambat" then 			--火腿棍除外	
                item.components.perishable.perishremainingtime = item.components.perishable.perishtime	
                end				
				
				--inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel") 

		
				end


		    end 
			 

			 
		end 
		return false 

end	
---ORANGE
local function SpawnEffect(inst)
    local pt = inst:GetPosition()
    local fx = SpawnPrefab("small_puff")
    fx.Transform:SetPosition(pt.x, pt.y, pt.z)
    fx.Transform:SetScale(0.5,0.5,0.5)
end

local function getitem(player, amulet, item)
    --Amulet will only ever pick up items one at a time. Even from stacks.
    SpawnEffect(item)
    --amulet.components.finiteuses:Use(1)
    
    if item.components.stackable then
        item = item.components.stackable:Get()
    end
    
    if item.components.trap and item.components.trap:IsSprung() then
        item.components.trap:Harvest(player)
        return
    end
    
    player.components.inventory:GiveItem(item)
end

local function pickup(inst, owner)
    local pt = owner:GetPosition()
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 5)

    for k,v in pairs(ents) do
        if v.components.inventoryitem and v.components.inventoryitem.canbepickedup and v.components.inventoryitem.cangoincontainer and not
            v.components.inventoryitem:IsHeld() and v.prefab ~= "toso_packim" and v.prefab ~= "toso_xiang" then

            if not owner.components.inventory:IsFull() then
                --Your inventory isn't full, you can pick something up.
                getitem(owner, inst, v)
                return

            elseif v.components.stackable then
                --Your inventory is full, but the item you're trying to pick up stacks. Check for an exsisting stack.
                --An acceptable stack should: Be of the same item type, not be full already and not be in the "active item" slot of inventory.
                local stack = owner.components.inventory:FindItem(function(item) return (item.prefab == v.prefab and not item.components.stackable:IsFull()
                    and item ~= owner.components.inventory.activeitem) end)
                if stack then
                    getitem(owner, inst, v)
                    return
                end
            end
        end
    end
    
end

local function onequip(inst, owner) 

    owner.AnimState:OverrideSymbol("swap_hat", "hat_hulu", "swap_hat")

    owner.AnimState:Show("HAT")
    owner.AnimState:Show("HAT_HAIR")
    owner.AnimState:Hide("HAIR_NOHAT")
    owner.AnimState:Hide("HAIR")

    inst.task = inst:DoPeriodicTask(0.2, function() pickup(inst, owner) end)
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("HAT")
    owner.AnimState:Hide("HAT_HAIR")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")
    --owner.AnimState:ClearOverrideSymbol("swap_body")
    if inst.task then inst.task:Cancel() inst.task = nil end
end

local function onopen(inst)
	inst.AnimState:PlayAnimation("idle", false)
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
end

local function onclose(inst)
	inst.AnimState:PlayAnimation("idle", false)
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
      cooked(inst)
end
--[[
--4格子
local slotpos = {}
for y = 0, 3 do
	table.insert(slotpos, Vector3(-162 +(75/2), -y*75 + 114 ,0))
end
]]
local slotpos = {}

for y = 2, 0, -1 do
	for x = 0, 2 do
		table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
	end
end

local slotpos_3x4 = {}

for y = 2.5, -0.5, -1 do
	for x = 0, 2 do
		table.insert(slotpos_3x4, Vector3(75*x-75*2+75, 75*y-75*2+75,0))
	end
end

local function itemtest(inst, item, slot)
	return not item:HasTag("notbackpack") and not item.components.health
end

local function fn()
	local inst = CreateEntity()
	inst:AddTag("fridge")
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    --inst.entity:AddMiniMapEntity()

	--inst.backpack_level = 0
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "hulu.tex" )
	
    inst.AnimState:SetBank("jiandai")
    inst.AnimState:SetBuild("jiandai")
    inst.AnimState:PlayAnimation("idle")

    --inst.MiniMapEntity:SetIcon("backpack.png")
    
    --inst.foleysound = "dontstarve/movement/foley/backpack"
    
	inst:AddTag("huluPerishMult")
	inst.huluPerishMult = TUNING.PERISH 

    inst:AddTag("notbackpack")	
	
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	--inst.components.inventoryitem.keepondeath = true
	inst.components.inventoryitem.imagename = "hulu"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/hulu.xml"
	inst.components.inventoryitem.cangoincontainer = true

	inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    inst.components.equippable.equipslot = EQUIPSLOTS.NECK or EQUIPSLOTS.HEAD

    inst:AddComponent("container")
    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos_3x4)
    inst.components.container.onopenfn = onopen
	inst.components.container.onclosefn = onclose
    inst.components.container.widgetslotpos = slotpos_3x4
	inst.components.container.widgetanimbank = "ui_chester_shadow_3x4"
	inst.components.container.widgetanimbuild = "ui_chester_shadow_3x4"
	inst.components.container.widgetpos = Vector3(0,220,0)
    inst.components.container.side_align_tip = 160
    --inst.components.container.side_widget = true
    --inst.components.container.type = "pack"
	--inst.components.container.widgetbuttoninfo = widgetbuttoninfo
--[[
TheInput:AddKeyUpHandler(KEY_1, function()
if not IsPaused() then


if inst.open then
inst.components.container:Close()
else
inst.components.container:Open()
end

end
end)  
]]
	
	if SaveGameIndex:IsModeShipwrecked() then
  
	MakeInventoryFloatable(inst, "idle_water", "idle")
    end	

    return inst
end

return Prefab("common/inventory/hulu1", fn, assets)