require "prefabutil"

local assets =
{
Asset("ANIM", "anim/jianzhong.zip"),
Asset("IMAGE", "images/inventoryimages/jianzhong.tex"),
Asset("ATLAS", "images/inventoryimages/jianzhong.xml"),
}

local prefabs = 
{
}

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", true)
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", true)
end

local slotpos = {}
for y = 0, 1 do
	table.insert(slotpos, Vector3(-162 +(75/2), -y*75 + 114 ,0))
end

local function itemtest(inst, item, slot)
    if item.prefab == "sheath" or "purplegem" then
       return true
    end
    return false
end

--function Container:GetItemByName(item, amount)

local widgetbuttoninfo = {
    text = "锻造",
    position = Vector3(-125, -40, 0),

    fn = function(inst)
		local player = GetPlayer()
        local item = inst.components.container.slots[1] or inst.components.container.slots[2]
		local keqianghua = false
		local weapon_upgrade_chance = 1
	if not item then
		GetPlayer().components.talker:Say("没有物品")


	elseif item.prefab == "surfboard_item_toso" then

		   if item and inst.components.container:Has("dragonpie", 5) then
              if player.weapon_adddmg and player.weapon_adddmg < 100 then
			   	player.weapon_adddmg = player.weapon_adddmg + 1--提升------
				
			    inst.components.container:ConsumeByName("dragonpie", 5)
			    --inst.components.container:DropItem(item)
		        --inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大攻击力上限")
			  end
		   elseif item and inst.components.container:Has("woodlegs_key1", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("woodlegs_key1", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end	   
		   elseif item and inst.components.container:Has("woodlegs_key2", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("woodlegs_key2", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end			   
		   elseif item and inst.components.container:Has("woodlegs_key3", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("woodlegs_key3", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end		
		   elseif item and inst.components.container:Has("pugalisk_skull", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("pugalisk_skull", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end	
		   elseif item and inst.components.container:Has("turbine_blades", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("turbine_blades", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end	
		   elseif item and inst.components.container:Has("dragon_scales", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("dragon_scales", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end	
		   elseif item and inst.components.container:Has("deerclops_eyeball", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("deerclops_eyeball", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end	
		   elseif item and inst.components.container:Has("bearger_fur", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("bearger_fur", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end
		   elseif item and inst.components.container:Has("minotaurhorn", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("minotaurhorn", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end
		   elseif item and inst.components.container:Has("quackenbeak", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("quackenbeak", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end
		   elseif item and inst.components.container:Has("cane", 1) then
              if player.weapon_defense and player.weapon_defense < 0.6 then
	            --player.weapon_defense = player.weapon_defense + 0.02--无视防御------
			    inst.components.container:ConsumeByName("cane", 1)
			    inst.components.container:DropItem(item)
		        inst.components.container:Close()
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")
			  else
			    GetPlayer().components.talker:Say("已达到最大破甲上限")
			  end
			  
			  
		   end
		   
    elseif item.prefab == "armor_ssword" then
		
		   if item and inst.components.container:Has("san", 1) then

				
			    inst.components.container:ConsumeByName("armor_ssword", 1)
				inst.components.container:ConsumeByName("san", 1)
                local nug = SpawnPrefab("armor_ssword2")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			    inst.components.container:Close()
				
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")

           else
			    GetPlayer().components.talker:Say("需要天眼升级")
           end		   
    elseif item.prefab == "armor_ssword2" then
		
		   if item and inst.components.container:Has("san", 1) then

			    inst.components.container:ConsumeByName("armor_ssword2", 1)				
			    inst.components.container:ConsumeByName("san", 1)
                local nug = SpawnPrefab("armor_ssword3")
                local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
                nug.Transform:SetPosition(pt:Get())
                local down = TheCamera:GetDownVec()
                local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
                --local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
                local sp = math.random()*4+2
                nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))					   
			    inst.components.container:Close()
				
				inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
				local fx = SpawnPrefab("collapse_small")
				local pos = Vector3(inst.Transform:GetWorldPosition())
				fx.Transform:SetScale(0.5, 0.5, 0.5)
				fx.Transform:SetPosition(pos:Get())
	
                local fx2 = SpawnPrefab("small_puff")
                fx2.entity:SetParent(inst.entity)
	            fx2.Transform:SetPosition(0, 3, 0)
			    GetPlayer().components.talker:Say("恭喜！锻造成功")

           else
			    GetPlayer().components.talker:Say("需要天眼升级")
           end	
	end



end}

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	trans:SetScale(2.0, 2.0, 2.0)
	MakeObstaclePhysics(inst, 1)

	local light = inst.entity:AddLight()
	inst.Light:SetRadius(3.5)
	inst.Light:SetFalloff(0.85)
	inst.Light:SetIntensity(.85)
--	inst.Light:SetColour(255/255, 0/255, 255/255)
	inst.Light:Enable(true)

	anim:SetBank("jianzhong")
	anim:SetBuild("jianzhong")
	anim:PlayAnimation("idle", true)

	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "jianzhong.tex" )
	
	inst:AddTag("structure")
	inst:AddComponent("lootdropper")
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)

	inst:AddComponent("inspectable")

    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetpos = Vector3(0,150,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.itemtestfn = itemtest
    inst.components.container.widgetbuttoninfo = widgetbuttoninfo
    inst.components.container.canbeopened = true
    inst.components.container.onopenfn = function(inst) GetPlayer().SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open") end
    inst.components.container.onclosefn = function(inst) GetPlayer().SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open") end
	--inst.SoundEmitter:PlaySound("dontstarve/common/craftable/icebox_open")
	MakeSnowCovered(inst, .01) 
	inst:ListenForEvent("onbuilt", onbuilt)
	inst:ListenForEvent( "daytime", function() inst.Light:Enable(true) end , GetWorld() )
	inst:ListenForEvent( "dusktime", function() inst.Light:Enable(false) end , GetWorld() )
--------------------------------------

return inst
end

return Prefab( "common/jianzhong", fn, assets),
       MakePlacer("common/jianzhong_placer", "jianzhong", "jianzhong", "idle" ) 