local assets = 
{
	Asset("ANIM", "anim/fx/jianyu.zip"),
	Asset("ANIM", "anim/fx/ziwen.zip"),
	Asset("ANIM", "anim/fx/jianyu2.zip"),
}

local function OnThrown(inst, owner, target)
	inst:FacePoint(Point(target.Transform:GetWorldPosition()))
	GetPlayer().SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
end

local function OnHit(inst, owner, target)
    inst:Remove()
    inst.SoundEmitter:PlaySound("dontstarve/creatures/bishop/shotexplo")
end


--[[
local function OnHit(inst, owner, target)
    local impactfx = SpawnPrefab("impact")
    if impactfx then
	    local follower = impactfx.entity:AddFollower()
	    follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
        impactfx:FacePoint(inst.Transform:GetWorldPosition())
    end
    inst:Remove()
end
]]




local function ziwen(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("ziwen")
    anim:SetBuild("ziwen")
    anim:PushAnimation("idle", true)
    trans:SetScale(2.5, 2.5, 2.5)

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:ListenForEvent("animover", function() inst:Remove() end)

    return inst
end



local function jianyu()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("jianyu")
    anim:SetBuild("jianyu")
	anim:PlayAnimation("idle")
	anim:PushAnimation("idle", true)
    inst.Transform:SetFourFaced()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    trans:SetScale(4, 4, 4)

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
	
    return inst
end

local function jianyu2()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("jianyu2")
    anim:SetBuild("jianyu2")
	anim:PlayAnimation("idle")
	anim:PushAnimation("idle", true)
    inst.Transform:SetFourFaced()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    trans:SetScale(4, 4, 4)

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
	
    return inst
end
--Prefab( "common/nature_wave", nature_wave, assets),

return Prefab( "common/jianyu", jianyu, assets),
       Prefab( "common/jianyu2", jianyu2, assets),
       Prefab( "common/ziwen",ziwen, assets)
