local assets =
{
	Asset("ANIM", "anim/miji.zip"),
	Asset("IMAGE", "images/inventoryimages/miji.tex"),
	Asset("ATLAS", "images/inventoryimages/miji.xml"),
}

local prefabs =
{
    "book_fx",
}

local function onfinished(inst) --耐久为零
	--删除物品
    inst:Remove()
end

function reaper(inst, reader)
    --reader.components.sanity:DoDelta(-math.random(20,50))
	--reader.components.health:DoDelta(-math.random(10,25))

    local pos = Vector3(inst.Transform:GetWorldPosition())
    local range = 30
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z,range)
        for k,v in pairs(ents) do
            if v.components.pickable and v.prefab ~= "flower" and v.prefab ~= "flower_evil"  then
                v.components.pickable:Pick(GetPlayer())
            end
			
            if v.components.crop then   --收获作物
                v.components.crop:Harvest(GetPlayer())
            end
			


	    end
	return true
end




    local function fn(Sim)
        local inst = CreateEntity()

        local inst = CreateEntity()
    	local trans = inst.entity:AddTransform()
    	local anim = inst.entity:AddAnimState()
        local sound = inst.entity:AddSoundEmitter()

        MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("miji")
    inst.AnimState:SetBuild("miji")
    inst.AnimState:PlayAnimation("idle")
		
if SaveGameIndex:IsModeShipwrecked() then
	MakeInventoryFloatable(inst, "idle_water", "idle")
end

        inst:AddComponent("inspectable")
        inst:AddComponent("book")
        inst.components.book.onread = reaper

        inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "miji"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/miji.xml"
		
        inst:AddComponent("finiteuses")
        inst.components.finiteuses:SetMaxUses(10)
        inst.components.finiteuses:SetUses(10)
        inst.components.finiteuses:SetOnFinished(onfinished)
		
		
		
        MakeSmallPropagator(inst)

        return inst
    end

return Prefab("common/inventory/shouhuo", fn, assets, prefabs)

