local assets = 
{
	Asset("ANIM", "anim/fx/zhiliao.zip"),
	Asset("ANIM", "anim/fx/baofengxue.zip"),
	Asset("ANIM", "anim/fx/dilie.zip"),
	Asset("ANIM", "anim/fx/baoliehuoyan_toso.zip"),
	Asset("ANIM", "anim/fx/liehuodaofa_toso.zip"),
	Asset("ANIM", "anim/fx/baguadun.zip"),
	Asset("ANIM", "anim/fx/ziwen.zip"),
	Asset("ANIM", "anim/fx/shaistate.zip"),
	Asset("ANIM", "anim/fx/liekaitexiao.zip"),
	Asset("ANIM", "anim/prj_huan.zip"),
	Asset("ANIM", "anim/zg_fx_mihawkhsqj.zip"),
	Asset("ANIM", "anim/toso_baoji.zip"),
	Asset("ANIM", "anim/abigail_shield.zip"),
	

}

local ss_assets = 
{

	Asset("ANIM", "anim/ssdilie.zip"),

}



local function OnThrown(inst, owner, target)
	inst:FacePoint(Point(target.Transform:GetWorldPosition()))
	GetPlayer().SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
end

local function OnHit(inst, owner, target)
    inst:Remove()
    inst.SoundEmitter:PlaySound("dontstarve/creatures/bishop/shotexplo")
end

--煞气特效
local function shaistate(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("shaistate")
    anim:SetBuild("shaistate")
    anim:PushAnimation("idle", true)

	anim:SetLayer( LAYER_BACKGROUND )
    anim:SetSortOrder( 3 )
    trans:SetScale(1, 1, 1)

    --inst:AddComponent("lighttweener")
    --local light = inst.entity:AddLight()
    --inst.components.lighttweener:StartTween(light, 0, .9, 0.9, {1,1,1}, 0)
    --inst.components.lighttweener:StartTween(nil, 3, .9, 0.9, nil, .2)
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    return inst
end



local function ziwen(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("ziwen")
    anim:SetBuild("ziwen")
    anim:PushAnimation("idle", true)
    trans:SetScale(2.5, 2.5, 2.5)

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:ListenForEvent("animover", function() inst:Remove() end)

    return inst
end

local function baguadun(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("baguadun")
    anim:SetBuild("baguadun")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("idle", true)

	anim:SetLayer( LAYER_BACKGROUND )
    anim:SetSortOrder( 3 )
    trans:SetScale(5, 5, 5)
	
    inst:AddComponent("lighttweener")
    local light = inst.entity:AddLight()
    inst.components.lighttweener:StartTween(light, 0, .9, 0.9, {1,1,1}, 0)
    inst.components.lighttweener:StartTween(nil, 3, .9, 0.9, nil, .2)
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end

local function liehuodaofa_toso(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("liehuodaofa_toso")
    anim:SetBuild("liehuodaofa_toso")
	anim:PlayAnimation("idle")
    anim:PushAnimation("idle", true)

	anim:SetLayer( LAYER_BACKGROUND )
    anim:SetSortOrder( 3 )
    trans:SetScale(1, 1, 1)

    --inst:AddComponent("lighttweener")
    --local light = inst.entity:AddLight()
    --inst.components.lighttweener:StartTween(light, 0, .9, 0.9, {1,1,1}, 0)
    --inst.components.lighttweener:StartTween(nil, 3, .9, 0.9, nil, .2)
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end



local function baoliehuoyan_toso(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("baoliehuoyan_toso")
    anim:SetBuild("baoliehuoyan_toso")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("idle")

    trans:SetScale(3, 3, 3)
    --inst.Transform:SetFourFaced()
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end

local function dilie_toso(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("dilie")
    anim:SetBuild("dilie")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("loops")

    trans:SetScale(1, 1, 1)
    --inst.Transform:SetFourFaced()
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end


local function ssdilie(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("dilie")
    anim:SetBuild("ssdilie")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("dilie")

    trans:SetScale(1, 1, 1)
    --inst.Transform:SetFourFaced()
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end




local function baofengxue()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("baofengxue")
    anim:SetBuild("baofengxue")
	anim:PlayAnimation("idle")
	anim:PushAnimation("idle", true)
    inst.Transform:SetFourFaced()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    trans:SetScale(4, 4, 4)

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
	
    return inst
end



local function zhiliao()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("deer_ice_flakes")
    anim:SetBuild("zhiliao")
	anim:PlayAnimation("pst")
	anim:PushAnimation("pst", true)
    --inst.Transform:SetFourFaced()
    --MakeInventoryPhysics(inst)
    --RemovePhysicsColliders(inst)

    trans:SetScale(1, 1, 1)

	inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
	
    return inst
end

local function liekaitexiao(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("liekaitexiao")
    anim:SetBuild("liekaitexiao")
    anim:PushAnimation("idle", true)
    trans:SetScale(2.5, 2.5, 2.5)

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")
    inst:ListenForEvent("animover", function() inst:Remove() end)

    return inst
end

local function sanqianyueren(Sim)



    local inst = CreateEntity()

    inst.entity:AddTransform()
	inst.Transform:SetScale(1.25,1.25,1.25)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()

    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("prj_huan")
    inst.AnimState:SetBuild("prj_huan")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("fx")


    --inst.persists = false
	
	----物理
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 2
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","companion","ssword"})
		
		for k,v in pairs(ents) do
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					local player = GetPlayer()
					v.components.combat:GetAttacked(inst, TUNING.ARM_RPGDAMAGE + 2*player.level)
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(1.5, function()
		if inst then 
			inst:Remove()
		end
	end)
	
    return inst
end

--冲击波
local function hengsao_fx(Sim)
    local inst = CreateEntity()

    inst.entity:AddTransform()
	local s=1
	inst.Transform:SetScale(s,s,s)
	
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()


    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)

    --inst.Transform:SetFourFaced()

    inst.AnimState:SetBank("zg_fx_mihawkhsqj")
    inst.AnimState:SetBuild("zg_fx_mihawkhsqj")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
    inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetAddColour(0, 1, 1, 0)

    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

	
	----物理
	local period = 1/30
	inst.collide_task_table = {}
	inst:DoPeriodicTask(period, function()
	
		local pt = inst:GetPosition()	
		local r = 3
		local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, r, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO", "shadow", "shadowboss","companion","ssword"})
		
		for k,v in pairs(ents) do
		
		if TUNING.AIWUXIANKANSHU == 1 then
		--砍树
		    if v and not v:HasTag("structure") and v.components.workable and v.components.workable.workleft > 0 then
                       SpawnPrefab("explode_small").Transform:SetPosition(v:GetPosition():Get())        
                       v.components.workable:Destroy(inst)
            end
		end
		
		
		
			if v and v.components.health and not v.components.health:IsDead() and v.components.combat then
				
				if not table.contains(inst.collide_task_table, v.GUID) then
					local player = GetPlayer()
					v.components.combat:GetAttacked(inst, TUNING.ARM_RPGDAMAGE + 2*player.level)
					SpawnPrefab("explode_small").Transform:SetPosition(v:GetPosition():Get())
					inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/items/weapon/halberd")
					table.insert(inst.collide_task_table, v.GUID)
				end
				
			end
		end
		
	end)
	
	inst:DoTaskInTime(3, function()
		if inst then 
			inst:Remove()
		end
	end)

    return inst
end

local function toso_baojifn(Sim)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    inst.AnimState:SetBuild("toso_baoji")
    inst.AnimState:SetBank("laser_explosion")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("NOCLICK")
    inst:AddTag("FX")
    inst:AddTag("laser")

    inst.Transform:SetScale(0.85,0.85,0.85)

    inst:ListenForEvent("animover", function(inst) inst:Remove() end)

    return inst
end

--护盾出现
local function dunappear(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("abigail_shield")
    anim:SetBuild("abigail_shield")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("shield")

	--anim:SetLayer( LAYER_BACKGROUND )
    --anim:SetSortOrder( 3 )
    trans:SetScale(0.8, 0.8, 0.8)
	
    inst:AddComponent("lighttweener")
    local light = inst.entity:AddLight()
    inst.components.lighttweener:StartTween(light, 0, .9, 0.9, {1,1,1}, 0)
    inst.components.lighttweener:StartTween(nil, 3, .9, 0.9, nil, .2)
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end

--护盾消耗
local function dunconsume(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("abigail_shield")
    anim:SetBuild("abigail_shield")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("shield_buff")

	--anim:SetLayer( LAYER_WORLD_BACKGROUND )
    --anim:SetSortOrder( 3 )
    trans:SetScale(0.8, 0.8, 0.8)
	
    inst:AddComponent("lighttweener")
    local light = inst.entity:AddLight()
    inst.components.lighttweener:StartTween(light, 0, .9, 0.9, {1,1,1}, 0)
    inst.components.lighttweener:StartTween(nil, 3, .9, 0.9, nil, .2)
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end

--护盾消耗爱2
local function dunconsume2(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    anim:SetBank("abigail_shield")
    anim:SetBuild("abigail_shield")
	--anim:PlayAnimation("idle")
    anim:PushAnimation("shield_retaliation")

	--anim:SetLayer( LAYER_BACKGROUND )
    --anim:SetSortOrder( 3 )
    trans:SetScale(0.8, 0.8, 0.8)
	
    inst:AddComponent("lighttweener")
    local light = inst.entity:AddLight()
    inst.components.lighttweener:StartTween(light, 0, .9, 0.9, {1,1,1}, 0)
    inst.components.lighttweener:StartTween(nil, 3, .9, 0.9, nil, .2)
    inst:AddTag("FX")
	inst:AddTag("NOCLICK")

    inst:ListenForEvent("animover", function() inst:Remove() end)
    return inst
end

--Prefab( "common/nature_wave", nature_wave, assets),

return Prefab( "common/shaistate",shaistate, assets), 
	   Prefab( "common/zhiliao", zhiliao, assets),
       Prefab( "common/baofengxue", baofengxue, assets),
       Prefab( "common/dilie_toso",dilie_toso, assets),
       Prefab( "common/ssdilie",ssdilie, ss_assets),
       Prefab( "common/sanqianyueren",sanqianyueren, assets),
       Prefab( "common/hengsao_fx",hengsao_fx, assets),
       Prefab( "common/baoliehuoyan_toso",baoliehuoyan_toso, assets),
       Prefab( "common/baguadun",baguadun, assets),
       Prefab( "common/ziwen",ziwen, assets),
       Prefab( "common/liekaitexiao",liekaitexiao, assets),
       Prefab( "common/toso_baoji", toso_baojifn, assets),
       Prefab( "common/liehuodaofa_toso",liehuodaofa_toso, assets),
       Prefab( "common/dunappear",dunappear, assets),
       Prefab( "common/dunconsume",dunconsume, assets),
       Prefab( "common/dunconsume2",dunconsume2, assets)	   
