local assets =
{
    Asset("ANIM", "anim/weapon/sword_4.zip"),
    Asset("ANIM", "anim/weapon/swap_sword_4.zip"),
	Asset("IMAGE","images/inventoryimages/sword_4.tex"),
	Asset("ATLAS","images/inventoryimages/sword_4.xml"),
	--Asset("ANIM", "anim/ui_pr_1x1.zip"), 
	--Asset("ANIM", "anim/ui_r503_1x1.zip"),
	--Asset("ANIM", "anim/ui_chest_3x3.zip"),
}

local function onfinished(inst)
    inst:Remove()
end
-- 事件 - 瞬移完成
local function onBlink(staff, pos, caster)
        caster.components.sanity:DoDelta(-2)

end



local function onequip(inst, owner)

    owner.AnimState:OverrideSymbol("swap_object", "swap_sword_4", "swap_sword_4")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	--inst.components.container:Open(owner)
	
end

local function onunequip(inst, owner)

    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
	--inst.components.container:Close(owner)
end


local function fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    inst.entity:AddSoundEmitter()
	
	inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "sword_4.tex" )
	
    inst.AnimState:SetBank("sword_4")
    inst.AnimState:SetBuild("sword_4")
    inst.AnimState:PlayAnimation("idle")

    
	--inst:AddTag("shadow")
	--inst:AddTag("feng")
    inst:AddTag("sharp")
	inst:AddTag("toso_kc")	
    inst:AddTag("weapon_sword")
    --inst:AddTag("extinguisher")
	


    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(180000)

    -------
    inst.components.weapon:SetRange(0.55)
    --inst.components.weapon:SetOnAttack(onAttackduan)
	--inst.components.weapon:SetProjectile("prj_huan")
	--inst.components.weapon:SetRange(10, 10)	

     inst:AddComponent("blinkstaff")
     inst.components.blinkstaff.onblinkfn = onBlink
	
    inst:AddComponent("inspectable")
	


    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "sword_4"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/sword_4.xml"
	--inst.components.inventoryitem.nobounce = true
	inst.components.inventoryitem.keepondeath = true


	inst:AddComponent("talker")
    inst.components.talker.fontsize = 36
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(.9, .4, .4)
    inst.components.talker.offset = Vector3(0, 0, 0)
    inst.components.talker.symbol = "swap_object"
	inst.Transform:SetScale(1.5,1.5,1.5)
	
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    --inst.components.equippable.dapperness = 20/60

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(1)
    inst.components.finiteuses:SetUses(1)
	
    inst.components.finiteuses:SetOnFinished( onfinished )
	
	--inst:AddComponent("stackable")
	--inst.components.stackable.maxsize = 1

	
    return inst
end

return Prefab( "common/inventory/sword_4", fn, assets)