local assets =
{
    Asset("ANIM", "anim/xiaotai.zip"),
    Asset("ANIM", "anim/swap_xukong.zip"),
	Asset("IMAGE","images/inventoryimages/xukong.tex"),
	Asset("ATLAS","images/inventoryimages/xukong.xml")
}

--照明
local function applylight(inst)


       if GetClock():IsDay() then
    inst.Light:Enable(true)
    inst.Light:SetIntensity(.75)
    inst.Light:SetColour(252/255,251/255,237/255)
    inst.Light:SetFalloff( 0.6 )
    inst.Light:SetRadius( 4 )



 	   elseif GetClock():IsDusk() then

    inst.Light:Enable(true)
    inst.Light:SetIntensity(.75)
    inst.Light:SetColour(252/255,251/255,237/255)
    inst.Light:SetFalloff( 0.6 )
    inst.Light:SetRadius( 4 )


       elseif GetClock():IsNight() then

    inst.Light:Enable(true)
    inst.Light:SetIntensity(.75)
    inst.Light:SetColour(252/255,251/255,237/255)
    inst.Light:SetFalloff( 0.6 )
    inst.Light:SetRadius( 4 )


	   end	

end

local function levelj(inst,data)

    local max_j = 600
if inst.level <= 599 then
   inst.components.talker:Say("lv : ".. (inst.level))
end
end

local function Upgradedamage(inst)


if inst.level <= 600 then
    inst.components.weapon:SetDamage(36 + inst.level)
	
   
end
end


local function onkilll(inst, data)

if inst.level <= 599 and math.random() < 0.12 and inst:HasTag("sz") then
SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
    inst.level = inst.level + 1
--inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
    levelj(inst)
 Upgradedamage(inst)
end
if inst.level <= 599 and math.random() < 0.4 and data.inst:HasTag("monster") and inst:HasTag("sz") then
SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
    inst.level = inst.level + 1
--inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
    levelj(inst)
 Upgradedamage(inst)
end
if inst.level <= 598 and math.random() < 0.6 and data.inst:HasTag("largecreature") and inst:HasTag("sz") then
SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
    inst.level = inst.level + 2
--inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
    levelj(inst)
   Upgradedamage(inst)
end
end

local function onpreload(inst, data)
	if data then
	if data.level then
	inst.level = data.level
	levelj(inst)
end
end
end

local function onsave(inst, data)
	data.level = inst.level
end

local function OnLoad(inst, data)
    Upgradedamage(inst) 
end


local function onAttackf(inst, owner, target)
	local x,y,z = inst.Transform:GetWorldPosition()
			--加入一个特效	
		local fxhuo = SpawnPrefab("explode_small")
		fxhuo.Transform:SetScale(1, 1, 1)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())
	local a,b,c = target.Transform:GetWorldPosition()
	if (x-a)*(x-a) + (y-b)*(y-b) + (z-c)*(z-c) > 4.0 then
		
		owner.Transform:SetPosition(target.Transform:GetWorldPosition())
		
	end

end




local function onequip(inst, owner)
 --inst:AddTag("sz")
     inst.Light:Enable(true)
    inst.Light:SetIntensity(.75)
    inst.Light:SetColour(252/255,251/255,237/255)
    inst.Light:SetFalloff( 0.6 )
    inst.Light:SetRadius( 4 )
	
     Upgradedamage(inst) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_xukong", "swap_datai")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
        if  inst.level >= 0 then	
		inst.components.talker:Say(
		"\n武器伤害["..(36 + inst.level).."]"..
		"\n武器等级["..(inst.level).."]")	
        end
	
end

local function onunequip(inst, owner)
    inst.Light:Enable(false)
--inst:RemoveTag("sz")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")

end


function onfinished(inst)
    inst:Remove()
end





local function fn()


    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    --local minimap = inst.entity:AddMiniMapEntity()
    --minimap:SetIcon("xiaotai.tex")
	inst.entity:AddMiniMapEntity()	 
	inst.MiniMapEntity:SetIcon( "xiaotai.tex" )	
	
    inst.AnimState:SetBank("xiaotai")
    inst.AnimState:SetBuild("xiaotai")
    inst.AnimState:PlayAnimation("idle")
	if SaveGameIndex:IsModeShipwrecked() then
  
	MakeInventoryFloatable(inst, "idle_water", "idle")
    end

	inst.entity:AddLight()
    inst.Light:Enable(true)
    inst.Light:SetIntensity(.75)
    inst.Light:SetColour(252/255,251/255,237/255)
    inst.Light:SetFalloff( 0.6 )
    inst.Light:SetRadius( 4 )
   
    inst:AddTag("sharp")
	inst:AddTag("sz")
	
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(Upgradedamage)
    inst.components.weapon:SetRange(0.8)
    --inst.components.weapon:SetOnAttack(onAttackf)
	
    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "xukong"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/xukong.xml"

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 24
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(1, 0.8, 0.65, 1)
    inst.components.talker.offset = Vector3(200,-250,0)
    inst.components.talker.symbol = "swap_object"
	
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
	
	inst:AddComponent("onikiriskill")
    inst.components.onikiriskill.skill = ACTIONS.GHOSTSHADOW
	
    inst.level = 0
    inst:ListenForEvent("levelup", levelj)
    inst:ListenForEvent("entity_death", function(wrld, data) onkilll(inst, data) end, GetWorld())

    

    inst.OnLoad = OnLoad
    inst.OnSave = onsave
    inst.OnPreLoad = onpreload
--inst.applylight = inst:DoPeriodicTask(1,applylight)	
	    Upgradedamage(inst)

	
    return inst
end

return Prefab( "common/inventory/xukong", fn, assets)