return {
	ACTIONFAIL =
	{
		SHAVE =
		{
			AWAKEBEEFALO = "I'm not going to try that while he's awake.",
			GENERIC = "I can't shave that!",
			NOBITS = "There isn't even any stubble left!",
		},
		STORE =
		{
			GENERIC = "It's full.",
			NOTALLOWED = "That can't go in there.",
		},
		RUMMAGE =
		{	
			GENERIC = "I can't.",	
		},
        COOK =
        {
            GENERIC = "Oh, I can't.",
            TOOFAR = "It's too far away!",
        },
        GIVE =
        {
            DEAD = "Maybe I'll just hold on to this.",
            SLEEPING = "Too unconscious to care.",
            BUSY = "I'll try again in a second.",
        },
        WRITE =
        {
            GENERIC = "I think it's fine as is.",
        },
        CHANGEIN =
        {
            GENERIC = "I don't want to change right now.",
            BURNING = "It's too dangerous right now!",
        },
		REPAIRBOAT = 
		{
			GENERIC = "She's floating just fine right now.",
		},
		TEACH =
        {
            KNOWN = "I already know that one.",
            CANTLEARN = "I can't learn that one.",
        },
	},
	ACTIONFAIL_GENERIC = "I can't do that.",
	ANNOUNCE_MAGIC_FAIL = "It won't work here.",
	
	ANNOUNCE_ADVENTUREFAIL = "That didn't go well. I'll have to try again.",
	ANNOUNCE_BEES = "BEEEEEEEEEEEEES!!!!",
	ANNOUNCE_BOOMERANG = "Ow! I should try to catch that!",
	ANNOUNCE_CHARLIE = "What was that?!",
	ANNOUNCE_CHARLIE_ATTACK = "OW! Something bit me!",
	ANNOUNCE_COLD = "So cold!",
	ANNOUNCE_HOT = "Need... ice... or... shade!",
	ANNOUNCE_CRAFTING_FAIL = "I'm missing a couple key ingredients.",
	ANNOUNCE_DEERCLOPS = "That sounded big!",
	ANNOUNCE_DUSK = "It's getting late. It will be dark soon.",
	ANNOUNCE_EAT =
	{
		GENERIC = "Yum!",
		PAINFUL = "I don't feel so good.",
		SPOILED = "Yuck! That was terrible!",
		STALE = "I think that was starting to turn.",
		INVALID = "I can't eat that!",
		YUCKY = "Putting that in my mouth would be disgusting!",
	},
	ANNOUNCE_ENTER_DARK = "It's so dark!",
	ANNOUNCE_ENTER_LIGHT = "I can see again!",
	ANNOUNCE_FREEDOM = "I'm free! I'm finally free!",
	ANNOUNCE_HIGHRESEARCH = "I feel so smart now!",
	ANNOUNCE_HOUNDS = "Did you hear that?",
	ANNOUNCE_WORMS = "Did you feel that?",
	ANNOUNCE_SHARX = "I'm going to need a bigger boat...",
	ANNOUNCE_HUNGRY = "I'm so hungry!",
	ANNOUNCE_HUNT_BEAST_NEARBY = "This track is fresh. The beast must be nearby.",
	ANNOUNCE_HUNT_LOST_TRAIL = "The beast's trail ends here.",
	ANNOUNCE_HUNT_LOST_TRAIL_SPRING = "This wet soil can't hold a footprint.",
	ANNOUNCE_INV_FULL = "I can't carry any more stuff!",
	ANNOUNCE_KNOCKEDOUT = "Ugh, my head!",
	ANNOUNCE_LOWRESEARCH = "I didn't learn very much from that.",
	ANNOUNCE_MOSQUITOS = "Aaah! Bug off!",
	ANNOUNCE_NOWARDROBEONFIRE = "I can't change while it's on fire!",
	ANNOUNCE_NODANGERSLEEP = "It's too dangerous right now!",
	ANNOUNCE_NODAYSLEEP = "It's too bright out.",
	ANNOUNCE_NODAYSLEEP_CAVE = "I'm not tired.",
	ANNOUNCE_NOHUNGERSLEEP = "I'm too hungry to sleep, my growling tummy will keep me up!",
	ANNOUNCE_NOSLEEPONFIRE = "I don't exactly have a burning desire to sleep in that.",
	ANNOUNCE_NODANGERSIESTA = "It's too dangerous to siesta right now!",
	ANNOUNCE_NONIGHTSIESTA = "Night is for sleeping, not taking siestas.",
	ANNOUNCE_NONIGHTSIESTA_CAVE = "I don't think I could really relax down here.",
	ANNOUNCE_NOHUNGERSIESTA = "I'm too hungry for a siesta!",
	ANNOUNCE_NO_TRAP = "Well, that was easy.",
	ANNOUNCE_PECKED = "Ow! Quit it!",
	ANNOUNCE_QUAKE = "That doesn't sound good.",
	ANNOUNCE_RESEARCH = "Never stop learning!",
	ANNOUNCE_SHELTER = "Thanks for the protection from the elements, tree!",
	ANNOUNCE_THORNS = "Ow!",
	ANNOUNCE_BURNT = "Yikes! That was hot!",
	ANNOUNCE_TORCH_OUT = "My light just ran out!",
	ANNOUNCE_FAN_OUT = "My fan is gone with the wind.",
    ANNOUNCE_COMPASS_OUT = "This compass doesn't point anymore.",
	ANNOUNCE_TRAP_WENT_OFF = "Oops.",
	ANNOUNCE_UNIMPLEMENTED = "OW! I don't think it's ready yet.",
	ANNOUNCE_WORMHOLE = "That was not a sane thing to do.",
	ANNOUNCE_CANFIX = "\nI think I can fix this!",
	ANNOUNCE_ACCOMPLISHMENT = "I feel so accomplished!",
	ANNOUNCE_ACCOMPLISHMENT_DONE = "If only my friends could see me now...",	
	ANNOUNCE_INSUFFICIENTFERTILIZER = "Are you still hungry, plant?",
	ANNOUNCE_TOOL_SLIP = "Wow, that tool is slippery!",
	ANNOUNCE_LIGHTNING_DAMAGE_AVOIDED = "Safe from that frightening lightning!",

	ANNOUNCE_DAMP = "Oh, H2O.",
	ANNOUNCE_WET = "My clothes appear to be water permeable.",
	ANNOUNCE_WETTER = "Water way to go!",
	ANNOUNCE_SOAKED = "I've nearly reached my saturation point.",

	ANNOUNCE_TREASURE = "It's a map! And it marks a location!",
	ANNOUNCE_MORETREASURE = "Seriously? Another one!?",
	ANNOUNCE_OTHER_WORLD_TREASURE = "This map doesn't correlate to my current surroundings.",
	ANNOUNCE_OTHER_WORLD_PLANT = "I don't think this soil has the proper nutrients.",

	ANNOUNCE_MESSAGEBOTTLE =
	{
		"The message is faded. I can't read it.",
	},
	ANNOUNCE_VOLCANO_ERUPT = "That can't be good.",
	ANNOUNCE_MAPWRAP_WARN = "Here be monsters.",
	ANNOUNCE_MAPWRAP_LOSECONTROL = "It would seem my future is foggy.",
	ANNOUNCE_MAPWRAP_RETURN = "I think I felt something brush against my leg...",
	ANNOUNCE_CRAB_ESCAPE = "I could've sworn it was right there...",
	ANNOUNCE_TRAWL_FULL = "My net filled up!",
	ANNOUNCE_BOAT_DAMAGED = "I think I sprung a leak.",
	ANNOUNCE_BOAT_SINKING = "I seem to be sinking.",
	ANNOUNCE_BOAT_SINKING_IMMINENT = "I need to get to land!",
	ANNOUNCE_WAVE_BOOST = "Weeeee!",

	ANNOUNCE_WHALE_HUNT_BEAST_NEARBY = "Follow those bubbles!",
	ANNOUNCE_WHALE_HUNT_LOST_TRAIL = "I wonder where it went...",
	ANNOUNCE_WHALE_HUNT_LOST_TRAIL_SPRING = "The water is too rough!",


	BATTLECRY =
	{
		GENERIC = "Go for the eyes!",
		PIG = "Here piggy piggy!",
		PREY = "I will destroy you!",
		SPIDER = "I'm going to stomp you dead!",
		SPIDER_WARRIOR = "Better you than me!",
	},
	COMBAT_QUIT =
	{
		GENERIC = "I sure showed him!",
		PIG = "I'll let him go. This time.",
		PREY = "He's too fast!",
		SPIDER = "He's too gross, anyway.",
		SPIDER_WARRIOR = "Shoo, you nasty thing!",
	},

	DESCRIBE =
	{
        WILDBOREGUARD = "What's it guarding?",
        GLOMMER = "It's cute, in a gross kind of way.",
        GLOMMERFLOWER = 
        {
        	GENERIC = "The petals shimmer in the light.",
        	DEAD = "The petals droop and shimmer in the light.",
        },
        GLOMMERWINGS = "These would look empirically amazing on a helmet!",
        GLOMMERFUEL = "This goop smells foul.",
        BELL = "Dingalingaling.",
        STATUEGLOMMER = 
        {	
        	GENERIC = "I'm not sure what that's supposed to be.",
        	EMPTY = "I broke it. For science.",
    	},

		LAVA_POND_ROCK = "As gneiss a place as any.",
		LAVA_POND_ROCK2 = "As gneiss a place as any.",
		LAVA_POND_ROCK3 = "As gneiss a place as any.",
		LAVA_POND_ROCK4 = "As gneiss a place as any.",
		LAVA_POND_ROCK5 = "As gneiss a place as any.",
		LAVA_POND_ROCK6 = "As gneiss a place as any.",
		LAVA_POND_ROCK7 = "As gneiss a place as any.",

		WEBBERSKULL = "Poor little guy. He deserves a proper funeral.",
		WORMLIGHT = "Looks delicious.",
		WORMLIGHT_LESSER = "Kinda wrinkled.",
		WORM =
		{
		    PLANT = "Seems safe to me.",
		    DIRT = "Just looks like a pile of dirt.",
		    WORM = "It's a worm!",
		},
		WORMLIGHT_PLANT = "Seems safe to me.",
		MOLE =
		{
			HELD = "Nowhere left to dig, my friend.",
			UNDERGROUND = "Something's under there, searching for minerals.",
			ABOVEGROUND = "I'd sure like to whack that mole... thing.",
		},
		MOLEHILL = "What a nice, homey hole in the ground!",
		MOLEHAT = "A wretched stench, but excellent visibility.",

		EEL = "This will make a delicious meal.",
		EEL_COOKED = "Smells great!",
		UNAGI = "I hope this doesn't make me feel eel!",
		EYETURRET = "I hope it doesn't turn on me.",
		EYETURRET_ITEM = "I think it's sleeping.",
		MINOTAURHORN = "Wow! I'm glad that didn't gore me!",
		MINOTAURCHEST = "It may contain a bigger something fantastic! Or horrible.",
		THULECITE_PIECES = "It's some smaller chunks of Thulecite.",
		POND_ALGAE = "Some algae by a pond.",
		GREENSTAFF = "This will come in handy.",
		POTTEDFERN = "A fern in a pot.",

		THULECITE = "I wonder where this is from?",
		ARMORRUINS = "It's oddly light.",
		RUINS_BAT = "It has quite a heft to it.",
		RUINSHAT = "How's my hair?",
		NIGHTMARE_TIMEPIECE =
		{
			CALM = "All is well.",
			WARN = "Getting pretty magical around here.",
			WAXING = "I think it's becoming more concentrated!",
			STEADY = "It seems to be staying steady.",
			WANING = "Feels like it's receding.",
			DAWN = "The nightmare is almost gone!",
			NOMAGIC = "There's no magic around here.",
		},
		BISHOP_NIGHTMARE = "It's falling apart!",
		ROOK_NIGHTMARE = "Terrifying!",
		KNIGHT_NIGHTMARE = "It's a knightmare!",
		MINOTAUR = "That thing doesn't look happy.",
		SPIDER_DROPPER = "Note to self: Don't look up.",
		NIGHTMARELIGHT = "I wonder what function this served.",
		NIGHTSTICK = "It's electric!",
		GREENGEM = "It's green and gemmy.",
		RELIC = "Ancient household goods.",
		RUINS_RUBBLE = "This can be fixed.",
		MULTITOOL_AXE_PICKAXE = "It's brilliant!",
		ORANGESTAFF = "This beats walking.",
		YELLOWAMULET = "Warm to the touch.",
		GREENAMULET = "Just when I thought I couldn't get any better.",
		SLURPERPELT = "Doesn't look all that much different dead.",		

		SLURPER = "It's so hairy!",
		SLURPER_PELT = "Doesn't look all that much different dead.",	
		ARMORSLURPER = "A soggy, sustaining, succulent suit.",
		ORANGEAMULET = "Teleportation can be so useful.",
		YELLOWSTAFF = "I put a gem on a stick.",
		YELLOWGEM = "This gem is yellow.",
		ORANGEGEM = "It's an orange gem.",
		TELEBASE = 
		{
			VALID = "It's ready to go.",
			GEMS = "It needs more purple gems.",
		},
		GEMSOCKET = 
		{
			VALID = "Looks ready.",
			GEMS = "It needs a gem.",
		},
		STAFFLIGHT = "That seems really dangerous.",
	
        ANCIENT_ALTAR = "An ancient and mysterious structure.",

        ANCIENT_ALTAR_BROKEN = "This seems to be broken.",

        ANCIENT_STATUE = "It seems to throb out of tune with the world.",

        LICHEN = "Only a cyanobacteria could grow in this light.",
		CUTLICHEN = "Nutritious, but it won't last long.",

		CAVE_BANANA = "It's mushy.",
		CAVE_BANANA_COOKED = "Yum!",
		CAVE_BANANA_TREE = "It's dubiously photosynthetical.",
		ROCKY = "It has terrifying claws.",
		
		COMPASS =
		{
			GENERIC="Which way am I facing?",
			N = "North.",
			S = "South.",
			E = "East.",
			W = "West.",
			NE = "Northeast.",
			SE = "Southeast.",
			NW = "Northwest.",
			SW = "Southwest.",
		},

		HOUNDSTOOTH="It's sharp!",
		ARMORSNURTLESHELL="It sticks to my back.",
		BAT="Ack! That's terrifying!",
		BATBAT = "I bet I could fly if I held two of them.",
		BATWING="I hate those things, even when they're dead.",
		BATWING_COOKED="At least it's not coming back.",
		BATCAVE = "I don't want to wake them.",
		BEDROLL_FURRY="It's so warm and comfy.",
		BUNNYMAN="I am filled with an irresistible urge to do science.",
		FLOWER_CAVE="Science makes it glow.",
		FLOWER_CAVE_DOUBLE="Science makes it glow.",
		FLOWER_CAVE_TRIPLE="Science makes it glow.",
		GUANO= "Another flavor of poop.",
		LANTERN= "A more civilized light.",
		LIGHTBULB= "It's strangely tasty looking.",
		MANRABBIT_TAIL= "I just like holding it.",
		MUSHTREE_TALL  = "That mushroom got too big for its own good.",
		MUSHTREE_MEDIUM= "These used to grow in my bathroom.",
		MUSHTREE_SMALL = "A magic mushroom?",
		MUSHTREE_TALL =
		{
            GENERIC = "That mushroom got too big for its own good.",
            BLOOM = "You can't tell from far away, but it's quite smelly.",
        },
		MUSHTREE_MEDIUM = 
		{
            GENERIC = "These used to grow in my bathroom.",
            BLOOM = "I'm mildly offended by this.",
        },
		MUSHTREE_SMALL = 
		{
            GENERIC = "A magic mushroom?",
            BLOOM = "It's trying to reproduce.",
        },
        MUSHTREE_TALL_WEBBED = "The spiders thought this one was important.",
        SPORE_TALL = "It's just drifting around.",
        SPORE_MEDIUM = "It's just drifting around.",
        SPORE_SMALL = "It's just drifting around.",
        SPORE_TALL_INV = "I'll keep a little light in my pocket.",
        SPORE_MEDIUM_INV = "I'll keep a little light in my pocket.",
        SPORE_SMALL_INV = "I'll keep a little light in my pocket.",
		RABBITHOUSE=
		{
			GENERIC = "That's not a real carrot.",
			BURNT = "That's not a real roasted carrot.",
		},
		SLURTLE="Ew. Just ew.",
		SLURTLE_SHELLPIECES="A puzzle with no solution.",
		SLURTLEHAT= "I hope it doesn't mess up my hair.",
		SLURTLEHOLE= "A den of \"ew\".",
		SLURTLESLIME= "If it wasn't useful, I wouldn't touch it.",
		SNURTLE= "He's less gross, but still gross.",
		SPIDER_HIDER= "Gah! More spiders!",
		SPIDER_SPITTER= "I hate spiders!",
		SPIDERHOLE= "It's encrusted with old webbing.",
		SPIDERHOLE_ROCK = "It's encrusted with old webbing.",
		STALAGMITE= "Looks like a rock to me.",
		STALAGMITE_FULL= "Looks like a rock to me.",
		STALAGMITE_LOW= "Looks like a rock to me.",
		STALAGMITE_MED= "Looks like a rock to me.",
		STALAGMITE_TALL= "Rocks, rocks, rocks, rocks...",
		STALAGMITE_TALL_FULL= "Rocks, rocks, rocks, rocks...",
		STALAGMITE_TALL_LOW= "Rocks, rocks, rocks, rocks...",
		STALAGMITE_TALL_MED= "Rocks, rocks, rocks, rocks...",

		TURF_CARPETFLOOR = "It's surprisingly scratchy.",
        TURF_CHECKERFLOOR = "These are pretty snazzy.",
		TURF_DIRT = "A chunk of ground.",
		TURF_FOREST = "A chunk of ground.",
		TURF_GRASS = "A chunk of ground.",
		TURF_MARSH = "A chunk of ground.",
		TURF_ROAD = "Hastily cobbled stones.",
		TURF_ROCKY = "A chunk of ground.",
		TURF_SAVANNA = "A chunk of ground.",
		TURF_WOODFLOOR = "These are floorboards.",

		TURF_CAVE="Yet another ground type.",
		TURF_FUNGUS="Yet another ground type.",
		TURF_SINKHOLE="Yet another ground type.",
		TURF_UNDERROCK="Yet another ground type.",
		TURF_MUD="Yet another ground type.",

		TURF_DECIDUOUS = "Yet another ground type.",
		TURF_SANDY = "Yet another ground type.",
		TURF_BADLANDS = "Yet another ground type.",
		TURF_DESERTDIRT = "A chunk of ground.",
		TURF_FUNGUS_GREEN = "A chunk of ground.",
		TURF_FUNGUS_RED = "A chunk of ground.",
		TURF_DRAGONFLY = "Do you want proof that it's fireproof?",

		POWCAKE = "I don't know if I'm hungry enough.",
        CAVE_ENTRANCE = 
        {
            GENERIC="I wonder if I could move that rock.",
            OPEN = "I bet there's all sorts of things to discover down there.",
        },
        CAVE_EXIT = "I've had enough discovery for now.",
        CAVE_ENTRANCE_OPEN = 
        {
            GENERIC = "The earth itself rejects me!",
            OPEN = "I bet there's all sorts of things to discover down there.",
        },
        CAVE_EXIT = 
        {
            GENERIC = "I'll just stay down here, I suppose.",
            OPEN = "I've had enough discovery for now.",
        },
		MAXWELLPHONOGRAPH = "So that's where the music was coming from.",
		BOOMERANG = "Aerodynamical!",
		PIGGUARD = "He doesn't look as friendly as the others.",
		ABIGAIL = "Awww, she has a cute little bow.",
		ADVENTURE_PORTAL = "I'm not sure I want to fall for that a second time.",
		AMULET = "I feel so safe when I'm wearing it.",
		ANIMAL_TRACK = "Tracks left by food. I mean... an animal.",
		ARMORGRASS = "I hope there are no bugs in this.",
		ARMORMARBLE = "This looks really heavy.",
		ARMORWOOD = "That is a perfectly reasonable piece of clothing.",
		ARMOR_SANITY = "Wearing this makes me feel safe and insecure.",
		ASH =
		{
			GENERIC = "All that's left after the fire has done its job.",
			REMAINS_GLOMMERFLOWER = "The flower was consumed by fire in the teleportation!",
			REMAINS_EYE_BONE = "The eyebone was consumed by fire in the teleportation!",
			REMAINS_THINGIE = "There's a perfectly scientific explanation for that.",
		},
		AXE = "It's my trusty axe.",
		BABYBEEFALO = "Awwww. So cute!",
		BACKPACK = "You could fit a whole lot of science in there.",
		BACONEGGS = "The perfect breakfast for a man of science.",
		BANDAGE = "Seems sterile enough.",
		BASALT = "That's too strong to break through!",
		BATBAT = "I bet I could fly if I held two of these.",
		BEARDHAIR = "I made them with my face.",
		BEARGER = "What a bear of a badger.",
		BEARGERVEST = "Welcome to the hibernation station!",
		ICEPACK = "The fur keeps the temperature inside stable.",
		BEARGER_FUR = "A mat of thick fur.",
		BEDROLL_STRAW = "Looks comfy, but it smells like mildew.",
		BEE =
		{
			GENERIC = "To bee or not to bee.",
			HELD = "Careful!",
		},
		BEEBOX =
		{
			FULLHONEY = "It's full of honey.",
			GENERIC = "Bees!",
			NOHONEY = "It's empty.",
			SOMEHONEY = "I should wait a bit.",
			BURNT = "How did it get burned?!!",
		},
		BEEFALO =
		{
			FOLLOWER = "He's coming along peacefully.",
			GENERIC = "It's a beefalo!",
			NAKED = "Aww, he's so sad.",
			SLEEPING = "These guys are really heavy sleepers.",
		},
		BEEFALOHAT = "That's a case of hat-hair waiting to happen.",
		BEEFALOWOOL = "It smells like beefalo tears.",
		BEEHAT = "Protects your skin, but squashes your meticulous coiffure.",
		BEEHIVE = "It's buzzing with activity.",
		BEEMINE = "It buzzes when I shake it.",
		BEEMINE_MAXWELL = "Bottled mosquito rage!",
		BERRIES = "Red berries taste the best.",
		BERRIES_COOKED = "I don't think heat improved them.",
		BERRYBUSH =
		{
			BARREN = "I think it needs to be fertilized.",
			WITHERED = "Nothing will grow in this heat.",
			GENERIC = "Red berries taste the best.",
			PICKED = "Maybe they'll grow back?",
		},
		BIGFOOT = "That is one biiig foot.",
		BIRDCAGE =
		{
			GENERIC = "I should put a bird in it.",
			OCCUPIED = "That's my bird!",
			SLEEPING = "Awwww, he's asleep.",
			HUNGRY = "He's looking a bit peckish.",
			STARVING = "Have I not fed you in awhile?",
			DEAD = "Maybe he's just resting?",
			SKELETON = "That bird is definitely deceased.",
		},
		BIRDTRAP = "Gives me a net advantage!",
		CAVE_BANANA_BURNT = "Not my fault!",
		BIRD_EGG = "A small, normal egg.",
		BIRD_EGG_COOKED = "Sunny side yum!",
		BISHOP = "Back off, preacherman!",
		BLOWDART_FIRE = "This seems fundamentally unsafe.",
		BLOWDART_SLEEP = "Just don't breathe in.",
		BLOWDART_PIPE = "Good practice for my birthday cake!",
		BLUEAMULET = "Cool as ice!",
		BLUEGEM = "It sparkles with cold energy.",
		BLUEPRINT = "It's scientific!",
		BELL_BLUEPRINT = "It's scientific!",
		BLUE_CAP = "It's weird and gooey.",
		BLUE_CAP_COOKED = "It's different now...",
		BLUE_MUSHROOM =
		{
			GENERIC = "It's a mushroom.",
			INGROUND = "It's sleeping.",
			PICKED = "I wonder if it will come back?",
		},
		BOARDS = "Boards.",
		BOAT = "Is that how I got here?",
		BONESHARD = "Bits of bone.",
		BONESTEW = "A stew to put some meat on my bones.",
		BUGNET = "For catching bugs.",
		BUSHHAT = "It's kind of scratchy.",
		BUTTER = "I can't believe it's butter!",
		BUTTERFLY =
		{
			GENERIC = "Butterfly, flutter by.",
			HELD = "Now I have you!",
		},
		BUTTERFLYMUFFIN = "I threw the recipe away and just kind of winged it.",
		BUTTERFLYWINGS = "Without these, it's just a butter.",
		BUZZARD = "What a bizarre buzzard!",
		CACTUS = 
		{
			GENERIC = "Sharp but delicious.",
			PICKED = "Deflated, but still spiny.",
		},
		CACTUS_MEAT_COOKED = "Grilled fruit of the desert.",
		CACTUS_MEAT = "There are still some spines between me and a tasty meal.",
		CACTUS_FLOWER = "A pretty flower from a prickly plant.",

		COLDFIRE =
		{
			EMBERS = "I should put something on the fire before it goes out.",
			GENERIC = "Sure beats darkness.",
			HIGH = "That fire is getting out of hand!",
			LOW = "The fire's getting a bit low.",
			NORMAL = "Nice and comfy.",
			OUT = "Well, that's over.",
		},
		CAMPFIRE =
		{
			EMBERS = "I should put something on the fire before it goes out.",
			GENERIC = "Sure beats darkness.",
			HIGH = "That fire is getting out of hand!",
			LOW = "The fire's getting a bit low.",
			NORMAL = "Nice and comfy.",
			OUT = "Well, that's over.",
		},
		CANE = "It makes walking seem much easier!",
		CATCOON = "A playful little thing.",
		CATCOONDEN = 
		{
			GENERIC = "It's a den in a stump.",
			EMPTY = "Its owner ran out of lives.",
		},
		CATCOONHAT = "Ears hat!",
		COONTAIL = "I think it's still swishing.",
		CARROT = "Yuck. I pulled this vegetable out of the dirt.",
		CARROT_COOKED = "Mushy.",
		CARROT_PLANTED = "The earth is making plantbabies.",
		CARROT_SEEDS = "It's a carrot seed.",
		WATERMELON_SEEDS = "It's a melon seed.",
		CAVE_FERN = "It's a fern.",
		CHARCOAL = "It's small, dark, and smells like burnt wood.",
        CHESSJUNK1 = "A pile of broken chess pieces.",
        CHESSJUNK2 = "Another pile of broken chess pieces.",
        CHESSJUNK3 = "Even more broken chess pieces.",
		CHESTER = "Otto von Chesterfield, Esq.",
		CHESTER_EYEBONE =
		{
			GENERIC = "It's looking at me.",
			WAITING = "It went to sleep.",
		},
		COOKEDMANDRAKE = "Poor little guy.",
		COOKEDMEAT = "Char broiled to perfection.",
		COOKEDMONSTERMEAT = "That's only somewhat more appetizing than when it was raw.",
		COOKEDSMALLMEAT = "Now I don't have to worry about getting worms!",
		COOKPOT =
		{
			COOKING_LONG = "This is going to take a while.",
			COOKING_SHORT = "It's almost done!",
			DONE = "Mmmmm! It's ready to eat!",
			EMPTY = "It makes me hungry just to look at it.",
			BURNT = "The pot got cooked.",
		},
		CORN = "High in fructose!",
		CORN_COOKED = "Cooked and high in fructose!",
		CORN_SEEDS = "It's a corn seed.",
		CROW =
		{
			GENERIC = "Creepy!",
			HELD = "He's not very happy in there.",
		},
		CUTGRASS = "Cut grass, ready for arts and crafts.",
		CUTREEDS = "Cut reeds, ready for crafting and hobbying.",
		CUTSTONE = "I've made them seductively smooth.",
		DEADLYFEAST = "A most potent dish.",
		DEERCLOPS = "It's enormous!!",
		DEERCLOPS_EYEBALL = "This is really gross.",
		EYEBRELLAHAT =	"It will watch over me.",
		DEPLETED_GRASS =
		{
			GENERIC = "It's probably a tuft of grass.",
		},
		DEVTOOL = "It smells of bacon!",
		DEVTOOL_NODEV = "I'm not strong enough to wield it.",
		DIRTPILE = "It's a pile of dirt... or IS it?",
		DIVININGROD =
		{
			COLD = "The signal is very faint.",
			GENERIC = "It's some kind of homing device.",
			HOT = "This thing's going crazy!",
			WARM = "I'm headed in the right direction.",
			WARMER = "I must be getting pretty close.",
		},
		DIVININGRODBASE =
		{
			GENERIC = "I wonder what it does.",
			READY = "It looks like it needs a large key.",
			UNLOCKED = "Now my machine can work!",
		},
		DIVININGRODSTART = "That rod looks useful!",
		DRAGONFLY = "That's one fly dragon!",
		ARMORDRAGONFLY = "Hot mail!",
		DRAGON_SCALES = "They're still warm.",
		DRAGONFLYCHEST = "Next best thing to a lockbox!",
		LAVASPIT = 
		{
			HOT = "Hot spit!",
			COOL = "I like to call it \"Basaliva\".",
		},
		LAVA_POND = "Magmificent!",
		LAVAE = "Too hot to handle.",
		LAVAE_PET = 
		{
			STARVING = "Poor thing must be starving.",
			HUNGRY = "I hear a tiny stomach grumbling.",
			CONTENT = "It seems happy.",
			GENERIC = "Aww. Who's a good monster?",
		},
		LAVAE_EGG = 
		{
			GENERIC = "There's a faint warmth coming from inside.",
		},
		LAVAE_EGG_CRACKED =
		{
			COLD = "I don't think that egg is warm enough.",
			COMFY = "I never thought I would see a happy egg.",
		},
		LAVAE_TOOTH = "It's an egg tooth!",

		DRAGONFRUIT = "What a weird fruit.",
		DRAGONFRUIT_COOKED = "The fruit's still weird.",
		DRAGONFRUIT_SEEDS = "It's a weird fruit seed.",
		DRAGONPIE = "The dragonfruit is very filling.",
		DRUMSTICK = "I should gobble it.",
		DRUMSTICK_COOKED = "Now it's even tastier.",
		DUG_BERRYBUSH = "Now it can be taken anywhere.",
		DUG_GRASS = "This needs to be planted.",
		DUG_MARSH_BUSH = "I should plant this.",
		DUG_SAPLING = "I could replant it closer to home.",
		DURIAN = "Oh, it smells!",
		DURIAN_COOKED = "Now it smells even worse!",
		DURIAN_SEEDS = "It's a durian seed.",
		EARMUFFSHAT = "At least my ears won't get cold...",
		EGGPLANT = "It doesn't look like an egg.",
		EGGPLANT_COOKED = "It's even less eggy.",
		EGGPLANT_SEEDS = "It's an eggplant seed.",
		DECIDUOUSTREE = 
		{
			BURNING = "What a waste of wood.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			POISON = "It looks unhappy about me stealing those birchnuts!",
			GENERIC = "It's all leafy. Most of the time.",
		},
		ACORN = 
		{
		    GENERIC = "There's definitely something inside there.",
		    PLANTED = "It'll be a tree soon!",
		},
		ACORN_COOKED = "Roasted to perfection.",
		BIRCHNUTDRAKE = "A mad little nut.",
		EVERGREEN =
		{
			BURNING = "What a waste of wood.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "It's all piney.",
		},
		EVERGREEN_SPARSE =
		{
			BURNING = "What a waste of wood.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "This sad tree has no cones.",
		},
		EYEPLANT = "I think I'm being watched.",
		FARMPLOT =
		{
			GENERIC = "I should try planting some crops.",
			GROWING = "Go plants go!",
			NEEDSFERTILIZER = "I think it needs to be fertilized.",
			BURNT = "I don't think anything will grow in a pile of ash.",
		},
		FEATHERHAT = "I AM A BIRD!",
		FEATHER_CROW = "A crow feather.",
		FEATHER_ROBIN = "A redbird feather.",
		FEATHER_ROBIN_WINTER = "A snowbird feather.",
		FEM_PUPPET = "She's trapped!",
		FIREFLIES =
		{
			GENERIC = "If only I could catch them!",
			HELD = "They make my pocket glow!",
		},
		FIREHOUND = "That one is glowy.",
		FIREPIT =
		{
			EMBERS = "I should put something on the fire before it goes out.",
			GENERIC = "Sure beats darkness.",
			HIGH = "Good thing it's contained!",
			LOW = "The fire's getting a bit low.",
			NORMAL = "Nice and comfy.",
			OUT = "At least I can start it up again.",
		},
		COLDFIREPIT =
		{
			EMBERS = "I should put something on the fire before it goes out.",
			GENERIC = "Sure beats darkness.",
			HIGH = "Good thing it's contained!",
			LOW = "The fire's getting a bit low.",
			NORMAL = "Nice and comfy.",
			OUT = "At least I can start it up again.",
		},
		FIRESTAFF = "I don't want to set the world on fire.",
		FIRESUPPRESSOR = 
		{	
			ON = "Fling on!",
			OFF = "All quiet on the flinging front.",
			LOWFUEL = "The fuel tank is getting a bit low.",
		},

		FISH = "Now I shall eat for a day.",
		FISHINGROD = "Hook, line and stick!",
		FISHSTICKS = "Sticks to my ribs.",
		FISH_MED = "Good dog.",
		FISH_MED_COOKED = "Grilled to perfection.",
		FISHTACOS = "Crunchy and delicious!",
		FISH_COOKED = "Grilled to perfection.",

		FISH3 = "A fish with widespread appeal.",
		FISH3_COOKED = "Avoid the green ones, they're not ripe yet.",


		FLINT = "It's a very sharp rock.",
		FLOWER = "It's pretty, but it smells like a common laborer.",
		FLOWERHAT = "It smells like prettiness.",
		FLOWER_EVIL = "Augh! It's so evil!",
		FOLIAGE = "Some leafy greens.",
		FOOTBALLHAT = "I don't like sports.",
		FROG =
		{
			DEAD = "He's croaked.",
			GENERIC = "He's so cute!",
			SLEEPING = "Aww, look at him sleep!",
		},
		FROGGLEBUNWICH = "A very leggy sandwich.",
		FROGLEGS = "I've heard it's a delicacy.",
		FROGLEGS_COOKED = "Tastes like chicken.",
		FRUITMEDLEY = "Fruity.",
		FURTUFT = "Black and white fur.", 
		GEARS = "A pile of mechanical parts.",
		GHOST = "This offends me as a scientist.",
        GHOST_SAILOR = "I wonder what he wants?",
		GOLDENAXE = "That's one fancy axe.",
		GOLDENPICKAXE = "Hey, isn't gold really soft?",
		GOLDENPITCHFORK = "Why did I even make a pitchfork this fancy?",
		GOLDENSHOVEL = "I can't wait to dig holes.",
		GOLDNUGGET = "I can't eat it, but it sure is shiny.",
		GRASS =
		{
			BARREN = "It needs poop.",
			WITHERED = "It's not going to grow back while it's so hot.",
			BURNING = "That's burning fast!",
			GENERIC = "It's a tuft of grass.",
			PICKED = "It was cut down in the prime of its life.",
		},
		GREEN_CAP = "It seems pretty normal.",
		GREEN_CAP_COOKED = "It's different now...",
		GREEN_MUSHROOM =
		{
			GENERIC = "It's a mushroom.",
			INGROUND = "It's sleeping.",
			PICKED = "I wonder if it will come back?",
		},
		GUNPOWDER = "It looks like pepper.",
		HAMBAT = "This seems unsanitary.",
		HAMMER = "Stop! It's time! To hammer things!",
		HEALINGSALVE = "The stinging means that it's working.",
		HEATROCK =
		{
			FROZEN = "It's colder than ice.",
			COLD = "That's a cold stone.",
			GENERIC = "I could manipulate its temperature.",
			WARM = "It's quite warm and cuddly... for a rock!",
			HOT = "Nice and toasty hot!",
		},
		HOME = "Someone must live here.",
		HOMESIGN = 
		{
			GENERIC = "It says \"You are here.\"",
			UNWRITTEN = "The sign is currently blank.",
			BURNT = "I can't read it any longer.",
		},
		HONEY = "Looks delicious!",
		HONEYCOMB = "Bees used to live in this.",
		HONEYHAM = "Sweet and savory.",
		HONEYNUGGETS = "Taste like chicken, but I don't think it is.",
		HORN = "It sounds like a beefalo field in there.",
		HOUND = "You ain't nothing, hound dog!",
		HOUNDBONE = "Creepy.",
		HOUNDMOUND = "I've got no bones to pick with the owner. Really.",
		ICEBOX = "I have harnessed the power of cold!",
		ICEHAT = "Stay cool, boy.",
		ICEHOUND = "Are there hounds for every season?",
		INSANITYROCK =
		{
			ACTIVE = "TAKE THAT, SANE SELF!",
			INACTIVE = "It's more of a pyramid than an obelisk.",
		},
		JAMMYPRESERVES = "I probably should have made a jar.",
		KABOBS = "Lunch on a stick.",
		KILLERBEE =
		{
			GENERIC = "Oh no! It's a killer bee!",
			HELD = "This seems dangerous.",
		},
		KNIGHT = "Check it out!",
		KOALEFANT_SUMMER = "Adorably delicious.",
		KOALEFANT_WINTER = "It looks warm and full of meat.",
		KRAMPUS = "He's going after my stuff!",
		KRAMPUS_SACK = "Ew. It has Krampus slime all over it.",
		LEIF = "He's huge!",
		LEIF_SPARSE = "He's huge!",
		LIGHTNING_ROD =
		{
			CHARGED = "The power is mine!",
			GENERIC = "I can harness the heavens!",
		},
		LIGHTNINGGOAT = 
		{
			GENERIC = "\"Baaaah\" yourself!",
			CHARGED = "I don't think it liked being struck by lightning.",
		},
		LIGHTNINGGOATHORN = "It's like a miniature lightning rod.",
		GOATMILK = "It's buzzing with tastiness!",
		LITTLE_WALRUS = "He won't be cute and cuddly forever.",
		LIVINGLOG = "It looks worried.",
		LOCKEDWES = "Maxwell's statues are trapping him.",
		LOG =
		{
			BURNING = "That's some hot wood!",
			GENERIC = "It's big, it's heavy, and it's wood.",
		},
		LUREPLANT = "It's so alluring.",
		LUREPLANTBULB = "Now I can start my very own meat farm.",
		MALE_PUPPET = "He's trapped!",
		MANDRAKE =
		{
			DEAD = "Mandrake roots have strange properties.",
			GENERIC = "I've heard strange things about those plants.",
			PICKED = "Stop following me!",
		},
		MANDRAKESOUP = "Well, he won't be waking up again.",
		MANDRAKE_COOKED = "It doesn't seem so strange anymore.",
		MARBLE = "Fancy!",
		MARBLEPILLAR = "I think I could use that.",
		MARBLETREE = "I don't think an axe will cut it.",
		MARSH_BUSH =
		{
			BURNING = "That's burning fast!",
			GENERIC = "It looks thorny.",
			PICKED = "That hurt.",
		},
		BURNT_MARSH_BUSH = "It's all burnt up.",
		MARSH_PLANT = "It's a plant.",
		MARSH_TREE =
		{
			BURNING = "Spikes and fire!",
			BURNT = "Now it's burnt and spiky.",
			CHOPPED = "Not so spiky now!",
			GENERIC = "Those spikes look sharp!",
		},
		MAXWELL = "I hate that guy.",
		MAXWELLHEAD = "I can see into his pores.",
		MAXWELLLIGHT = "I wonder how they work.",
		MAXWELLLOCK = "Looks almost like a key hole.",
		MAXWELLTHRONE = "That doesn't look very comfortable.",
		MEAT = "It's a bit gamey, but it'll do.",
		MEATBALLS = "I cooked it myself!",
		MEATRACK =
		{
			DONE = "Jerky time!",
			DRYING = "Meat takes a while to dry.",
			DRYINGINRAIN = "Meat takes even longer to dry in rain.",
			GENERIC = "I should dry some meats.",
			BURNT = "The rack got dried.",
		},
		MEAT_DRIED = "Just jerky enough.",
		MERM = "Smells fishy!",
		MERMHEAD = 
		{
			GENERIC = "The stinkiest thing I'll smell all day.",
			BURNT = "Burnt merm flesh somehow smells even worse.",
		},
		MERMHOUSE = 
		{
			GENERIC = "Who would live here?",
			BURNT = "Nothing to live in, now.",
		},
		MINERHAT = "A hands-free way to brighten my day.",
		MONKEY = "Curious little guy.",
		MONKEYBARREL = "Did that just move?",
		MONSTERLASAGNA = "It's an affront to science.",
		FLOWERSALAD = "A bowl of foliage.",
        ICECREAM = "I scream for ice cream!",
        WATERMELONICLE = "Cryogenic watermelon.",
        TRAILMIX = "A healthy, natural snack.",
        HOTCHILI = "Five alarm!",
        GUACAMOLE = "Avogadro's favorite dish.",
		MONSTERMEAT = "Ugh. I don't think I should eat that.",
		MONSTERMEAT_DRIED = "Strange-smelling jerky.",
		MOOSE = "I don't exactly know what that thing is.",
		MOOSE_NESTING_GROUND = "It puts its babies there.",
		MOOSEEGG = "Its contents are like excited electrons trying to escape.",
		MOSSLING = "Aaah! You are definitely not an electron!",
		FEATHERFAN = "Down, to bring the temperature down.",
		MINIFAN = "Somehow the breeze comes out the back twice as fast.",
		TROPICALFAN = "Somehow the breeze comes out the back twice as fast.",
		GOOSE_FEATHER = "Fluffy!",
		STAFF_TORNADO = "Spinning doom.",
		MOSQUITO =
		{
			GENERIC = "Disgusting little bloodsucker.",
			HELD = "Hey, is that my blood?",
		},
		MOSQUITOSACK = "It's probably not someone else's blood...",
		MOUND =
		{
			DUG = "I should probably feel bad about that.",
			GENERIC = "I bet there's all sorts of good stuff down there!",
		},
		NIGHTLIGHT = "It gives off a spooky light.",
		NIGHTMAREFUEL = "This stuff is crazy!",
		NIGHTSWORD = "I dreamed it myself!",
		NITRE = "I'm not a geologist.",
		ONEMANBAND = "I should have added a beefalo bell.",
		PANDORASCHEST = "It may contain something fantastic! Or horrible.",
		PANFLUTE = "I can serenade the animals.",
		PAPYRUS = "Some sheets of paper.",
		PENGUIN = "Must be breeding season.",
		PERD = "Stupid bird! Stay away from my berries!",
		PEROGIES = "These turned out pretty good.",
		PETALS = "I showed those flowers who's boss!",
		PETALS_EVIL = "I'm not sure I want to hold these.",
		PHLEGM = "It's thick and pliable. And salty.",
		PICKAXE = "Iconic, isn't it?",
		PIGGYBACK = "This little piggy's gone... \"home\".",
		PIGHEAD = 
		{	
			GENERIC = "Looks like an offering to the beast.",
			BURNT = "Crispy.",
		},
		PIGHOUSE =
		{
			FULL = "I can see a snout pressed up against the window.",
			GENERIC = "These pigs have pretty fancy houses.",
			LIGHTSOUT = "Come ON! I know you're home!",
			BURNT = "Not so fancy now, pig!",
		},
		PIGKING = "Ewwww, he smells!",
		PIGMAN =
		{
			DEAD = "Someone should tell its family.",
			FOLLOWER = "You're part of my entourage.",
			GENERIC = "They kind of creep me out.",
			GUARD = "Looks serious.",
			WEREPIG = "Not a friendly pig!!",
		},
		PIGSKIN = "It still has the tail on it.",
		PIGTENT = "Smells like bacon.",
		PIGTORCH = "Sure looks cozy.",
		PINECONE = 
		{
		    GENERIC = "I can hear a tiny tree inside it, trying to get out.",
		    PLANTED = "It'll be a tree soon!",
		},
		LUMPY_SAPLING = "How did this tree even reproduce?",
		PITCHFORK = "Maxwell might be looking for this.",
		PLANTMEAT = "That doesn't look very appealing.",
		PLANTMEAT_COOKED = "At least it's warm now.",
		PLANT_NORMAL =
		{
			GENERIC = "Leafy!",
			GROWING = "Guh! It's growing so slowly!",
			READY = "Mmmm. Ready to harvest.",
			WITHERED = "The heat killed it.",
		},
		POMEGRANATE = "It looks like the inside of an alien's brain.",
		POMEGRANATE_COOKED = "Haute Cuisine!",
		POMEGRANATE_SEEDS = "It's a pome-whatsit seed.",
		POND = "I can't see the bottom!",
		POOP = "I should fill my pockets!",
		FERTILIZER = "That is definitely a bucket full of poop.",
		PUMPKIN = "It's as big as my head!",
		PUMPKINCOOKIE = "That's a pretty gourd cookie!",
		PUMPKIN_COOKED = "How did it not turn into a pie?",
		PUMPKIN_LANTERN = "Spooky!",
		PUMPKIN_SEEDS = "It's a pumpkin seed.",
		PURPLEAMULET = "It's whispering to me.",
		PURPLEGEM = "It contains the mysteries of the universe.",
		RABBIT =
		{
			GENERIC = "He's looking for carrots.",
			HELD = "Do you like science?",
		},
		RABBITHOLE = 
		{
			GENERIC = "That must lead to the Kingdom of the Bunnymen.",
			SPRING = "The Kingdom of the Bunnymen is closed for the season.",
		},
		RAINOMETER = 
		{	
			GENERIC = "It measures cloudiness.",
			BURNT = "The measuring parts went up in a cloud of smoke.",
		},
		RAINCOAT = "Keeps the rain where it ought to be. Outside my body.",
		RAINHAT = "It'll mess up my hair, but I'll stay nice and dry.",
		RATATOUILLE = "An excellent source of fiber.",
		RAZOR = "A sharpened rock tied to a stick. For hygiene!",
		REDGEM = "It sparkles with inner warmth.",
		RED_CAP = "It smells funny.",
		RED_CAP_COOKED = "It's different now...",
		RED_MUSHROOM =
		{
			GENERIC = "It's a mushroom.",
			INGROUND = "It's sleeping.",
			PICKED = "I wonder if it will come back?",
		},
		REEDS =
		{
			BURNING = "That's really burning!",
			GENERIC = "It's a clump of reeds.",
			PICKED = "I picked all the useful reeds.",
		},
        RELIC = 
        {
            GENERIC = "Ancient household goods.",
            BROKEN = "Nothing to work with here.",
        },
        RUINS_RUBBLE = "This can be fixed.",
        RUBBLE = "Just bits and pieces of rock.",
		RESEARCHLAB = 
		{	
			GENERIC = "It breaks down objects into their scientific components.",
			BURNT = "It won't be doing much science now.",
		},
		RESEARCHLAB2 = 
		{
			GENERIC = "It's even more science-y than the last one!",
			BURNT = "The extra science didn't keep it alive.",
		},
		RESEARCHLAB3 = 
		{
			GENERIC = "What have I created?",
			BURNT = "Whatever it was, it's burnt now.",
		},
		RESEARCHLAB4 = 
		{
			GENERIC = "Who would name something that?",
			BURNT = "Fire doesn't really solve naming issues...",
		},
		RESURRECTIONSTATUE = 
		{
			GENERIC = "What a handsome devil!",
			BURNT = "Not much use anymore.",
		},
		RESURRECTIONSTONE = "It's always a good idea to touch base.",
		ROBIN =
		{
			GENERIC = "Does that mean winter is gone?",
			HELD = "He likes my pocket.",
		},
		ROBIN_WINTER =
		{
			GENERIC = "Life in the frozen wastes.",
			HELD = "It's so soft.",
		},
		ROBOT_PUPPET = "It's trapped!",
		ROCK_LIGHT =
		{
			GENERIC = "A crusted over lava pit.",
			OUT = "Looks fragile.",
			LOW = "The lava's crusting over.",
			NORMAL = "Nice and comfy.",
		},
		ROCK = "It wouldn't fit in my pocket.",
		ROCK_ICE = 
		{
			GENERIC = "A very isolated glacier.",
			MELTED = "Won't be useful until it freezes again.",
		},
		ROCK_ICE_MELTED = "Won't be useful until it freezes again.",
		ICE = "Ice to meet you.",
		ROCKS = "I can make stuff with these.",
        ROOK = "Storm the castle!",
		ROPE = "Some short lengths of rope.",
		ROTTENEGG = "Ew! It stinks!",
		SANITYROCK =
		{
			ACTIVE = "That's a CRAZY looking rock!",
			INACTIVE = "Where did the rest of it go?",
		},
		SAPLING =
		{
			BURNING = "That's burning fast!",
			WITHERED = "It might be okay if it was cooler.",
			GENERIC = "Baby trees are so cute!",
			PICKED = "That'll teach him.",
		},
		SEEDS = "Each one is a tiny mystery.",
		SEEDS_COOKED = "I cooked all the life out of 'em!",
		SEWING_KIT = "Darn it! Darn it all to heck!",
		SHOVEL = "There's a lot going on underground.",
		SILK = "It comes from a spider's butt.",
		SKELETON = "Better you than me.",
		SCORCHED_SKELETON = "Spooky.",
		SKELETON_PLAYER = "Better him than... wait a minute!",
		SKULLCHEST = "I'm not sure if I want to open it.",
		SMALLBIRD =
		{
			GENERIC = "That's a rather small bird.",
			HUNGRY = "It looks hungry.",
			STARVING = "It must be starving.",
		},
		SMALLMEAT = "A tiny chunk of dead animal.",
		SMALLMEAT_DRIED = "A little jerky.",
		SPAT = "What a crusty looking animal.",
		SPEAR = "That's one pointy stick.",
		SPIDER =
		{
			DEAD = "Ewwww!",
			GENERIC = "I hate spiders.",
			SLEEPING = "I'd better not be here when he wakes up.",
		},
		SPIDERDEN = "Sticky!",
		SPIDEREGGSACK = "I hope these don't hatch in my pocket.",
		SPIDERGLAND = "It has a tangy, antiseptic smell.",
		SPIDERHAT = "I hope I got all of the spider goo out of it.",
		SPIDERQUEEN = "AHHHHHHHH! That spider is huge!",
		SPIDER_WARRIOR =
		{
			DEAD = "Good riddance!",
			GENERIC = "Looks even meaner than usual.",
			SLEEPING = "I should keep my distance.",
		},
		SPOILED_FOOD = "It's a furry ball of rotten food.",
		STATUEHARP = "What happened to the head?",
		STATUEMAXWELL = "It really captures his personality.",
		STEELWOOL = "Scratchy metal fibers.",
		STINGER = "Looks sharp!",
		STRAWHAT = "Hats always ruin my hair.",

		TALLBIRD = "That's one tall bird!",
		TALLBIRDEGG = "Will it hatch?",
		TALLBIRDEGG_COOKED = "Delicious and nutritious.",
		TALLBIRDEGG_CRACKED =
		{
			COLD = "Is it shivering or am I?",
			GENERIC = "Looks like it's hatching!",
			HOT = "Are eggs supposed to sweat?",
			LONG = "I have a feeling this is going to take a while...",
			SHORT = "It should hatch any time now.",
		},
		TALLBIRDNEST =
		{
			GENERIC = "That's quite an egg!",
			PICKED = "The nest is empty.",
		},
		TEENBIRD =
		{
			GENERIC = "Not a very tall bird.",
			HUNGRY = "I'd better find it some food.",
			STARVING = "It has a dangerous look in its eye.",
		},
		TELEBASE =
		{
			VALID = "It's ready to go.",
			GEMS = "It needs more purple gems.",
		},
		GEMSOCKET = 
		{
			VALID = "Looks ready.",
			GEMS = "It needs a gem.",
		},
		TELEPORTATO_BASE =
		{
			ACTIVE = "With this I can surely pass through space and time!",
			GENERIC = "This appears to be a nexus to another world!",
			LOCKED = "There's still something missing.",
			PARTIAL = "Soon, the invention will be complete!",
		},
		TELEPORTATO_BOX = "This may control the polarity of the whole universe.",
		TELEPORTATO_CRANK = "Tough enough to handle the most intense experiments.",
		TELEPORTATO_POTATO = "This metal potato contains great and fearful power...",
		TELEPORTATO_RING = "A ring that could focus dimensional energies.",
		TELESTAFF = "It can show me the world.",
		TENT = 
		{
			GENERIC = "I get sort of crazy when I don't sleep.",
			BURNT = "Nothing left to sleep in.",
		},
		SIESTAHUT = 
		{
			GENERIC = "A nice place for an afternoon rest, safely out of the heat.",
			BURNT = "It won't provide much shade now.",
		},
		TENTACLE = "That looks dangerous.",
		TENTACLESPIKE = "It's pointy and slimy.",
		TENTACLESPOTS = "I think these were its genitalia.",
		TENTACLE_PILLAR = "A slimy pole.",
		TENTACLE_PILLAR_HOLE = "Seems stinky, but worth exploring.",
		TENTACLE_PILLAR_ARM = "Little slippery arms.",
		TENTACLE_GARDEN = "Yet another slimy pole.",
		TOPHAT = "What a nice hat.",
		TORCH = "Something to hold back the night.",
		TRANSISTOR = "It's whirring with electricity.",
		TRAP = "I wove it real tight.",
		TRAP_TEETH = "This is a nasty surprise.",
		TRAP_TEETH_MAXWELL = "I'll want to avoid stepping on that!",
		TREASURECHEST = 
		{
			GENERIC = "It's my tickle trunk!",
			BURNT = "That trunk was truncated.",
		},
		TREASURECHEST_TRAP = "How convenient!",
		TREECLUMP = "It's almost like someone is trying to prevent me from going somewhere.",

		TRINKET_1 = "They are all melted together.",
		TRINKET_10 = "I hope I get out of here before I need these.",
		TRINKET_11 = "He whispers beautiful lies to me.",
		TRINKET_12 = "I'm not sure what I should do with a dessicated tentacle.",
		TRINKET_2 = "What's kazoo with you?",
		TRINKET_23 = "Someone lost their words.",
		TRINKET_3 = "The knot is stuck. Forever.",
		TRINKET_4 = "It must be some kind of religious artifact.",
		TRINKET_5 = "Sadly, it's too small for me to escape on.",
		TRINKET_6 = "Their electricity carrying days are over.",
		TRINKET_7 = "I have no time for fun and games!",
		TRINKET_8 = "Great. All of my tub stopping needs are met.",
		TRINKET_9 = "I'm more of a zipper person, myself.",

		BISHOP_CHARGE_HIT = "Ow!",
		TRUNKVEST_SUMMER = "Wilderness casual.",
		TRUNKVEST_WINTER = "Winter survival gear.",
		TRUNK_COOKED = "Somehow even more nasal than before.",
		TRUNK_SUMMER = "A light breezy trunk.",
		TRUNK_WINTER = "A thick, hairy trunk.",
		TUMBLEWEED = "Who knows what that tumbleweed has picked up.",
		TURF_DIRT = "A chunk of ground.",
		TURF_FOREST = "A chunk of ground.",
		TURF_GRASS = "A chunk of ground.",
		TURF_MARSH = "A chunk of ground.",
		TURF_ROAD = "Hastily cobbled stones.",
		TURF_ROCKY = "A chunk of ground.",
		TURF_SAVANNA = "A chunk of ground.",
		TURKEYDINNER = "Mmmm.",
		TWIGS = "It's a bunch of small twigs.",
		UMBRELLA = "This will keep my hair dry, at least.",
		GRASS_UMBRELLA = "This will keep my hair moderately dry, at least.",
		PALMLEAF_UMBRELLA = "My hair looks good wet... it's when it dries that's the problem.",
		UNIMPLEMENTED = "It doesn't look finished! It could be dangerous.",
		WAFFLES = "I'm waffling on whether I should add more syrup.",
		WALL_HAY = 
		{	
			GENERIC = "Hmmmm. I guess that'll have to do.",
			BURNT = "That won't do at all.",
		},
		WALL_HAY_ITEM = "This seems like a bad idea.",
		WALL_STONE = "That's a nice wall.",
		WALL_STONE_ITEM = "They make me feel so safe.",
		WALL_RUINS = "An ancient piece of wall.",
		WALL_RUINS_ITEM = "A solid piece of history.",
		WALL_WOOD = 
		{
			GENERIC = "Pointy!",
			BURNT = "Burnt!",
		},
		WALL_WOOD_ITEM = "Pickets!",
		WALL_MOONROCK = "Spacey and smooth!",
		WALL_MOONROCK_ITEM = "Very light, but surprisingly tough.",
		MOONROCKNUGGET = "That rock came from the moon.",
		ROCK_MOON = "That rock came from the moon.",
		WALRUS = "Walruses are natural predators.",
		WALRUSHAT = "It's covered with walrus hairs.",
		WALRUS_CAMP =
		{
			EMPTY = "Looks like somebody was camping here.",
			GENERIC = "It looks warm and cozy inside.",
		},
		WALRUS_TUSK = "I'm sure I'll find a use for it eventually.",
		WARDROBE = 
		{
			GENERIC = "It holds dark, forbidden secrets...",
            BURNING = "That's burning fast!",
			BURNT = "It's outta style now.",
		},
		WARG = "You might be something to reckon with, big dog.",
		WASPHIVE = "I think those bees are mad.",
		WATERMELON = "Sticky sweet.",
		WATERMELON_COOKED = "Juicy and warm.",
		WATERMELONHAT = "Let the juice run down your face.",
		WETGOOP = "It tastes like nothing.",
		WHIP = "Nothing like loud noises to help keep the peace.",
		WINTERHAT = "It'll be good for when winter comes.",
		WINTEROMETER = 
		{
			GENERIC = "I am one heck of a scientist.",
			BURNT = "Its measuring days are over.",
		},
		WORMHOLE =
		{
			GENERIC = "Soft and undulating.",
			OPEN = "Science compels me to jump in.",
		},
		WORMHOLE_LIMITED = "Guh, that thing looks worse off than usual.",
		ACCOMPLISHMENT_SHRINE = "I want to use it, and I want the world to know that I did.",        
		LIVINGTREE = "Is it watching me?",
		ICESTAFF = "It's cold to the touch.",
		
        FLOTSAM = "If only I had some way of hooking on to it from here.",

        SUNKEN_BOAT = 
        {
            GENERIC = "That fellow looks like he wants to talk.",
            ABANDONED = "This is why I hate the water.",
        },
        SUNKEN_BOAT_BURNT = "It's even less seaworthy than before.",
   		SUNKEN_BOAT_TRINKET_1 = "An instrument of some sort.", --sextant
		SUNKEN_BOAT_TRINKET_2 = "Now all I need is a miniaturization machine!", --toy boat
		SUNKEN_BOAT_TRINKET_3 = "Looks kinda soggy.", --candle
		SUNKEN_BOAT_TRINKET_4 = "Scientific!", --sea worther
		SUNKEN_BOAT_TRINKET_5 = "If only I had another!", --boot

		HOUNDFIRE = "Fire! Fire!",

		--- CAPY DLC ------------------------------------------------------------------------------------------------
		
		STUFFEDEGGPLANT = "I'll be stuffed after eating this!",
		SUNKBOAT = "It's no use to me out there!",
		BANANAPOP = "No, not brain freeze! I need that for science!",
		BISQUE = "Cooking that sure kept me bisque-y!",
		CEVICHE = "Can I get a bigger bowl? This one looks a little shrimpy.",
		SEAFOODGUMBO = "It's a jumbo seafood gumbo.",
		SURFNTURF = "It's perf!",
		SHARKFINSOUP = "It's shark fin-ished!",
		LOBSTERDINNER = "If I eat it in the morning is it still dinner?",
		LOBSTERBISQUE = "Could use more salt, but that's none of my bisque-ness.",
		JELLYOPOP = "Jelly-O pop it right in my mouth!",
		SWEATERVEST = "This vest is dapper as all get-out.",
		REFLECTIVEVEST = "Keep off, evil sun!",
		HAWAIIANSHIRT = "It's not lab safe!",
		TAFFY = "My dentist'd get mad if I ate this... but I don't have one.",

		ANTIVENOM = "Tastes horrible!",
		VENOMGLAND = "Only poison can cure poison.",
		BLOWDART_POISON = "The pointy end goes that way.",
		OBSIDIANMACHETE = "It's hot to the touch.",
		SPEARGUN_POISON = "Poison tipped.",
		OBSIDIANSPEARGUN = "Fire tipped.",
		LUGGAGECHEST = "It looks like a premier steamer trunk.",
		PIRATIHATITATOR =
		{
			GENERIC = "It's twisting my tongue.",
			BURNT = "Fire doesn't really solve naming issues...",
		},
		COFFEEBEANS = "They could use some roasting.",
		COFFEE = "Smells delicious and energizing!",
		COFFEEBEANS_COOKED = "Heat definitely improved them.",
		COFFEEBUSH =
		{
			BARREN = "I think it needs to be fertilized.",
			WITHERED = "Looks malnourished.",
			GENERIC = "This is a plant I could learn to love.",
			PICKED = "Maybe they'll grow back?",
		},
		COFFEEBOT = "It's a coffee maker.",
		MUSSEL = "Could use some flexing.",
		MUSSEL_FARM =
		{
			 GENERIC = "I wonder if they are from Brussels.",
			 STICKPLANTED = "I really stuck it to them."
		},

		MUSSEL_STICK = "I'm really going to stick it to those mussels.",
		LOBSTER = "What a Wascally Wobster.",
		LOBSTERHOLE = "That Wascal is sleeping.",
		SEATRAP = "For the deadliest catch.",
		SAND_CASTLE =
		{
			SAND = "It's a sandcastle, in the sand!",
			GENERIC = "Look what I made!"
		},
		BOATREPAIRKIT = "This will add some float to my boat.",

		BALLPHIN = "Such a round, rubbery fellow.",
		BOATCANNON = "The only thing better than a boat is a boat with a cannon.",
		BOTTLELANTERN = "A bottle full of sunshine.",
		BURIEDTREASURE = "Please be a good treasure!",
		BUSH_VINE =
		{
			BURNING = "Whoops.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "It's all viney!",
		},
		CAPTAINHAT = "The proper boating attire!",
		COCONADE =
		{
			BURNING = "This seems dangerous.",
			GENERIC = "I'll need to light it first.",
		},
		CORAL = "Living building material!",
		CORALREEF = "The coral's formed a reef!",
		CRABHOLE = "They call a hole in the sand their home.",
		CUTLASS = "I hope this sword doesn't start to smell...",
		DUBLOON = "I'm rich!",
		FABRIC = "Soft cloth made from hard roots!",
		FISHINHOLE = "This area seems pretty fishy.",
		GOLDENMACHETE = "Hack in style!",
		JELLYFISH = "This creature is pure science!",
		JELLYFISH_DEAD = "It lived a good life. Maybe.",
		JELLYFISH_COOKED = "It's all wriggly.",
		JELLYFISH_PLANTED = "Science works in mysterious, blobby ways.",
		JELLYJERKY = "I'd be a jerk not to eat this.",

		LIMPETROCK =
		{
			GENERIC = "I could fill a pail with all those snails.",
			PICKED = "I can't fill a pail without snails.",
		},
		LOGRAFT = "This looks... sort of boat-like...",
		MACHETE = "I like the cut of this blade.",
		MESSAGEBOTTLEEMPTY = "Just an empty bottle.",
		MOSQUITO_POISON = "These blasted mosquitoes carry a terrible sickness.",
		OBSIDIANCOCONADE = "It's even bombier!",
		OBSIDIANFIREPIT =
		{
			EMBERS = "I should put something on the fire before it goes out.",
			GENERIC = "This fire pit is a conductor for even more... fire.",
			HIGH = "Good thing it's contained!",
			LOW = "The fire's getting a bit low.",
			NORMAL = "This is my best invention yet.",
			OUT = "At least I can start it up again.",
		},
		OX = "These creatures seem reasonable.",
		PIRATEHAT = "Fit for a cutthroat scallywag. Or me.",
		RAFT = "This looks adequate.",
		ROWBOAT = "It runs on elbow grease.",
		SAIL = "This should really transform my boating experience.",
		SANDBAG_ITEM = "Sand technology, on the go.",
		SANDBAG = "Keeps the water at bay.",
		SEASACK = "I hate when food has that not-so-fresh taste.",
		SEASHELL_BEACHED = "Sea refuse.",
		SEAWEED = "A weed. Of the sea.",

		SEAWEED_PLANTED = "Is that what passes for food around here?",
		SLOTMACHINE = "I suppose I could linger for a moment or two.",
		SNAKE_POISON = "Even worse than a regular snake!",
		SNAKESKIN = "I'm intrigued AND repelled.",
		SNAKESKINHAT = "It should repel the rain from my hair.",
		SOLOFISH = "It has that wet-dog smell.",
		SPEARGUN = "Oh, the science I could get up to with this!",
		SPOILED_FISH = "I'm not terribly curious about the smell.",
		SWORDFISH = "I think this fish evolved to run me through.",
		TRIDENT = "I wonder how old this artifact is?",
		TRINKET_13 = "What is this substance?",
		TRINKET_14 = "This thing gives me the creeps...",
		TRINKET_15 = "Incredible! This guitar has undergone shrinkification!",
		TRINKET_16 = "How did this get all the way out here?",
		TRINKET_17 = "Where's the other one?",
		TRINKET_18 = "A relic of a bygone era!",
		TRINKET_19 = "Clouding of the brain. Never heard of it...",
		TURBINE_BLADES = "Perhaps this powered that beastly storm?",
		TURF_BEACH = "Sandy ground.",
		TURF_JUNGLE = "Very gnarled ground.",
		VOLCANO_ALTAR =
		{
			GENERIC = "It appears to be closed.",
			OPEN = "The altar is open and ready to accept offerings!",
		},
		VOLCANO_ALTAR_BROKEN = "Er, that won't be a problem, will it?",
		WHALE_BLUE = "That whale has emotional issues.",
		WHALE_CARCASS_BLUE = "Gross. I think the bloating has begun.",
		WHALE_CARCASS_WHITE = "Gross. I think the bloating has begun.",

		ARMOR_SNAKESKIN = "How fashionable!",
		CLOTHSAIL = "That wind isn't getting away now!",
		DUG_COFFEEBUSH = "This belongs in the ground!",
		LAVAPOOL = "A bit hot for my tastes.",
		BAMBOO = "Maybe I can bamboozle my enemies with this?",
		AERODYNAMICHAT = "It really cuts through the air!",
		POISONHOLE = "I think I'll stay away from that.",
		BOAT_LANTERN = "This will do wonders for my night vision!",
		DEAD_SWORDFISH = "I better not run with this.",
		LIMPETS = "Maybe starving wouldn't be so bad.",
		OBSIDIANAXE = "A winning combination!",
		COCONUT = 
		{
		    GENERIC = "It requires a large nut hacker.",
		    PLANTED = "It doesn't need my help to grow anymore.",
		},
		COCONUT_COOKED = "Now I just need a cake.",
		BERMUDATRIANGLE = "Gives me an uneasy feeling.",
		SNAKE = "I wonder if it'll sell me some oil?",
		SNAKEOIL = "The label says \"Jay's Wondrous Snake Oil!\"",
		ARMORSEASHELL = "Arts and crafts!",
		SNAKE_FIRE = "Is that snake smoldering?",
		MUSSEL_COOKED = "I cook a mean mussel.",

		PACKIM_FISHBONE = "This seems like something I should carry around.",
		PACKIM = "I bet I could pack'im full of stuff.",

		ARMORLIMESTONE = "I'm sure this will hold up great!",
		TIGERSHARK = "Well that's terrifying.",
		WOODLEGS_KEY1 = "Something, somewhere must be locked.",
		WOODLEGS_KEY2 = "This key probably unlocks something.",
		WOODLEGS_KEY3 = "That's a key.",
		WOODLEGS_CAGE = "That seems like an excessive amount of locks.",
		OBSIDIAN_WORKBENCH = "I feel inspired.",

		NEEDLESPEAR = "I'm glad I didn't step on this.",
		LIMESTONE = "Could be a useful building material.",
		DRAGOON = "You're a quick one, aren't you?",

		ICEMAKER = 
		{
			OUT = "It needs more fuel.",
			VERYLOW = "I can hear it sputtering.",
			LOW = "It seems to be slowing down.",
			NORMAL = "It's putting along.",
			HIGH = "It's running great!",
		},

		DUG_BAMBOOTREE = "I need to plant this.",
		BAMBOOTREE =
		{
			BURNING = "Bye bye, bamboo.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "Looks pretty sturdy.",
		},
		JUNGLETREE =
		{
			BURNING = "What a waste of wood.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "That tree needs a hair cut.",
		},
		SHARK_GILLS = "I wish I had gills.",
		TREEGUARD = "Someone gimme a hand with this palm!",
		OBSIDIAN = "It's a fire rock.",
		BABYOX = "It's a tiny meat beast.",
		STUNGRAY = "I think I'll keep my distance.",
		SHARK_FIN = "A sleek fin.",
		FROG_POISON = "It looks meaner than usual.",
		ARMOUREDBOAT = "That is one durable boat.",
		ARMOROBSIDIAN = "I'm a genius.",
		BIOLUMINESCENCE = "These make a soothing glow.",
		SPEAR_POISON = "Now it's extra deadly.",
		SPEAR_OBSIDIAN = "This will leave a mark.",
		SNAKEDEN =
		{
			BURNING = "Whoops.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "It's all viney!",
		},
		TOUCAN = "I tou-can't catch him.",
		MESSAGEBOTTLE = "Someone wrote me a note!",
		SAND = "A handy pile of pocket sand.",
		SANDHILL = "You better stay out of my shoes.",
		PEACOCK = "Nothing more than a dressed up thief.",
		VINE = "Maybe I can tie stuff up with this.",
		SUPERTELESCOPE = "I can see forever!",
		SEAGULL = "Shoo! Find some other land!",
		SEAGULL_WATER = "Shoo! Find some other water!",
		PARROT = "I find myself fresh out of crackers.",
		ARMOR_LIFEJACKET = "Keeps me afloat, without my boat!",
		WHALE_BUBBLES = "Something's underwater here.",
		EARRING = "The fewer holes in my body, the better.",
		ARMOR_WINDBREAKER = "The wind doesn't stand a chance!",
		SEAWEED_COOKED = "Crispy.",
		CARGOBOAT = "It has room for all my stuff!",
		GASHAT = "Sucks all the stink out.",
		ELEPHANTCACTUS = "Yikes! I could poke an eye out!",
		DUG_ELEPHANTCACTUS = "A portable poker plant.",
		ELEPHANTCACTUS_ACTIVE = "That cactus seems abnormally pokey.",
		ELEPHANTCACTUS_STUMP = "It'll sprout pokers again eventually.",
		FEATHERSAIL = "It's feather-light!",
		WALL_LIMESTONE_ITEM = "These would do more good if I placed them.",
		JUNGLETREESEED =
        {
            GENERIC = "I can hear the hissing of tiny snakes.",
            PLANTED = "It will grow into a nice jungle tree.",
        },
		VOLCANO = "My scientific know-how tells me that's a perfectly safe mountain!",
		IRONWIND = "This is how a scientist should travel.",
		SEAWEED_DRIED = "Salty!",
		TELESCOPE = "I spy with my little eye...",
		
		DOYDOY = "I feel oddly protective of this dumb bird.",
		DOYDOYBABY = "What a cute little, uh, thing.",
		DOYDOYEGG = "Maybe I should have let it hatch.",
		DOYDOYEGG_CRACKED = "Oh well. I'm sure there are lots more!",
		DOYDOYFEATHER = "Soft AND endangered!",

		PALMTREE =
		{
			BURNING = "What a waste of wood.",
			BURNT = "I feel like I could have prevented that.",
			CHOPPED = "Take that, nature!",
			GENERIC = "How tropical.",
		},
		PALMLEAF = "I'm fond of these fronds.",
		CHIMINEA = "Take that, wind!",
		DOUBLE_UMBRELLAHAT = "The second umbrella keeps the first umbrella dry.",
		CRAB = 
		{
			GENERIC = "Don't get snappy with me, mister.",
			HIDDEN = "I wonder where that crabbit went?",
		},
		TRAWLNET = "Nothing but net.",
		TRAWLNETDROPPED = 
		{
			SOON = "It is definitely sinking.",
			SOONISH = "I think it's sinking.",
			GENERIC = "It's bulging with potential!",
		},
		VOLCANO_EXIT = "There's a cool breeze blowing in from outside.",
		SHARX = "These things sure are persistent.",
		SEASHELL = "Maybe I could sell these.",
		WHALE_BUBBLES = "Something down there has bad breath.",
		MAGMAROCK = "I can dig it.",
		MAGMAROCK_GOLD = "I see a golden opportunity.",
		CORAL_BRAIN_ROCK = "I wonder what it's plotting...",
		CORAL_BRAIN = "Food for thought.",
		SHARKITTEN = "You've got to be kitten me!",
		SHARKITTENSPAWNER = 
		{
			GENERIC = "Is that sand pile purring?",
			INACTIVE = "That is a rather large pile of sand.",
		},
		LIVINGJUNGLETREE = "Just like any other tree.",
		WALLYINTRO_DEBRIS = "Part of a wrecked ship.",
		MERMFISHER = "You better not try anything fishy.",
        PRIMEAPE = "Those things are going to be the end of me.",
        PRIMEAPEBARREL = "Here be evil.",
        REDBARREL = "How original.",
        PORTAL_SHIPWRECKED = "It's broken.",
		MARSH_PLANT_TROPICAL = "Planty.",
		TELEPORTATO_SW_POTATO = "Seems like it was made with a purpose in mind.",
		PIKE_SKULL = "Ouch.",
		PALMLEAF_HUT = "Shade, sweet shade.",
		FISH_RAW_SMALL_COOKED = "A small bit of cooked fish.",
		LOBSTER_DEAD = "You should cook up nicely.",
		MERMHOUSE_FISHER = "Doesn't smell very good.",
		WILDBORE = "Looks aggressive.",
		PIRATEPACK = "I can keep my booty in here.",
		TUNACAN = "Where did this can come from?",
		MOSQUITOSACK_YELLOW = "Part of a yellow mosquito.",
		SANDBAGSMALL = "This should keep the water out.",
		FLUP = "Leave me alone!",
		OCTOPUSKING = "I'm a sucker for this guy.",
		OCTOPUSCHEST = "I hope that thing is waterproof.",
		GRASS_WATER = "I hope you're thirsty, grass.",
		WILDBOREHOUSE = "What a bore-ing house.",
		FISH_RAW_SMALL = "A small bit of fish.",
		TURF_SWAMP = "Swampy turf.",
		FLAMEGEYSER = "Maybe I should stand back.",
		KNIGHTBOAT = "Get off the waterway, you maniac!",
		MANGROVETREE_BURNT = "I wonder how that happened.",
		TIDAL_PLANT = "Look. A plant.",
		WALL_LIMESTONE = "Sturdy.",
		FISH_RAW = "A chunk of fish meat.",
		LOBSTER_DEAD_COOKED = "I can't wait to eat you.",
		BLUBBERSUIT = "Well, it's something.",
		BLOWDART_FLUP = "Eye see.",
		TURF_MEADOW = "Meadow-y turf.",
		TURF_VOLCANO = "Volcano-y turf.",
		SWEET_POTATO = "Looks yammy!",
		SWEET_POTATO_COOKED = "Looks even yammier!",
		SWEET_POTATO_PLANTED = "That's an odd looking carrot.",
		SWEET_POTATO_SEEDS = "My very own plant eggs.",
		BLUBBER = "Squishy.",
		TELEPORTATO_SW_RING = "Looks like I could use this.",
		TELEPORTATO_SW_BOX = "It looks like a part for something.",
		TELEPORTATO_SW_CRANK = "I wonder what this is used for.",
		TELEPORTATO_SW_BASE = "I think it's missing some parts.",
		VOLCANOSTAFF = "The label says \"Keep out of reach of children.\"",
		THATCHPACK = "I call it a thatchel.",
		TURF_DESERTDIRT = "Dirty turf.",
		SHARK_TEETHHAT = "What a dangerous looking hat.",
		TURF_ASH = "Ashy turf.",
		TURF_FUNGUS_GREEN = "Green fungus-y turf.",
		BOAT_TORCH = "This'll keep my hands free.",
		MANGROVETREE = "I wonder if it's getting enough water?",
		HAIL_ICE = "Chilling.",
		TROPICAL_FISH = "What a tropical looking fish.",
		TIDALPOOL = "A pool, left by the tides.",
		WHALE_WHITE = "Looks like a fighter.",
		VOLCANO_SHRUB = "You look ashen.",
		ROCK_OBSIDIAN = "Blast it! It won't be mined!",
		ROCK_CHARCOAL = "Would need an awfully big stocking for that.",
		DRAGOONDEN = "Even goons gotta sleep.",
		WILBUR_UNLOCK = "He looks kind of regal.",
		WILBUR_CROWN = "It's oddly monkey-sized.",
		TWISTER = "I thought it was strangely windy around here.",
		TWISTER_SEAL = "D'awww.",
		MAGIC_SEAL = "This is a powerful artifact.",
		SAIL_STICK = "There must be a scientific explanation for this.",
		WIND_CONCH = "I can hear the wind trapped within.",
		DRAGOONEGG = "Do I hear cracking?",
		BUOY = "Awww yaaaaa buoy!", 
		TURF_SNAKESKINFLOOR = "Sssstylish ssssstatement.",
        DOYDOYNEST = "It's for doydoy eggs, dummy.",
		ARMORCACTUS = "The best defense is a good offense.",
		BIGFISHINGROD = "To catch a big fish, you need a big rod.",
		BRAINJELLYHAT = "Two brains means double the ideas!",
		COCONUT_HALVED = "When I click them together, they make horsey sounds.",
		CRATE = "There must be a way to open it.",
		DEPLETED_BAMBOOTREE = "Will it grow again?",
		DEPLETED_BUSH_VINE = "One day it may return.",
		DEPLETED_GRASS_WATER = "Farewell, sweet plant.",
		DOYDOYEGG_COOKED = "A controlled chemical reaction has made this egg matter more nutritious.",
		DRAGOONHEART = "Where the dragoon once stored its feelings.",
		DRAGOONSPIT = "It's SPITacularly disgusting!",
		DUG_BUSH_VINE = "I suppose I should pick it up.",
		FRESHFRUITCREPES = "Sugary fruit! Part of a balanced breakfast.",
		KRAKEN = "Now's not the time for me to be Quacken wise!",
		KRAKENCHEST = "To the victor, the spoils.",
		KRAKEN_TENTACLE = "A beast that never sleeps.",
		MAGMAROCK_FULL = "I can dig it.",
		MAGMAROCK_GOLD_FULL = "I see a golden opportunity.",
		MONKEYBALL = "I have a strange desire to name it after myself.",
		MONSTERTARTARE = "There's got to be something else to eat around here.",
		MUSSELBOUILLABAISE = "Imagine the experiments I could run on it!",
		MYSTERYMEAT = "I'm not dissecting that.",
		OXHAT = "Nice and dry. This helmet will protect me from the elements.",
		OX_FLUTE = "Is it dripping...?",
		OX_HORN = "I grabbed the ox by the horn.",
		PARROT_PIRATE = "I try not to eat anything with a name.",
		PEG_LEG = "I can perform amputations if anyone'd like to wear it for real.",
		PIRATEGHOST = "He met a terrible end. I will too if I don't get out of here.",
		SANDBAGSMALL_ITEM = "A bag full of sand. Does science know no bounds?",
		SHADOWSKITTISH_WATER = "Yikes!",
		SHIPWRECKED_ENTRANCE = "Ahoy!",
		SHIPWRECKED_EXIT = "And so, I sail away into the horizon!",
		SNAKESKINSAIL = "Scale it and sail it!",
		SPEAR_LAUNCHER = "Science takes care of me.",
		SWEETPOTATOSOUFFLE = "Sweet potato souffles are a rising trend.",
		SWIMMINGHORROR = "Yikes! Get me back to land!",
		TIGEREYE = "More eyes means better sight... right?",
		TRINKET_20 = "I'm not sure what it is, but it makes me feel smarter!",
		TRINKET_21 = "I ought to measure it to ensure it's to scale.",
		TRINKET_22 = "I'm sure someone would like this.",
		TURF_FUNGUS_RED = "Fungal red floor.",
		TURF_MAGMAFIELD = "Lava-y floor.",
		TURF_TIDALMARSH = "Marsh-y floor.",
		VOLCANO_ALTAR_TOWER = "How scary!",
		WATERYGRAVE = "Sure, I could fish it out of there. But should I?",
		WHALE_TRACK = "Whale, ho!",
		WILDBOREHEAD = "It smells as bad as it looks.",
		WOODLEGSBOAT = "A vessel fit for a scallywag.",
		WOODLEGSHAT = "Does it make me look scurvy... I mean scary!?",
		WOODLEGSSAIL = "The quintessential pirate sail.",
		WRECK = "Poor little boat.",
		INVENTORYGRAVE = "There was someone here before me!",
        INVENTORYMOUND = "There was someone here before me!",
		LIMPETS_COOKED = "Escargotcha!",
		RAWLING = "It's my buddy!",
		CALIFORNIAROLL = "But I don't have chopsticks.",



	--- 5C DLC ------------------------------------------------------------------------------------------------

        ENCRUSTEDBOAT = "A mere shell of a ship.",
        BABYOX = "Smaller, but just as smelly.",
        BALLPHINHOUSE = "The place where the ballphins roost.",
        DORSALFIN = "Guess that house is FINished.",
        NUBBIN = "I want nubbin to do with that.",
        CORALLARVE = "That's a baby coral reef.",
        RAINBOWJELLYFISH = "That's a lot of tendrils.",
        RAINBOWJELLYFISH_PLANTED = "A colorful blob of science.",
        RAINBOWJELLYFISH_DEAD = "An electric shock will not revive it. I tried.",
        RAINBOWJELLYFISH_COOKED = "A colorful snack!",
        RAINBOWJELLYJERKY = "All the water's dried right out of it.",
        WALL_ENFORCEDLIMESTONE = "I shelled out for the good stuff.",
        WALL_ENFORCEDLIMESTONE_ITEM = "I have to build it in the water.",
        CROCODOG = "I'd rather stay away from the business end of that jerk.",
        POISONCROCODOG = "That looks like an experiment gone wrong.",
        WATERCROCODOG = "It's a dog-eat-me world out here.",
        QUACKENBEAK = "I'd say I made the pecking order around here quite clear.",
        QUACKERINGRAM = "Does my ingenuity know no bounds?!",
    
    --- DLC ------------------------------------------------------------------------------------------------    

        CAVIAR = "I never had it before I came here.",
        CORMORANT = "I bet it eats a lot of fish.",

        FISH3 = "Surf and turf, hold the turf.",
        FISH4 = "This one's extra water repellent.",
        FISH5 = "It looks like a fish, but it feels clammy.",

        FISH3_COOKED = "That fish is fin-ished.",
        FISH4_COOKED = "Gilled to perfection.",
        FISH5_COOKED = "Fried fry.",

        FISH_FARM = 
        {
        	EMPTY = "I need to find some fish eggs for this.",
			STOCKED = "The fish babies haven't hatched yet.",
			ONEFISH = "There's a fish!",
			TWOFISH = "The fish are still multiplying.",
			REDFISH = "This has been a successful fish experiment!",
			BLUEFISH  = "I'd better start harvesting these!",
        },

        ROE = "Fish babies.",
        ROE_COOKED = "Roe, sunny side up.",
        
        SEA_YARD =
       	{
            ON = "For keeping my ships in tiptop shape!",
            OFF = "It's not in shipshape right now.",
            LOWFUEL = "I'll need to refill it soon.",
        },

        SEA_CHIMINEA = 
        {
            EMBERS = "Better put something on it before it goes out.",
            GENERIC = "Science protect my fires out here.",
            HIGH = "I'm glad we're surrounded by water.",
            LOW = "It's getting low.",
            NORMAL = "As cozy as it gets.",
            OUT = "It finally went out.",
        }, 

        TAR = "Do I have to hold it with my bare hands?",
        TAR_EXTRACTOR =
        {
            ON = "It's running smoothly.",
            OFF = "I have to turn it on.",
            LOWFUEL = "I need to refuel that.",
        },
        TAR_POOL = "There must be a way to get that tar out.",

        TARLAMP = "That's a real slick lamp.",
        TARSUIT = "I'll pitch a fit if I have to wear that.",
        TAR_TRAP = "Who's cleaning that up, I wonder?",

        TROPICALBOUILLABAISSE = "I seasoned it with a dash of science.",

        RESEARCHLAB5 = "For sea science!",
        WATERCHEST = "Watertight, just like all my theories.",		
	},
	DESCRIBE_GENERIC = "It's a... thing.",
	DESCRIBE_TOODARK = "It's too dark to see!",
	DESCRIBE_SMOLDERING = "That thing's about to catch fire.",
	EAT_FOOD =
	{
		TALLBIRDEGG_CRACKED = "Mmm. Beaky.",
	},
}
