require("stategraphs/commonstates")

local actionhandlers =
{    

}

local events = 
{
	
}

local states =
{
    State{
        name = "idle",
        tags = {"idle", "canrotate"},
        onenter = function(inst, pushanim)    
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("spin_loop", true)
        end,
    },


 
	
---kaisih
--跳跃定义数值
--local JUMP_SPEED = 75
--local JUMP_LAND_OFFSET = 3
	
--跳跃动画
    State{
        name = "tosojump",
        tags = {"busy", "specialattack"},

        onenter = function(inst)
		    --防止被打断
		    --inst.missatk = true
			--inst.skillon = false
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("spin_loop")
            inst.AnimState:PushAnimation("spin_loop", true)
        end,

        timeline =
        {
            -- TimeEvent(0*FRAMES, function(inst)
            --     inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
            -- end),

            TimeEvent(23*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/jump_attack")
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/roar")
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/launch_land")
	            --inst.components.locomotor.disable = true
	            inst.Physics:SetMotorVelOverride(0,75,0)
    		end),

            TimeEvent(38*FRAMES, function(inst)
                --local tar = inst:GetTarget()

                --if tar and not inst:GroundTypesMatch(tar) then
                    --inst:MakeWater() --GoToWaterState
                --end

                inst.sg:GoToState("tosofallwarn")
            end)
        },
    },


    State{
        name = "tosofallwarn",
        tags = {"busy", "specialattack"},

        onenter = function(inst)
            inst.sg:SetTimeout(34*FRAMES)

            inst.Physics:Stop()

            --local tar = inst:GetTarget()
            --local pos = tar or inst:GetPosition()

            --pos.y = 45
            --inst.Transform:SetPosition(inst:GetPosition():Get())

            --local shadow = SpawnPrefab("tigersharkshadow")
            --shadow:Ground_Fall()
            --local heading = 50--TheCamera:GetHeading()
            --local rotation = 180 - heading

            --if inst.AnimState:GetCurrentFacing() == FACING_LEFT then
                --rotation = rotation + 180
            --end

            --if rotation < 0 then
                --rotation = rotation + 360
            --end

            --shadow.Transform:SetRotation(rotation)
            --local x,y,z = inst:GetPosition():Get()
            --shadow.Transform:SetPosition(x,0,z)
        end,

        ontimeout = function(inst)
            inst:Show()

            --if inst:GetIsOnWater() then
                --inst:MakeWater()
                --local pos = inst:GetPosition()
                --pos.y = 45
                --inst.Transform:SetPosition(inst:GetPosition():Get())
            --end

            inst.sg:GoToState("tosofall")
        end,
    }
	
    State{
        name = "tosofall",
        tags = {"busy", "specialattack"},

        onenter = function(inst)
            --ChangeToCharacterPhysics(inst)
	        --inst.components.locomotor.disable = true
            inst.Physics:SetMotorVel(0,-75,0)
            inst.AnimState:PlayAnimation("spin_loop", true)
            --inst.Physics:SetCollides(false)
            inst.sg:SetTimeout(75/45 + 0.2)
            inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/dive_attack")
        end,

        timeline =
        {
            TimeEvent(20*FRAMES, function(inst) inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/roar") end)
        },

        ontimeout = function(inst)
            local pt = Point(inst.Transform:GetWorldPosition())
            local vx, vy, vz = inst.Physics:GetMotorVel()
            if pt.y <= .1 then
                pt.y = 0
                inst.Physics:Stop()
                inst.Physics:Teleport(pt.x,pt.y,pt.z)
                --inst.CanFly = false
                --inst.Physics:SetCollides(true)
                inst.sg:GoToState("tosofallpost")
            end
        end,

        onupdate = function(inst)
            inst.Physics:SetMotorVel(0,-75,0)
            local pt = Point(inst.Transform:GetWorldPosition())
            if pt.y <= .1 then
                pt.y = 0
                inst.Physics:Stop()
                inst.Physics:Teleport(pt.x,pt.y,pt.z)
                --inst.CanFly = false
                --inst.Physics:SetCollides(true)
                inst.sg:GoToState("tosofallpost")
            end
        end,
    }
	
    State{
        name = "tosofallpost",
        tags = {"busy", "specialattack"},

        onenter = function(inst)
		    --加入位置

		    local x,y,z = inst.Transform:GetWorldPosition()
            inst.Physics:Stop()
            --inst.components.locomotor.disable = false
            inst.AnimState:PlayAnimation("spin_loop")
            --inst.components.groundpounder:GroundPound()

		--加入一个特效	
		local fxhuo = SpawnPrefab("dilie_toso")
		fxhuo.Transform:SetScale(1.4, 1.4, 1.4)
		fxhuo.Transform:SetPosition(inst:GetPosition():Get())	
			--替换为自己的特效
			local fx = SpawnPrefab("groundpoundring_fx") --触发特效
		    local scale = 0.8
		    fx.Transform:SetScale(scale,scale,scale)
		    fx.Transform:SetPosition(x,y,z)
            inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/tiger_shark/land_explode")
			--加入雷电
			SpawnPrefab("lightning").Transform:SetPosition(inst:GetPosition():Get())
--伤害程序
	--local weapon =  inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
	--local weapondmg = 20
	--if weapon and weapon.components.weapon.damage then
		--weapondmg = weapon.components.weapon.damage
	--end
	local pt = Vector3(inst.Transform:GetWorldPosition())
	local plus_dmg = 100
    local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, 20)
    for k,v in pairs(ents) do
	if v.components.combat and v.components.health and not v.components.health:IsDead() and not v:HasTag("ssword") and not v:HasTag("myfriend") and not (v.components.inventoryitem and v.components.inventoryitem.owner) and not v:HasTag("wall") and not v:HasTag("companion") and not v:HasTag("toso_helper") then

		if v.components.health and not (v.components.inventoryitem and v.components.inventoryitem.owner) then 
		
	local x, y, z = v.Transform:GetWorldPosition()
	local fx = SpawnPrefab("moose_nest_fx")
	fx.Transform:SetPosition(x, y, z)
		--if v.components.freezable and v.components.freezable.coldness > 0 then
        v.components.health:DoDelta(-100)
		end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.hit and not v.components.health:IsDead() then v.sg:GoToState("hit") end
		if v.sg and v.sg.sg and v.sg.sg.states and v.sg.sg.states.idle and not v.components.health:IsDead() then v.sg:GoToState("idle") end
		
		
--冰冻程序								
	if v.components.sleeper and v.components.sleeper:IsAsleep() then
        v.components.sleeper:WakeUp()
    end
    if v.components.burnable then
        if v.components.burnable:IsBurning() then
            v.components.burnable:Extinguish()
        elseif v.components.burnable:IsSmoldering() then
            v.components.burnable:SmotherSmolder()
        end
    end

    --if v.components.combat then
        --v.components.combat:SuggestTarget(attacker)
    --end

    --if v.sg and not v.sg:HasStateTag("frozen") then
        --v:PushEvent("attacked", {attacker = attacker, damage = 0})
    --end
	--冰		 
	if not inst or not v then 
	return end
	
    local numFX = math.random(5,10)
    local pos = inst:GetPosition()
    local targetPos = v:GetPosition()
    local vec = targetPos - pos
    vec = vec:Normalize()
    local dist = pos:Dist(targetPos)
    local angle = inst:GetAngleToPoint(targetPos:Get())

    for i = 1, numFX do
        inst:DoTaskInTime(math.random() * 0.25, function(inst)
            local prefab = "icespike_fx_"..math.random(1,4)
            local fx = SpawnPrefab(prefab)
            if fx then
                local x = 0.5
                local z = 0.5
                local offset = (vec * math.random(dist * 0.25, dist)) + Vector3(x,0,z)
                fx.Transform:SetPosition((offset+pos):Get())
            end
        end)
    end
	
	--v.components.health:DoDelta(- 10 - inst.level)
if not v:HasTag("ant") and not v:HasTag("insect") then	
    if v.components.freezable then
        --v.components.freezable:AddColdness(3)
        --v .components.freezable:SpawnShatterFX()
    end
end
--冰冻程序结束	

		
end
end

--伤害程序结束
        end,

        onexit = function(inst)
            --inst.components.health:SetInvincible(false)
            inst:Show()
			--防止被打断

		    inst:DoTaskInTime(1, function()
		    --inst.missatk = false	
		    end)
		    --inst.skillon = true
        end,

        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    }
----


	
}

return StateGraph("SGarm_ss", states, events, "idle", actionhandlers)